#!/home/jtn/epd-5.1.1-rh3-x86/bin/python2.5

##from ira5 import SpinSystem
from ira import *
import numpy
from numpy import log, exp, sqrt, take, hstack, vstack, ones, zeros, empty,\
argmax, argmin, arange, linspace, pi, array, transpose, cos, sin, prod,\
average, sum, dot, cumsum, amin, clip
from numpy.random import normal as randNorm
from numpy.random import rand
##from scipy.optimize.anneal import anneal
from random import normalvariate
from random import randint
from random import choice as randchoice
import string, os, math
from util import *
##from jakob.protstat import Parser
##from pylab import show, scatter, plot, clf, contour, imshow, rot90, subplot, title, hist, cm
##import pylab
##import scipy.optimize.optimize as opt
import matplotlib
matplotlib.use('Agg')
from matplotlib.pyplot import show, hist, scatter, clf
import time
import sys
import operator
aa31dict={'CYS': 'C', 'GLN': 'Q', 'ILE': 'I', 'SER': 'S', 'VAL': 'V', 'MET': 'M', 'ASN': 'N', 'PRO': 'P', 'LYS': 'K', 'THR': 'T', 'PHE': 'F', 'ALA': 'A', 'HIS': 'H', 'GLY': 'G', 'ASP': 'D', 'LEU': 'L', 'ARG': 'R', 'TRP': 'W', 'GLU': 'E', 'TYR': 'Y'}
aa13dict={'A': 'ALA', 'C': 'CYS', 'E': 'GLU', 'D': 'ASP', 'G': 'GLY', 'F': 'PHE', 'I': 'ILE', 'H': 'HIS', 'K': 'LYS', 'M': 'MET', 'L': 'LEU', 'N': 'ASN', 'Q': 'GLN', 'P': 'PRO', 'S': 'SER', 'R': 'ARG', 'T': 'THR', 'W': 'TRP', 'V': 'VAL', 'Y': 'TYR'}

def analexplst(explst):
    allmult=[];singles=[]
    hascb=False
    for i,exp0 in enumerate(explst):
	hasmult = (None in exp0.atnames)
	hasspec = (0 in exp0.multi)
	if not hasspec:allmult.append(i)
	if not hasmult:singles.append(i)
	if 'CB' in exp0.atnames:hascb=True
    print singles,allmult
    global SINGLES 
    global ALLMULT 
    global HASCB 
    SINGLES=singles
    ALLMULT=allmult
    HASCB=hascb

myexplst=read_dba('newexplst.pck')
UNCERTAINTY=myexplst[0].lineWidth
analexplst(myexplst)

def clipspec(x):
    if x<0.1:return 0.1
    elif x>1.0:return 1.0
    return x

def getentrop2(es):
    eners=array(es)[:,1]
    ps=exp(-eners)
    ps/=sum(ps)
    es1=-log(ps)
    return sum(ps*es1)

def getentrop3(es):
    ps=exp(-es)
    ps/=sum(ps)
    es1=-log(ps)
    return sum(ps*es1)

def getentrop3b(es0):
    ##es=array([x for x in es0 if x<30.0])
    es=clip(array(es0),-99.0,30.0)
    ps=exp(-es)
    ps/=sum(ps)
    es1=-log(ps)
    return sum(ps*es1),ps

def getentrop4(ps):
    es=-log(ps)
    return sum(ps*es)

def getentrop5(ps):
    ps/=sum(ps)
    es=-log(ps)
    return sum(ps*es)

def getentrop4b(ps0):
    ps=array([p for p in ps0 if p>0.0])
    es=-log(ps)
    return sum(ps*es)


class _Atom(tuple):#asuming one chain!

    pass


def getrandomcoils():
    buf=initfil2('randcoilCenter.txt')
    dct={}
    for lin in buf[1:]:
      aa=lin[0]
      dct[aa]={}
      shifts=[eval(x) for x in lin[1:]]
      for i,atn in enumerate(['CA','CB','C','HA','H','N']):
        ##if shifts[i]>0.0:
          dct[aa][atn]=shifts[i]
    return dct

def getsep(x,y):
    for i,t in enumerate(y):
	if x<t:return i
    return len(y)

def getener(tup,dct,col):
    csepxvals=[(-0.8,0.6),(-1.0,0.7),(-3.5,3.5),(-3.0,3.0)]
    s0=getsep(tup[0],csepxvals[col])
    s1=getsep(tup[2],csepxvals[col])
    N,numvals,vals0,wid,eners=dct[(s0,s1)]
    if vals0==None:return 19.999
    i=int((tup[1]-vals0)/wid)
    ##print s0,s1,i,N##,eners
    if i<0 or i>=numvals:return 10.0
    return eners[i]


class ProbabilitySelector:

    def selectpartner(self,its,doexp=True):
	es=array(its)[:,0]
	##ps=exp(-array(es))
	if doexp:ps=exp(-es)
	else:ps=es
	psc=cumsum(ps/sum(ps))
	ptest=rand()
	for i in range(len(es)):
	  if ptest<psc[i]:return i,psc[i],its[i][1],its[i][0]
	print es
	print psc

    def selectpartner2(self,its,doexp=True):##,scale=1.0):
	es=array(its)[:,0]##*scale
	##ps=exp(-array(es))
	if doexp:ps=exp(-es)
	else:ps=es
	nps=ps/sum(ps)#normalized
	psc=cumsum(nps)
	ptest=rand()
	for i in range(len(es)):
	  if ptest<psc[i]:return i,psc[i],its[i][1],its[i][0],nps[i]
	print es
	print psc

    def pselectpartner(self,its):
	ps=array([it[-1] for it in its]).astype('f')
	ps/=sum(ps)
	psc=cumsum(ps)
	ptest=rand()
	for i in range(len(ps)):
	  if ptest<psc[i]:return i,psc[i],its[i][-1],its[i][0]
	  ##return                   i,psc[i],its[i][1],its[i][0]
      
    def pselectpartner_rev(self,its):
	##ps=array([it[-1] for it in its]).astype('f')
	ps=array([-it[-1] for it in its]).astype('f')
	ps/=sum(ps)
	psc=cumsum(ps)
	ptest=rand()
	for i in range(len(ps)):
	  if ptest<psc[i]:return i,psc[i],its[i][-1],its[i][0]

    def pselectpartner2(self,ps):
	psc=cumsum(ps)
	ptest=rand()
	for i in range(len(ps)):
	  if ptest<psc[i]:return i,psc[i],ps[i]


class BestSelector:

    def __init__(self,scale=50.0):
	##print 'initializing BestSelector with scale',scale
	self.scale=scale

    def selectpartner(self,its,minfac=90.0):
	fac=max(0.5,len(its)/self.scale)
	fac=min(minfac,fac)
	ind0=int(abs(normalvariate(0,1))*fac)
	ind0=min(len(its)-1,ind0)
	return ind0,exp(-its[ind0][0]),its[ind0][1],its[ind0][0]
	#allways gets the same result with ind0=0 - for debugging only


class DummyPatch:

    def __init__(self,aty):
	self.assigned_type=aty


class AtomAssignment(list):

    def __init__(self,shlst,reflst,axlst,atnord,ssy):
	tup=(shlst,reflst,None,[],axlst)
	list.__init__(self,tup)
	self.shlst =shlst
	self.reflst=reflst
	self.axlst =axlst
	self.atnord=atnord#parrent (order,atom) key in ssy
	self.ssy=ssy#parrent spin system object

    def show(self):
	#showatas
	stats=self[2]
	flag =self[3]
	if flag=='w' and stats[2]>1:flag='m'
	if stats<>None and stats[0]<>None:#can be NaN?#need to be float!
	  ##print tuple(list(self.atnord)+stats)
	  print '%4s %4s %7.3f %7.4f %1d'%tuple(list(self.atnord)+stats),flag,##self[1],
	  if len(self)==6:print '!!',self[5]
	  else:print

    def show_hist(self,resi,resshifts,bw=0.10,doshow=False):
	shs=self[0]
	sh0,sh1=min(shs),max(shs)
	shstd=std(shs)
	shdiff=-1.0;pac=9.99
	atn=self.atnord[1]
	if shstd<bw:
	 if resshifts<>None and atn in resshifts:
	  print self.atnord,shstd,0.00
	  shref=resshifts[atn][0]
	  maxsh=average(shs)
	  shdiff=abs(shref-maxsh)
	  pac=sum(abs(array(shs)-shref)<0.55)*1.0/len(shs)
	  print 'cmpvals:',resi,atn,shref,maxsh,shdiff,pac,0.0,bw,len(shs)
	  return 0.0,shdiff,pac
	 else:
	  print 'NOTE: A-M: (no manual ass.)',resi,atn,shstd,len(shs)
	  return 0.0,None,None
	if len(shs)>1:
	 stdsh=std(shs)
	 data=hist(shs,arange(sh0,sh1+bw,bw),normed=True,alpha=0.5)
	 fracs=data[0]*bw
	 entrop=getentrop4b(fracs)
	 ind=numpy.argmax(fracs)
	 maxsh=sh0+ind*bw+0.5*bw
	else:
	 maxsh=shs[0]
	 entrop=3.0#OK?
	if resshifts<>None and atn in resshifts:
	 shref=resshifts[atn][0]
	 shdiff=abs(shref-maxsh)
	 pac=sum(abs(array(shs)-shref)<0.55)*1.0/len(shs)
	 print 'cmpvals:',resi,atn,shref,maxsh,shdiff,pac,entrop,stdsh,len(shs)
	 if doshow:
	  scatter([shref],[0.0],c='r',s=500,faceted=False,alpha=0.75)
	  scatter([maxsh],[0.0],c='g',s=500,faceted=False,alpha=0.75)
	  show()
	 else:clf()
	else:
	 shdiff=None;pac=None
	##print fracs
	print self.atnord,shstd,entrop
	return entrop,shdiff,pac

    def set_stats(self):
	lst=self[0]
	self[2]=[average(lst),std(lst),len(lst)]

    def add(self,other):
	for i in [0,1,4]:
	  self[i]+=other[i]
	self.set_stats()

    def get_espin(self,lw):
	stats=self[2]
	toti=0.0
	if stats[2]>1:
	  ##toti+=((stats[1]**2)/stats[2])
	  ##toti+=min(lw**2,((stats[1]**2)/stats[2]))
	  ##toti+=min(lw**2,((stats[1]**2)*stats[2]))
	  toti+=min(5.0*(lw**2),stats[1]**2)
	  ##if stats[1]/lw<5.0: toti+=stats[1]**2
	  ##else: toti+=((lw**2)*100.0)
	  ##toti+=(stats[1]**2)
	##else: toti+=(lw**2)
	else: toti+=(1.0*(lw**2))
	return toti/(lw**2)

    def merge_atas(self,other,lw=UNCERTAINTY):
	if not isinstance(other,MultiAtomAssignment):
	  print 'merging atas',self.atnord,other.atnord,self[2][0],other[2][0]
	  print 'simple merging'
	  self.add(other)
	else:
	 print 'ambigous merging!',self.atnord,other.atnord,self[2][0]
	 diffs2=[((self[2][0]-atas[2][0])/lw)**2 for atas in other]
	 if len(diffs2)>0:
	  its=[(i,diffs2[i]) for i in range(len(diffs2))];its.sort(lambda x,y: cmp(y[-1],x[-1]))
	  pselec=ProbabilitySelector()
	  n,cprobt,probt,i=pselec.pselectpartner(its)
	  oatas=other[i]
	  self.add(oatas)
	  #we dont care about other - in particular dont delete other[j] for j<>i

    def get_refs(self):
	return set(self[1][:])

    def compare_values(self,other,minstd=0.15,refdev=0.25):
	valc,stdc,numc=self[2]
	if stdc<=0.001:stdc=refdev
	else:stdc=max(stdc,0.1)
	if not isinstance(other,MultiAtomAssignment):
	  valp,stdp,nump=other[2]
	  ##if stdp<=0.001:stdp=refdev
	  ##else:stdp=max(stdp,minstd/2)
	  sigtot=refdev**2##(stdp**2)+(stdc**2)
	  sdiff=0.5*(((valc-valp)**2)/sigtot)
	  ##if self[3]=='w' and len(self[0])==1 or other[3]=='w' and len(other[0])==1:return sdiff,2
	  ##if self[3]=='w' and len(self[0])==1 or other[3]=='w' and len(other[0])==1:return 99.9,2
	  if self[3]=='w' and len(self[0])==1 or other[3]=='w' and len(other[0])==1:return 1.0,2 #least plausible/2
	  #above weak link is not implemented for multi
	  return sdiff,0
	else:
	  sigtot=(stdc**2)+(refdev**2)
	  sdiff=min([0.5*(((valc-atas[2][0])**2)/sigtot) for atas in other])
	  return sdiff,1

    def compare_tovalue(self,vald,stdd,redo=None):
	return 0.5*(((self[2][0]-vald)/stdd)**2),None


class MultiAtomAssignment(AtomAssignment):#or just inheret from list

    def __init__(self,ataslst,atnord,ssy):
	list.__init__(self,ataslst)#list of AtomAssignment
	self.ssy=ssy
	self.atnord=atnord

    def show(self):
	lst=[atas[2][0] for atas in self]
	stats=[average(lst),std(lst),len(lst)]
	print '%4s %4s %7.3f %7.4f %1d amb'%tuple(list(self.atnord)+stats)

    def set_stats(self):
	for atas in self:atas.set_stats() 

    def get_espin(self,lw):
	##return len(self)*(lw**2)
	return len(self)*(lw**2)/2

    def merge_atas(self,other,lw=UNCERTAINTY):
	try:print 'ambigous merging atas',self.atnord,other.atnord,self[0],other[2][0]
	except IndexError:
	  print 'warning indexerror for merging atas',self.atnord,other.atnord
	  return None
	if not isinstance(other,MultiAtomAssignment):
	 diffs2=[((other[2][0]-atas[2][0])/lw)**2 for atas in self]
	 if len(diffs2)>0:
	  its=[(i,diffs2[i]) for i in range(len(diffs2))];its.sort(lambda x,y: cmp(y[-1],x[-1]))
	  pselec=ProbabilitySelector()
	  n,cprobt,probt,i=pselec.pselectpartner(its)
	  atas=self[i]
	  atas.add(other)
	  return i
	  #later delete self[j] for j<>i
	else:pass#both are multi (unlikely) dont merge

    def get_refs(self):
	refs=set([])
	for atas in self:refs|=set(atas[1])
	return refs

    def compare_values(self,other,minstd=0.15,refdev=0.25):
	if not isinstance(other,MultiAtomAssignment):
	  return other.compare_values(self,minstd,refdev)
	else:
	  print 'warning two-sided ambigous!'
	  sigtot=2.0*(refdev**2)
	  sdiff=min([ min([0.5*(((satas[2][0]-atas[2][0])**2)/sigtot) for atas in other]) for satas in self])
	  return sdiff,2

    def compare_tovalue(self,vald,stdd,redo=False,verb=False):
	if verb:print 'ambigous assignment (typ)',self.atnord
	eners=[0.5*(((atas[2][0]-vald)/stdd)**2) for atas in self]
	if redo:
	  probs=exp(-array(eners))
	  probs/=sum(probs)
	  ptest=rand()
	  ##print eners
	  ##print probs
	  if ptest<probs[0]:remind=1
	  else:remind=0
	  return eners[1-remind]+0.15,remind#asumes precisely 2 values!
	else:
	  p=numpy.argmin(eners)
	  return eners[p]+0.15,1-p


class SpinSystem(dict):

    labelcounts=[]

    def __init__(self,patch=None,explst=None,mode=1,aty=None):
	dict.__init__(self)
	self.flatpeaklst=[]
	self.patch=patch
	self.neighbors={}
	self.complete=False
	self.nummult=0
	self.ignoredct={}
	self.nonspecdct={0:[],-1:[]}#or MultiAtomAssignment([],(ord,spatn),self)
	self.labelcnt=str(len(self.labelcounts))
	self.labelcounts.append(aty)
	if patch==None:
	  self.label=None
	  self.patch=DummyPatch(aty)
	  self.patch.spin=self
	  return#simple empty initialization
	patch.spin=self#cyclic attributing
	for k in patch:
	  for m in patch[k]:
	     self.add_peak((k,m),explst,mode=mode)
	#do statistics
	for ord in self:
	 for atn in self[ord]:
	   lst=self[ord][atn][0]
	   if atn<>'X':
	     stats=[average(lst),std(lst),len(lst)]
	     self[ord][atn][2]=stats
	self.label=patch.label
	##self.show(explst)
	self.show()
	self.regroupX(explst)
	self.show()
	self.setSpecial(lim=explst[0].lineWidth)
	self.show()
	#now update all stats and deeply remove ignored peaks

    def update_maintain(self):
	for ref in self.ignoredct:
	  ord,atn0=self.ignoredct[ref]
	  for atn in self[ord]:
	    atas=self[ord][atn]
	    if ref in atas[1]:
		pos=atas[1].index(ref)
		for j in [0,1,4]:
		  ##atas.pop(j)
		  atas[j].pop(pos)
	for ord in self:
	  somein=False
	  for atn in self[ord].keys():
	    if len(self[ord][atn][0])==0:
	      ##print 'delete this item:',ord,atn
	      self[ord].pop(atn)
	    else:
	      somein=True
	      self[ord][atn].set_stats()
	  if not somein:self[ord].clear()
	for ord in self.nonspecdct:
	  lst=[]
	  for q,atas in enumerate(self.nonspecdct[ord]):
	    if len(atas[0])==0:lst.append(q)
	    else:atas.set_stats()
	  for q in reversed(lst):
	    del self.nonspecdct[ord][q]
	    ##print 'delete this item:',ord,'X',q

    def deep_copy(self,include_weak={0:True,-1:True}):
	other=SpinSystem(aty=self.patch.assigned_type)
	for i in self:
	  other[i]={}
	  for atn in self[i]:
	    #more elegantly: other[i][atn]=self[i][atn].deep_copy()
	    ##other[i][atn]=[[],[],None,None,[]]
	    other[i][atn]=AtomAssignment([],[],[],(i,atn),other)
	    flag0=self[i][atn][3]
	    if isinstance(flag0,str):other[i][atn][3]=flag0
	    elif isinstance(flag0,list):other[i][atn][3]=flag0[:]
	    if include_weak[i]:
	      for n in [0,1,2,4]:
		  other[i][atn][n]=self[i][atn][n][:]
	    else:
	      for p in range(len(self[i][atn][0])):
	        if self[i][atn][1]<>None or include_weak[i]:
		  other[i][atn][0].append(self[i][atn][0][p])#shifts
		  other[i][atn][1].append(self[i][atn][1][p])#refs
		  other[i][atn][4].append(self[i][atn][4][p])#axes
	      shlst=other[i][atn][0]
	      if len(shlst)==0:del other[i][atn]
	      else:other[i][atn][2]=[average(shlst),std(shlst),len(shlst)]
	##other.nonspecdct=some_deepcopy(self.nonspecdct) need this?
	other.espins=self.espins.copy()
	other.etyps=self.etyps.copy()
	other.elink=self.elink
	other.flatpeakdct=self.flatpeakdct.copy()
	other.complete=self.complete
	other.nummult=self.nummult
	for i in include_weak:
	  dnei={0:1,-1:-1}[i]
	  if include_weak[i]:
	    if not dnei in self.neighbors:
	      print 'warning no neighbor available for copying',dnei
	    else:
	      other.neighbors[dnei]=self.neighbors[dnei]#OK? or use deep_copy (iterative?)
	  else:
	    print 'not including neighbor',dnei
	    other.neighbors[dnei]=None#OK?
	return other
	#dont copy neighbors

    def inheretsplit(self,other,explst,inhnum):
	print 'other splits peaks with self, used i==inhnum from self'
	newrefs={}
	if inhnum in self:
	  for atn in self[inhnum]:
	   if atn<>'X':
	    if self[inhnum][atn][1]<>[None]:#something different from None needs to be within list
	      ##other[inhnum][atn]=[[],[],None,None,[]]#reset spin system part
	      other[inhnum][atn]=AtomAssignment([],[],[],(inhnum,atn),other)
	      flag0=self[inhnum][atn][3]
	      for p in range(len(self[inhnum][atn][0])):
	        ref= self[inhnum][atn][1][p]
	    	print 'inheretsplit',atn,self[inhnum][atn][1]
	        if ref<>None:
	          axis=self[inhnum][atn][4][p]
		  atnord=(inhnum,atn)
		  if not ref in newrefs:newrefs[ref]={}
		  newrefs[ref][axis]={atnord:None}
		  ##atndct={axis:{atnord:None}}
		  ##newlst.append((ref,atndct))
		  ##other.add_peak(ref,explst,mode=2,atndct=atndct)#,checknei=chkn_vars)
	if len(newrefs)>0:
	  for ref in newrefs:
	    atndct=newrefs[ref]
	    other.add_peak(ref,explst,mode=2,atndct=atndct)
	  other.set_stats()
	  other.show()
	  ##other.show();1/0

    def inheretolder(self,other,explst):#deprecated!
	print 'other inherets peaks from self',self.flatpeakdct.keys()==other.flatpeakdct.keys()
	self.show()
	other.show()
	newlst=[]
	for i in self:
	 ##if i in other:
	  for atn in self[i]:
	   print 'inheretnew?',i,atn,atn in other[i],self[i][atn][1]
	   if (not atn in other[i]) and atn<>'X':
	    ##other[i][atn]=[[],[],None,None,[]]
	    flag0=self[i][atn][3]
	    for p in range(len(self[i][atn][0])):
	        ref= self[i][atn][1][p]
	        if ref<>None:
	          axis=self[i][atn][4][p]
		  atnord=(i,atn)
		  atndct={axis:{atnord:None}}
		  ##other.add_peak(ref,explst,mode=2,atndct=atndct)#,checknei=chkn_vars)
		  newlst.append((ref,atndct))
	    	  print 'inhereted',i,atn,self[i][atn][1]
	if len(newlst)>0:
	  for ref,atndct in newlst:
	    other.add_peak(ref,explst,mode=2,atndct=atndct)
	  other.set_stats()

    def inheretnew(self,other,explst):
	print 'other inherets peaks from self',self.flatpeakdct.keys()==other.flatpeakdct.keys()
	##self.show()
	##other.show()
	changed=False
	for ref in self.flatpeakdct:
	  if not ref in other.flatpeakdct:
	    peak,p,atns=self.flatpeakdct[ref]
	    changed=True
	    peaknam='none'##getAsFormat(peak.names)
	    print 'inhereted:',ref,peaknam,atns
	    atndct={}
	    for axis in atns:atndct[axis]={atns[axis]:None}
	    other.add_peak(ref,explst,mode=2,atndct=atndct,checkshift=True)
	    #NOTE: this can give double unique (f.ex.: CONCA)
	if changed:
	  other.set_stats()
	  other.show()

    def add_peak_simple(self,ord,atn,content,weakref=True):
	shlst,reflst,stats,sorp,axes=content
	if stats==None or len(shlst)>stats[2]:
	  newsh=average(shlst)
	else:newsh=stats[0]
	if weakref:flag='w'
	else:flag='s'
	if not ord in self:self[ord]={}
	##if not atn in self[ord]:self[ord][atn]=[[],[],None,flag,[]]
	if atn=='X': print 'xwarning (simple)',ord,atn
	if not atn in self[ord]:
	    ##self[ord][atn]=[[],[],[newsh,0.0,1],flag,[]]
	    self[ord][atn]=AtomAssignment([],[],[],(ord,atn),self)
	    self[ord][atn][2]=[newsh,0.0,1]
	    self[ord][atn][3]=flag
	if len(self[ord][atn][0])==0 or not weakref:
	    print '... adding new peak weak',self.patch.assigned_type,ord,atn##,newsh,reflst
	    self[ord][atn][0].append(newsh)
	    self[ord][atn][1].append(None)#ref
	    self[ord][atn][4].append(None)#axis
	##if len(self[ord][atn][0])==1:##0:
	##    self[ord][atn][2]=[newsh,0.0,1]

    def get_assign(self,ref,explst,shdct,aas,lw=UNCERTAINTY):
	     shifts=[shdct[aa13dict[aa]] for aa in aas]
	     ener=0.0
	     k,m=ref
	     expk=explst[k]
	     peak=expk.peakData.peaklist[m]
	     ##peakasname=getAsFormat(peak.names)
	     shs=peak.shifts
	     assign=[]
	     for i in range(len(shs)):
		shi=shs[i]
		ordi=expk.order[i]
		atni=expk.atnames[i]
		if atni<>None:
		  if ordi in self and atni in self[ordi]:
		    atas=self[ordi][atni]
		    stats=atas[2]
		    diff2=(stats[0]-shi)**2#scaled how?
		    scal=0.5/(lw**2)##max(0,1,min(stats[2]**2,1.0))
		    ener+=(scal*diff2)#+log(scal)
		    assign.append((ordi,atni))
		  ##else:assign.append(None)
		else:
		  if ordi==None:ordi=expk.exporder[i]
		  if ordi in self:
		    shd=shifts[ordi]
		    xatns=[k for k in shd if k[0]=='C']## and (not k in ['C','CA'])]
		    vals=[]
		    scal=0.5/(lw**2)
		    for atni in xatns:
		      if atni in self[ordi]:
			vals.append((log(lw)+scal*(self[ordi][atni][2][0]-shi)**2,atni,'s'))
		      else:
			vald,stdd=shd[atni]
			##print 'shift not found in ssy',atni,vald
			vals.append((log(stdd)+0.5/stdd/stdd*(vald-shi)**2,atni,'n'))
		    ##for atn in self[ordi]:print atn,self[ordi][atn][0],self[ordi][atn][2]
		    ##vals=[((self[ordi][atn][2][0]-shi)**2,atn) for atn in self[ordi]]
		    minener,minatn,minmet=min(vals)
		    if minmet=='n':
			print 'NOTE new shift:',min(vals)
		    ener+=minener
		    assign.append((ordi,minatn))
		  ##else:assign.append(None)
	     return ener,assign

    def add_peak(self,ref,explst,mode=1,execute=True,atndctnum=0,atndct=None,checknei=None,overwriteord=False,maxdiff=1.0,checkshift=True):##False):
	     ener=0.0
	     k,m=ref
	     if mode==2:
		if atndct==None:
		  atndct=self.patch[k][m]
		  ##print 'atndct:',atndct
	     expk=explst[k]
	     peak=expk.peakData.peaklist[m]
	     ##peakasname=getAsFormat(peak.names)
	     shs=peak.shifts
	     warndct={}
	     if execute:self.flatpeaklst.append(peak)
	     lw=explst[k].lineWidth
	     for i in range(len(shs)):
		shi=shs[i]
		ordi=expk.order[i]
		atni=expk.atnames[i]
		addshift=True
		if atni==None:
		  atni='X'
		  if mode==2:
		    if i in atndct:
			atns=atndct[i]
			if len(atns)==1:
			  atnord=atns.keys()[0]
			  ord0,atni=atnord #ord0 == ordi
			else:
			  print 'note multiple choice of atoms',k,m,i,atns
			  pselec=ProbabilitySelector()
			  its=atns.items();its.sort(lambda x,y: cmp(y[-1],x[-1]))
			  print its
			  n,cprobt,probt,atnord=pselec.pselectpartner(its)
			  ##atnord=its[atndctnum][0]
			  print 'chosen best atnord',atnord,probt,n,cprobt,cprobt
			  ord0,atni=atnord #ord0 == ordi
		    else:
			print 'warning: axis not in atndct',k,m,i,atndct,shi
			#now trying to identify possible assignments
			mindiff=999.999;minatn=None
			thisord=ordi
			if thisord==None:thisord=expk.exporder[i]
			if thisord in self:
			 for atnix in self[thisord]:
			  if self[thisord][atnix][2]==None:
			    shx=average(self[thisord][atnix][0])
			  else:
			    shx=self[thisord][atnix][2][0]
			  diff=abs(shx-shi)
			  if diff<mindiff:
			    mindiff=diff
			    minatn=atnix
			print 'order not found yet',i,shi,thisord
			print 'best fitting atom for axis',i,shi,mindiff,minatn
			if mindiff>1.0:#optimize value
			  print 'still no good match',i,shi,mindiff,minatn,atndct
			  addshift=False
			  ener+=1.0#OK?
			  if execute and thisord in self:
			    for oax in atndct:
			      for xord,oatn in atndct[oax]:
				warndct[(thisord,oatn)]=(i,ref,minatn)
				print 'warning illconfirmed atom',(thisord,oatn),(i,ref,minatn)
			  #add for other atom anyway? (yes, for the moment)
			  #add as X atom?? (no, for the moment)
			else:
			  atni=minatn
			  atndct[i]={(thisord,minatn):None}
			  #wrong to put in object for further use?
		    ##print k,m,atni
		##if ordi==None:ordi=expk.order[1]#TAKEBACK
		if ordi==None:ordi=expk.exporder[i]
		if overwriteord and expk.order[i]==None:
		  ##print 'overwriting order',ordi,ord0,atni
		  ordi=ord0
		if execute:
		  if not ordi in self:self[ordi]={}
		  ##if not atni in self[ordi]:self[ordi][atni]=[[],[],None,[],[]]
		  if not atni in self[ordi]:self[ordi][atni]=AtomAssignment([],[],[],(ordi,atni),self)
		elif mode==2 and atni<>'X':
		 ##print 'adding to existing data',ordi,atni
		 if ordi in self and atni in self[ordi] and len(self[ordi][atni][0])>0:
		   sh0=average(self[ordi][atni][0])
		   shdiff=abs(sh0-shi)
		   ener+=min(0.25*(shdiff/lw)**2,maxdiff)
		   if shdiff>1.0:#TODO: optimize value
			##print 'warning inconsistent shift',atni,sh0,shi
			addshift=False
		if execute and (not checkshift or addshift):
		  ##if i==2:print 'adding new shift',ordi,atni,ref,self[ordi][atni],shs
		  if atni=='X': print 'xwarning (normal)',mode,execute,ref,ordi,atni
		  self[ordi][atni][0].append(shs[i])
		  self[ordi][atni][1].append((k,m))
		  self[ordi][atni][4].append(i)#axis number
		  #or implement as method for AtomAssignment
		  if checknei<>None:
		    aty,maxaty,allatys=checknei
		    ##print 'checking neighbor within add_peak',ordi,atni,aty
		    if atni<>'X' and atni<>'N':
		      self.add_peak_to_neighbor(ordi,atni,aty,maxaty,allatys)
		  ##if i==2:print 'added  new shift',ordi,atni,ref,self[ordi][atni]
	     for thisord,oatn in warndct:
		print 'warning illconfirmed atom',oatas
		oatas=self[thisord][oatn]
		if len(oatas)==5:oatas.append([])
		oatas[5].append(warndct[(thisord,oatn)])##(i,ref,minatn))
	     return ener

    def ask_peak(self,peak,expk,pemat,pasnm,peakref,execute=False):
	shs=peak.shifts
	tot=0.0
	hit=False
	for i in range(len(shs)):
	  ordi=expk.order[i]
	  atni=expk.atnames[i]
	  if atni==None:atni='X'
	  if ordi==None:ordi=expk.order[1]#TAKEBACK
	  if ordi in self:
	     if not pasnm[i] in self[ordi]:
		print 'asking',shs[i],ordi,pasnm[i],pemat[i]
		tot+=pemat[i]
		hit=True
		if execute:
		  print 'executing addition',shs[i],ordi,pasnm[i],pemat[i]
		  ##self.assignNewSpecific(ordi,pasnm[i],peakref,shs[i],i)
		  self.assignNewSpecific(ordi,pasnm[i],peakref,shs,expk.atnames,expk.order,i)
	  else:print 'warning ordi not in self',ordi
	if hit and execute:self.show()
	if not hit:return 90.0
	return tot

    def show(self):
	print '++++++ spin system assignments ++++++++','ssy'+self.labelcnt##,self.labelcounts
	speccnt=0
	for ord in self:
	 for atn in self[ord]:
	   if atn<>'X':
	     atas=self[ord][atn]
	     atas.show()
	     speccnt+=1
	   else:
	    lst =self[ord][atn][0]
	    flag=self[ord][atn][3]
	    stats=self[ord][atn][2]
	    for i,shi in enumerate(lst):
	     print '%4s %4s %7.3f'%(ord,atn,shi),##flag
	     if stats<>None and isinstance(stats[0],list):
		print '%7.4f %1d'%(stats[1][i],stats[2][i])
	     else:print flag
	 if ord in self.nonspecdct:
	  for xatas in self.nonspecdct[ord]:
	    xatas.show()
	 else:print 'WARNING - order not in nonspecdct',ord
	print 'speccnt:',speccnt,self.complete
	self.speccnt=speccnt
	#NOTE is speccnt derived elsewhere?

    def merge_with(self,other,lw=UNCERTAINTY):
	#other is (often) side-chain only
	#self and other are swapped compared to get_merge_score below
	##print 'merging spin systems'
	##self.show()
	##other.show()
	for order in other:
	  if not order in self:self[order]={}
	  for atn in other[order]:
	    if atn in self[order]:
	      mindex=self[order][atn].merge_atas(other[order][atn])
	      if mindex<>None:
		print 'overwriting ambigous special atom with specific assignment',mindex
		self[order][atn]=self[order][atn][mindex]
	    else:
	      self[order][atn]=other[order][atn]
	xataslst=self.nonspecdct[0]
	oxataslst=other.nonspecdct[0]
	for oatas in oxataslst:
	 diffs=[abs(atas[2][0]-oatas[2][0])/lw for atas in xataslst]
	 if len(diffs)>0:
	  p=numpy.argmin(diffs)
	  diff=diffs[p]
	  merged=False
	  if diff<3.0:
	    prob=exp(-0.5*0.5*(diff**2))
	    ptest=rand()
	    if ptest<prob:
	      xataslst[p].merge_atas(oatas)
	      merged=True
	  if not merged:
	    print 'appending new nonspecific atom assignment',oatas[2][0],diff
	    xataslst.append(oatas)
	#cross-merge between non-specific and special atoms?...

    def get_merge_score(self,other,explst,lw=UNCERTAINTY):
	#self is side-chain only
	self.show()
	other.show()
	xataslst=self.nonspecdct[0]
	if len(xataslst)==0:return 0.0,0,0
	sh0lst=[atas[2][0] for atas in xataslst]
	xataslst1=other.nonspecdct[0]
	sh1lst=[atas[2][0] for atas in xataslst1]
	cnt=0.0#"fuzzy" count (see regroupX)
	for spatn in ['CA','C']:#CB later?
	  if spatn in other[0]:
	    if not isinstance(other[0][spatn],MultiAtomAssignment):
	      ##print 'adding value for spatn',spatn,other[0][spatn][2]
	      ##sh1lst.append(other[0][spatn][2][0])
	      if spatn in self[0]:
		if not isinstance(self[0][spatn],MultiAtomAssignment):
		  diff=     abs(self[0][spatn][2][0]-other[0][spatn][2][0])/lw
		  scal=1.5
		else:
		  diff=min([abs(          atas[2][0]-other[0][spatn][2][0])/lw for atas in self[0][spatn]])
		  scal=1.0
		if diff>3.0:
		  ##print 'specific shifts are inconsistent (returning 0.0)',spatn,diff
		  return 0.0,len(sh0lst),len(sh1lst)
		else:
		  cnt+=(scal*exp(-0.5*(diff**2)))#uses different scaling/weighting? - OK?
	    else:
	      if spatn in self[0] and not isinstance(self[0][spatn],MultiAtomAssignment):
		diff=min([abs(self[0][spatn][2][0]-atas[2][0])/lw for atas in other[0][spatn]])
		if diff>3.0:
		  ##print 'specific shifts are inconsistent (multi,returning 0.0)',spatn,diff
		  return 0.0,len(sh0lst),len(sh1lst)
		else:
		  cnt+=(1.5*exp(-0.5*(diff**2)))#uses different scaling/weighting? - OK?
	##print sh0lst
	##print sh1lst
	for sh0 in sh0lst:
	  for sh1 in sh1lst:
	    diff=abs(sh0-sh1)/lw
	    if diff<3.0:
	      cnt+=exp(-0.5*0.5*(diff**2))
	return cnt,len(sh0lst),len(sh1lst)

    def regroupX(self,explst):
	xhits=[]
	for ord in self:
	 for atn in self[ord]:
	   if atn=='X':
	     xhits.append(ord)
	     xd=self[ord][atn]
	     if len(xd[0])>0:
	      ##print xd
	      data=[(xd[0][p],xd[1][p],xd[4][p],p) for p in range(len(xd[0]))] #(shift,ref,axis,index)
	      data.sort()
	      ##print data
	      prevsh=data[0][0];prevnum=0
	      curgroup=[0]##data[0][3]]
	      allgroups=[]
	      for i in range(1,len(data)):
		shdiff=prevsh-data[i][0]
	        lw=explst[data[i][1][0]].lineWidth#should be average
	        lw/=sqrt(2.0/(len(curgroup)+1))#more permissive with more peaks (expect larger spread)
		scald2=(shdiff/lw)**2
		prob=exp(-0.5*0.5*scald2)
		ptest=rand()
		if ptest<prob:
		  ##print 'add to group',prob
		  curgroup.append(i)
		else:
		  ##print 'next group',prob
		  allgroups.append(curgroup)
		  curgroup=[i]
		  prevsh=data[i][0]
	      allgroups.append(curgroup)
	      ##print allgroups
	      for ilst in allgroups:
		shvals =[data[i][0] for i in ilst]
		refvals=[data[i][1] for i in ilst]
		axivals=[data[i][2] for i in ilst]
		xatas=AtomAssignment(shvals,refvals,axivals,(ord,'X'),self)
		xatas[2]=[average(shvals),std(shvals),len(shvals)]
		self.nonspecdct[ord].append(xatas)
	for ord in xhits:del self[ord]['X']#OK?

    def get_tripener(self,tripenerdct,rcdct,seq,i):
	defener=0.0
	atnfacs=[('CA',-1.0),('CB',1.0),('C',-1.0),('N',0.2)]#solid state
	ress=[]
	if -1 in self.neighbors:
	  ssy=self.neighbors[-1]
	  if 0 in ssy:ress.append(ssy[0])
	if len(ress)==0:
	  if -1 in self:ress.append(self[-1])
	if 0 in self:ress.append(self[0])
	if 1 in self.neighbors:
	  if 0 in self.neighbors[1]:ress.append(self.neighbors[1][0])
	if len(ress)<3:return defener
	misses=0
	tup=zeros(3)
	for j,res in enumerate(ress):
	  for atn,fac in atnfacs:
	    aa=seq[i+j-1];resn=aa13dict[aa]
	    if resn=='GLY' and atn=='CB':pass #add 0.0
	    elif resn=='PRO' and atn=='N':pass #add 0.0
	    elif not atn in res:
		##print 'warning atn not in res:',atn,resn,i,j
		misses+=1
		if misses>2:return defener
	    else:
	     if res[atn][2][0]<>None:
	      ##print j,aa,res[atn][2]
	      tup[j]+=((res[atn][2][0]-rcdct[aa][atn])*fac)
	try:
	  tener=getener(tup,tripenerdct[seq[i]],2)
	  ##print 'residue triplet energy %2d %s %6.3f'%(i,seq[i],tener),tup
	  tener=min(5,tener-5.0)
	  return tener
	except KeyError:
	  print 'WARNING - no key',seq[i],i
	  return 4.0

    def setSpecial(self,lim=0.5):
	print 'setting special',self
	specs={'CA':(44.0,68.0),'C':(170.5,182.0)}#boundaries are known from NCACO
	for ord in self:
	  remlst=[]
	  ##if 'X' in self[ord]:
	  if len(self.nonspecdct[ord])>0:
	    xataslst=self.nonspecdct[ord]
	    lst=[atas[2][0] for atas in xataslst]
	    for spatn in specs:
	      lims=specs[spatn]
	      for i,shi in enumerate(lst):
		##print 'data:',ord,spatn,shi
		axis=xataslst[i][4]
		if lims[0]<shi<lims[1]:
		  if spatn in self[ord]:
		    shref=self[ord][spatn][2][0]
		    if abs(shref-shi)<=lim:
		      print 'found matching shift for special atom',ord,spatn,shi,shref
		      remlst.append((i,shi,spatn,'m',axis))
		    else:
		      pmatch=False
		      if spatn=='C' and ord==0 and -1 in self and 'C' in self[-1]:
		       if len(self[-1]['C'][2])>0:
			#possible to generalize?...
			shrefp=self[-1]['C'][2][0]
			if abs(shrefp-shi)<=lim:
		          print 'matching prev C',shi,shrefp
			  remlst.append((i,shi,spatn,'x',axis))
			  pmatch=True
		      elif spatn=='CA' and ord==-1 and 0 in self and 'CA' in self[0]:
			shrefp=self[0]['CA'][2][0]
			if abs(shrefp-shi)<=lim:
		          print 'matching prev CA',shi,shrefp
			  remlst.append((i,shi,spatn,'x',axis))
			  pmatch=True
		      if not pmatch:
		        print 'found inconsistent shift for special atom',ord,spatn,shi,shref
			remlst.append((i,shi,spatn,'n',axis))
		  else:
		    print 'found plausible shift for special atom',ord,spatn,shi
		    pmatch=False
		    if spatn=='CA' and ord==-1 and 0 in self and 'CA' in self[0]:
		      if len(self[0]['CA'][2])>0:
			shrefp=self[0]['CA'][2][0]
			if abs(shrefp-shi)<=lim:
		          print 'matching prev CA',shi,shrefp
			  remlst.append((i,shi,spatn,'x',axis))
			  pmatch=True
		    elif spatn=='C' and ord==0 and -1 in self and 'C' in self[-1]:
			shrefp=self[-1]['C'][2][0]
			if abs(shrefp-shi)<=lim:
		          print 'matching prev C',shi,shrefp
			  remlst.append((i,shi,spatn,'x',axis))
			  pmatch=True
		    if not pmatch:
		      remlst.append((i,shi,spatn,'p',axis))
	    xataslst=self.nonspecdct[ord]
	    if HASCB and 'CB' in self[ord]:
	      cbatas=self[ord]['CB']
	      shref=cbatas[2][0]
	      for i,shi in enumerate(lst):
		axis=xataslst[i][4]
		scald2=((shref-shi)/lim)**2
		if scald2<9.0:
		 inds=[tup[0] for tup in remlst]
		 if not i in inds:
		  prob=exp(-0.5*0.5*scald2)
		  ptest=rand()
		  if ptest<prob:
		  ##if abs(shref-shi)<=lim:
		   print 'found matching shift for special atom 0 CB',shi,shref
		   remlst.append((i,shi,'CB','m',axis))
	  remlst.sort();remlst.reverse()
	  #sorting+reversing is very important to ensure popping items from the end first to preserve numbering
	  print 'remlst:',ord,len(remlst),remlst

	  remdct={}
	  for i,shi,spatn,flag,axis in remlst:
	    if flag=='p':
	      if not spatn in remdct:remdct[spatn]=[]
	      remdct[spatn].append((i,shi,axis))
	  for i,shi,spatn,flag,axis in remlst:
	    if flag in 'mx':
	      ##print 'popping',ord,flag
	      atas=xataslst.pop(i)
	    elif flag=='p':
	      if not ord in self:self[ord]={}
	      if len(remdct[spatn])>1:
		print 'ambigous: plausible spatn creating multiatas',ord,spatn,remdct[spatn]
		if not spatn in self[ord]:
		  print 'empty initialization of multiatas',ord,spatn
		  self[ord][spatn]=MultiAtomAssignment([],(ord,spatn),self)
		atas=xataslst[i]
		self[ord][spatn].append(atas)
		applst=[(spatn,vals[1]) for vals in remdct[spatn]]
		atas[3]=applst
		#DONT POP from nonspecdct
	      else:
		print 'unique plausible spatn - assign atom',ord,spatn,remdct[spatn]
		#POP from nonspecdct
		atas=xataslst.pop(i)
		atas.atnord=(ord,spatn)#changing name to specific
		self[ord][spatn]=atas
	    elif flag=='n':
	      print 'supposed inconsistent shift - no action:',i,shi,spatn
	      #should label somehow - often a bad peak
	    if flag=='x':
	      print 'matched prev (off-pathway transfer) - deleting',i,shi,spatn
	      #allready popped above
	      for refi in atas[1]:
	        pass##self.ignoredct[refi]=(ord,'X')
	    elif flag=='m':
	      spatas=self[ord][spatn]
	      print 'add to existing assigned atom',i,shi,spatn,spatas[0]
	      spatas.add(atas)
	    #TODO: also remove peaks from other atoms? (such as 'N')
	    #TODO: also remove peaks from parrent patch
	
    def finalize_special(self):
	for ord in self:
	  for atn in self[ord]:
	    if atn[0]<>'X':
	      if self[ord][atn][3]=='p':
		refp=self[ord][atn][1][0]
	        self.ignoredct[refp]=(ord,'X')
		reflstx=self[ord]['X'][1]
		try:
		  pos=reflstx.index(refp)
		  self[ord]['X'][0].pop(pos)
		  self[ord]['X'][1].pop(pos)
		  self[ord]['X'][4].pop(pos)
		except ValueError:print 'WARNING: value not in reflstx',refp,atn,ord

    def assignSpecific(self,dct,ambdct,probrem0=0.3,probrem1=0.6):
	print 'assigning specific',self
	patch=self.patch
	remrefs=[]
	for ord in dct:
	 lst=dct[ord]
	 if len(lst)>1:
	   lst.sort(lambda x,y: cmp(x[1],y[1]))
	   print ord,lst
	   for i in range(1,len(lst)):
	     if lst[i][1]==lst[i-1][1] and lst[i][2]=='a' and lst[i-1][2]=='a':
		eners=lst[i][3],lst[i-1][3]
		print 'warning: same atom (removing one or neither)',lst[i][1],eners
		##if eners[0]<eners[1]:lst[i-1][2]='r'
		##else:lst[i][2]='r'
		#now stochastically decide whether to remove neither or which of them...
		probs =exp(-array(eners))
		probs/=sum(probs)
		print probs
		ptest=rand()
		if ptest<probs[0]:remind=0
		else:remind=1
		remnum=[i-1,i][remind]
		##if probs[remind]>0.5:probrem=probrem0
		##else:probrem=probrem1
		probrem=probs[remind]
		if rand()<probrem:lst[remnum][2]='r'
		else:lst[remnum][2]='x'
	 lst.sort();lst.reverse()
	 print ord,lst
	 for i,spatn,flag,ener in lst:
	  if flag=='a':  print 'assigning specific',
	  elif flag=='r':print 'removing peak from spin system',
	  elif flag=='x':print 'keeping xtra peak from spin system',
	  print ord,i,spatn,ener
	  if flag<>'x':
	    atas=self.nonspecdct[ord].pop(i)
	    print 'popped',atas
	    if spatn[0]<>'X' and flag<>'a':
	     for ref in atas[1]:
	      self.ignoredct[ref]=(ord,spatn)
	      patch.remove(ref);remrefs.append((ref,spatn))
	    if flag=='a':
		self[ord][spatn]=atas
		atas.atnord=(ord,spatn)
	for ord in ambdct:
	  for spatn in ambdct[ord]:
	    i=ambdct[ord][spatn]
	    print 'removing (popped) ambi peak from spin system',ord,spatn,i
	    for ref in self[ord][spatn][i][1]:
	      self.ignoredct[ref]=(ord,spatn)
	      patch.remove(ref);remrefs.append((ref,spatn))
	    keepatas=self[ord][spatn][1-i]
	    ##print keepatas.__class__
	    ##print keepatas
	    ##keepatas.show()
	    self[ord][spatn].atnord=(ord,spatn)
	    self[ord][spatn]=keepatas#overwrite
	#now "deeply" remove peak in other atom assignments
	for remref,spatn in remrefs:
	  if spatn[0]<>'X':
	   for ord in self:
	    for atn in self[ord]:
	      if atn<>'X':
	       if atn<>spatn:
		##if not (spatn[0]=='X' and spatn[2:]==atn):
		 reflst=self[ord][atn][1]
		 for p in range(len(reflst)-1,-1,-1):
		  if reflst[p]==remref:
		    print 'removing (popped) shift in reflst',ord,atn,p,reflst[p],spatn
		    reflst.pop(p)
		    self[ord][atn][0].pop(p)
		    self[ord][atn][4].pop(p)

    ##def assignNewSpecific(self,ord,spatn,ref,shi,axis):
    def assignNewSpecific(self,ord,spatn,ref,shs,names,orders,axis):
	shi=shs[axis]
	if spatn in self[ord]:
	  print 'WARNING spatn allready present:',spatn,ref,shi,self[ord][spatn]
	  #TODO:...
	##self[ord][spatn]=[[shi],[ref],[shi,0.0,1],[],[axis]]
	self[ord][spatn]=AtomAssignment([shi],[ref],[axis],(ord,spatn),self)
	self[ord][spatn][2]=[shi,0.0,1]
	for i in range(len(shs)):
	  if axis<>i:
	    atni=names[i]
	    ordi=orders[i]
	    shi =shs[i]
	    self[ordi][atni][0].append(shi)
	    self[ordi][atni][1].append(ref)
	    self[ordi][atni][4].append(i)
	    lst=self[ordi][atni][0]
	    self[ordi][atni][2]=[average(lst),std(lst),len(lst)]

    def addnonspecificpeak(self,patch,peak,expk,ref,shs):
	print 'adding non specific peak',peak,ref,shs

    def set_stats(self):
	for i in self:
	  for atn in self[i]:
	    stat=self[i][atn][2]
	    if stat==None or len(self[i][atn][0])>stat[2]:
	      dat=[]
	      for p,shp in enumerate(self[i][atn][0]):
		if self[i][atn][1][p]<>None:dat.append(shp)
	      if len(dat)>0:
		self[i][atn][2]=[average(dat),std(dat),len(dat)]
	      else:
		##print 'warning no data:',i,atn,self[i][atn]
		self[i][atn][2]=[None,None,0]
		if len(self[i][atn][0])>0:
		  self[i][atn][2][0]=self[i][atn][0][0]
		  ##self[i][atn][2][1]=0.0

    def get_elink(self,other,verb=False,redo=False,refdev=0.2,expectX=False,probminspec=0.05,probminx=0.1):##,explst):
	lw=UNCERTAINTY
	##refdev depricated
	k_least_plausible=2.0#.......?TODO: optimize this value
	if verb:
	  print 'getting elink'
	  self.show()
	  other.show()
	#outcomment show() and print statements to speed up ~3-fold
	if not (-1 in self and 0 in other):return k_least_plausible
	current=self[-1];prev=other[0]
	specs=['CA','C']
	eobs=0.75
	tot=0.0
	eminspec=-log(probminspec)
	eminax=-log(probminx)
	iddct={}
	sp=set(specs)
	s0=set(current.keys())
	##s1=set(current.keys()) #BUG! #BUG!
	s1=set(prev.keys())
	sx=set(['X','N'])
	specsx=(s0|s1)-sp-sx
	##print specs,specsx
	##for spatn in specs:
	for spatn in specs+list(specsx):
	  iddct[spatn]=False
	  if spatn in specsx:emincur=eminax
	  else:emincur=eminspec
	  if spatn in current and spatn in prev:
	    curratas=current[spatn]
	    prevatas=prev[spatn]
	    sdiff,ambval=curratas.compare_values(prevatas,minstd=lw/2,refdev=lw)
	    #if ambval is 2, this could mean one value is "weak" => consider not using!
	    if sdiff-eobs<emincur:##spec:
		tot+=(sdiff-eobs)+ambval*0.3
		iddct[spatn]=True
	    else:
		tot+=emincur##spec
	  else:tot+=k_least_plausible/2
	#end-for spatn in specs+list(specsx):
	if verb:print 'tot is:',tot
	totx=0.0
	eminx=-log(probminx)
	sigtot=(refdev**2)*2
	if expectX:
	 ##if 'X' in current and 'X' in prev:
	 #if len(self.nonspecdct[-1])>0 and len(other.nonspecdct[0])>0:
	  ##valsxc=current['X']
	  ##valsxp=   prev['X']
	  currataslst=self.nonspecdct[-1]
	  valsxc=[atas[2][0] for atas in currataslst]
	  prevataslst=other.nonspecdct[0]
	  valsxp=[atas[2][0] for atas in prevataslst]
	  ##print valsxc
	  ##print valsxp
	  if len(valsxc)==0 or len(valsxp)==0:
	    ##if not redo:totx+=k_least_plausible
	    if not redo:totx+=(eminx*max(len(valsxp),len(valsxc)))
	  else:
	    if len(valsxc)<len(valsxp):
	      shortvals=valsxc
	      largevals=valsxp
	      shortatas=currataslst
	      largeatas=prevataslst
	    else:
	      shortvals=valsxp
	      largevals=valsxc
	      shortatas=prevataslst
	      largeatas=currataslst
	    usedlarge=[]
	    for i,atas in enumerate(shortatas):
	      skip=False
	      if atas[3]>0:
	        for pspatn,pval in atas[3]:
		  if iddct[pspatn] and abs(pval-atas[2][0])<0.001:skip=True
 	      if not skip:
		diffs=[atas.compare_values(latas,minstd=lw/2,refdev=lw)[0] for latas in largeatas]
		p=argmin(diffs)
		#TODO: choose stochastically?
		mindiff=diffs[p]
		if mindiff-eobs<eminx:
		  usedlarge.append(p)
		  totx+=mindiff-eobs
		else:
		  totx+=eminx
	    for i,atas in enumerate(largeatas):
	     if not i in usedlarge:#should be faster!
	      skip=False
	      if atas[3]>0:
	        for pspatn,pval in atas[3]:
		  if iddct[pspatn] and abs(pval-atas[2][0])<0.001:skip=True
	      if not skip:
		diffs=[atas.compare_values(satas,minstd=lw/2,refdev=lw)[0] for satas in shortatas]
		mindiff=min(diffs)
		totx+=min(mindiff-eobs,eminx)
	  if verb:print 'totx is:',totx
	return tot+totx
	##return tot+(totx/2)

    def get_complete(self,dct,aas):
	specs=['CA','C']
	if not 0 in self:return False
	if not 'N' in self[0]:return False
	shifts=[dct[aa13dict[aa]] for aa in aas]
	for i in [0,-1]:
	  if not i in self:return False
	  current=self[i]
	  for spatn in specs:
	    if not spatn in current:return False
	    shi=shifts[i]
	    xatns=[k for k in shi if k[0]=='C' and (not k in specs)]## and (shi[k][0]<100 or shi[k][0]>160)]
	    for xatn in xatns:
		if not xatn in current:
		  print 'spin system is incomplete!',aas,i,xatn
		  return False
	print 'spin system is complete!',aas,self.patch.assigned_type,self[0].keys(),self[-1].keys()
	return True

    def get_missing_atom_assignments(self,dct,aas):
	specs=['CA','C']
	missing=[]
	if not 0 in self:
	  for spatn in specs:missing.append((0,spatn,'s'))
	##if not 'N' in self[0]:missing.append((0,'N'))
	if aas[0]<>'P' and (not 0 in self or not 'N' in self[0]):missing.append((0,'N','s'))
	shifts=[dct[aa13dict[aa]] for aa in aas]
	for i in [0,-1]:
	 if i==0 or aas[0]<>'P':
	  if not i in self:current=[]
	  else:current=self[i]
	  for spatn in specs:
	    if not spatn in current:
		missing.append((i,spatn,'s'))
	    else:
	      flag0=self[i][spatn][3]
	      if flag0=='w':
	        for ref in self[i][spatn][1]:
	          if ref<>None:
		    flag0='s';break
		if flag0=='w':
		  missing.append((i,spatn,'w'))
	  shi=shifts[i]
	  xatns=[k for k in shi if k[0]=='C' and (not k in specs)]## and (shi[k][0]<100 or shi[k][0]>160)]
	  for xatn in xatns:
	    if not xatn in current:
		missing.append((i,xatn,'s'))
	    else:
	      flag0=self[i][xatn][3]
	      if flag0=='w':
	        for ref in self[i][xatn][1]:
	          if ref<>None:
		    flag0='s';break
		if flag0=='w':
		  missing.append((i,xatn,'w'))
	return set(missing)

    def get_espinsystem(self,lw=UNCERTAINTY):
	tot=0.0;num=0
	self.espins={}
	for i in self:
	  toti=0.0
	  for atn in self[i]:
	    atas=self[i][atn]
	    toti+=atas.get_espin(lw)
	    num+=1
	  if i in self.nonspecdct:
	   for atas in self.nonspecdct[i]:
	    toti+=atas.get_espin(lw)
	    num+=1
	  self.espins[i]=toti
	  tot+=toti
	if num==0:return 9.99
	return tot/num

    def set_rank(self,isgly=None):
	rank=0
	nshift=150.0;cashift=None
	if 0 in self and 'N' in self[0]:
	  nshift=self[0]['N'][2][0]
	  rank+=1
	if isgly==None:
	 isgly=nshift<114.0
	 if 0 in self and 'CA' in self[0]:
	  atas=self[0]['CA']
	  if isinstance(atas,MultiAtomAssignment):
	   cashift=min([atas1[2][0] for atas1 in atas])
	  else:
	   cashift=self[0]['CA'][2][0]
	   isgly=cashift<49.0
	specs=['CA','C']
	for ord in (0,-1):
	  if ord in self:
	    for spatn in specs:
	      if spatn in self[ord]:rank+=1
	if 0 in self:
	  if 'CB' in self[0]:rank+=0.7
	  elif isgly:rank+=0.6
	for ord in (0,-1):
	  if ord in self.nonspecdct:
	    rank+=0.4
	self.rank=rank

    def get_quality(self,resi,resshifts,aac,seq,cnt,out):
	isgly=aac=='G'
	self.set_rank(isgly)
	espin=sum(self.espins.values())
	##eval_true=self.evaltrues[0]
	eval_true=1
	etyp=sum(self.etyps.values())
	print self.rank,espin
	print self.complete
	print sum(self.etyps)
	try:
	  print self.nummult,len(self.flatpeakdct)
	  fracm=(self.nummult*1.0)/len(self.flatpeakdct)
	except AttributeError:
	  print 'WARNING - no nummult',self.assigned_type
	  self.nummult=0; fracm=0.5
	##atas=self[-1]['CA']
	tsh=(resshifts,None)
	if resshifts<>None:
	  cmpresul=self.compare_true(tsh,(aac,None))
	  miss,bad,sumdevs2,misssc,badsc,sumdevs2sc,num,numsc=cmpresul
	num=0;sume=0.0;numfar=0;numbad=0
	bbatns=['N','CA','C']##,'CB']
	bbfar=0;bbbad=0;scfar=0;scbad=0
	for i in [0]:##self:
	 if i in self:
	  for atn in self[i]:
	    atas=self[i][atn]
	    entrop,shdiff,pac=atas.show_hist(resi,tsh[0])##,doshow=atn=='CB')
	    if shdiff<>None and shdiff>0.55:#was 0.50
		if atn in bbatns:bbfar+=1
		else:scfar+=1
		numfar+=1
		if pac<0.2:
		  numbad+=1
		  if atn in bbatns:bbbad+=1
		  else:scbad+=1
	    num+=1
	    sume+=exp(entrop)
	if num<1:return 0,0,0,0
	print sume/num
	if resshifts<>None:
	 for atn in resshifts:
	  if (not 0 in self) or (not atn in self[0]): print 'NOTE: M-A: (no autoass.)',resi,atn
	 print 'truestat:',len(miss),len(misssc),len(bad),len(badsc),bad,badsc,sumdevs2,sumdevs2sc,miss,misssc
	frsco=-log(1-fracm+0.02)*1.0
	qua=(6.5-self.rank-self.complete)/2.0+frsco+sqrt(espin)/2+etyp*0.2
	print 'qualityvars: %2d %1d %3.1f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f'%\
	(self.assigned_type,self.complete,self.rank,eval_true,frsco,sume/num,sqrt(espin)/2,etyp,qua/10.0),
	if resshifts<>None:print len(bad),len(badsc),numfar,numbad
	else:print
	cnt=self.write_shifts(out,cnt,seq,resi-2,qua)
	return bbfar,bbbad,scfar,scbad,cnt

    def write_shifts(self,out,cnt,seq,i,qua,direc=0):
	if i==0 and direc==0:cnt=self.write_shifts(out,cnt,seq,i,qua,direc=-1)
	aac=seq[i+1+direc]
	aac3=aa13dict[aac]
	if direc in self:
	  for atn in self[direc]:
	    atas=self[direc][atn]
	    ave,stdi,num=atas[2]
	    if num==1:stdi=0.5
	    combqual=7.5/clipspec(stdi)/clipspec(qua/10.0)
	    stdi=max(stdi,0.1)
	    ##atas.write_shift(out,cnt)
	    out.write('%4d %3d %3s %4s %2s %6.2f %5.3f 1 %6.3f\n'%(cnt,i+2+direc,aac3,atn,atn[0],ave,stdi,combqual))
	    cnt+=1
	return cnt

    def setallrefs(self):
	self.combrefset=set([])
	s=self.combrefset
	for i in self:
	  for atn in self[i]:
	    atas=self[i][atn]
	    s|=atas.get_refs()
	  for atas in self.nonspecdct[i]:
	    s|=atas.get_refs()

    def add_peak_to_neighbor(self,ord,atn,aty,maxaty,allatys,merge=False):
	this=self[ord]
	ord1={0:-1,-1:0}[ord]
	dnei={0:1,-1:-1}[ord]
	if dnei in self.neighbors:
	  other=self.neighbors[dnei]
	  if ord1 in other:next=other[ord1]
	  else:next=[]
	  if merge or (not atn in next):
	    content=this[atn]
	    ##print 'assign_neighbor',ord,aty,atn,content
	    other.add_peak_simple(ord1,atn,content)
	else:
	  newaty=aty+dnei
	  if 0<=newaty<=maxaty:
	   if not newaty in allatys:
	    ##print 'create_by_nei',ord,aty,newaty,atn,len(this),this.keys()
	    newssy=SpinSystem(aty=newaty)#empty now
	    allatys[newaty]=newssy#was removed preveously
	   else:
	    newssy=allatys[newaty]
	    ##print 'create_an_nei',ord,aty,newaty,atn,len(this),this.keys()
	   if True:
	    content=this[atn]
	    newssy.add_peak_simple(ord1,atn,content)
	    ##allatys[newaty]=newssy
	    self.neighbors[dnei]=newssy
	    newssy.neighbors[-dnei]=self
	    if newaty+dnei in allatys:newssy.neighbors[dnei]=allatys[newaty+dnei]

    def transfer_neighbor_assignments(self,aty,maxaty,allatys,ordrange=[0,-1],merge=False):
	'''transfers assignments from self to neighbors
	   also creates new spin systems as neighbors
	   and puts in the allatys dict'''
	for ord in ordrange:
	 if ord in self:
	   this=self[ord]
	   for atn in this:
	     if atn<>'X' and atn<>'N':
		self.add_peak_to_neighbor(ord,atn,aty,maxaty,allatys,merge=merge)

    def update_neighbor(self,prev,aty):
	self.neighbors[-1]=prev
	prev.neighbors[1] =self
	self.transfer_neighbor_assignments(aty,  None,None,ordrange=[-1])
	prev.transfer_neighbor_assignments(aty-1,None,None,ordrange=[0])

    def get_flatpeakdct(self,explst,fulldct=None,usenonspec=False):
	self.flatpeakdct={}
	patch=self.patch
	for i in self:
	  for atn in self[i]:
	    atas=self[i][atn]
	    if not isinstance(atas,MultiAtomAssignment):
	      reflst=atas[1]
	      for p in range(len(reflst)):
	       ref=reflst[p]
	       if ref<>None:
	        k,m=reflst[p]
		axis=atas[4][p]
		peak=explst[k].peakData.peaklist[m]
		if not (k,m) in self.flatpeakdct:
		  ##self.flatpeakdct[(k,m)]=[peak,i,{}]
		  self.flatpeakdct[(k,m)]=[peak,p,{}]#NOTE p is only valid for the first hit
		##self.flatpeakdct[(k,m)][2][axis]=atn
		self.flatpeakdct[(k,m)][2][axis]=(i,atn)
	    else:
	     for patas in atas:
	      reflst=patas[1]
	      for p in range(len(reflst)):
	       ref=reflst[p]
	       if ref<>None:
	        k,m=reflst[p]
		axis=patas[4][p]
		peak=explst[k].peakData.peaklist[m]
		if not (k,m) in self.flatpeakdct:
		  self.flatpeakdct[(k,m)]=[peak,p,{}]
		self.flatpeakdct[(k,m)][2][axis]=(i,atn)
	for i in self:
	  if usenonspec and i in self.nonspecdct:
	    xataslst=self.nonspecdct[i]
	    for q,patas in enumerate(xataslst):
	      reflst=patas[1]
	      for p in range(len(reflst)):
	       ref=reflst[p]
	       if ref<>None:
	        k,m=reflst[p]
		axis=patas[4][p]
		peak=explst[k].peakData.peaklist[m]
		if not (k,m) in self.flatpeakdct:
		  self.flatpeakdct[(k,m)]=[peak,p,{}]
		self.flatpeakdct[(k,m)][2][axis]=(i,'X')
		self.flatpeakdct[(k,m)][1]=patas#overwrite! to work in get_peak_aligns below
	##if fulldct<>None:fulldct.update(self.flatpeakdct)
	if fulldct<>None:self.update_fulldct(fulldct)

    def update_fulldct(self,fulldct):
	for ref in self.flatpeakdct:
	  if not ref in fulldct:fulldct[ref]=[]
	  try:fulldct[ref].append((self.assigned_type,self.flatpeakdct[ref][2]))
	  except AttributeError:fulldct[ref].append((None,self.flatpeakdct[ref][2]))

    def get_peak_aligns(self,explst,lw=UNCERTAINTY,doprint=True):
	self.alignscores={}
	self.istruedct={}
	for ref in self.flatpeakdct:
	  sum2=0.0
	  k,m=ref
	  peak,p,atndct=self.flatpeakdct[ref]
	  shs=peak.shifts
	  ##print k,m,self.label,len(atndct),atndct
	  for ax in atndct:
	    shx=shs[ax]
	    i,atn=atndct[ax]
	    if atn=='X':
	      atas=p##self.nonspecdct[i][p]#p could be wrong if not "fresh"...
	    else:
	      atas=self[i][atn]
	    if isinstance(atas,MultiAtomAssignment):sum2+=(lw*2)
	    else:
	      numshi=atas[2][2]
	      if numshi==1:sum2+=(lw**2)
	      else:
	        shi=atas[2][0]
	        if k<4: sum2+=    ((shx-shi)**2)
	        else:   sum2+=min([(shz-shi)**2 for shz in shs])
	  sum2/explst[k].dimension
	  sum2/(lw**2)
	  if doprint:
	    name='none'##getAsFormat(peak.names)
	    assityp=self.label
	    ##istrue,numas=self.has_true_assign(peak,assityp,atndct,symm=k>9)#generalize
	    if not self.label in ['na','nb']:
	      istrue,numas=self.has_true_assign(peak,self.label-1)
	    else:istrue='bad'
	    print 'align?: %15s %5s %2s'%(name,istrue,assityp),
	    print ('%7.3f '*len(shs))%tuple(shs),
	    print '%10s %3d %3d %6.3f'%(explst[k].name,k,m,sum2)
	  self.alignscores[ref]=sum2
	  self.istruedct[ref]=istrue#for debugging only

    def remove_peak(self,ref):
	peak,p,atndct=self.flatpeakdct[ref]
	##print 'removing peak:',ref,p,atndct
	for ax in atndct:
	    i,atn=atndct[ax]
	    more=False
	    if atn=='X':
	      atas=self.nonspecdct[i]
	      more=True
	    else:
	      atas=self[i][atn]
	    if isinstance(atas,MultiAtomAssignment) or more:
	      ##print 'is multiatas',ref
	      for atas0 in atas:
		if ref in atas0[1]:
		  ##print 'found ref:',ref
		  break
	      atas=atas0
	    pos=atas[1].index(ref)
	    for j in [0,1,4]:
	      atas[j].pop(pos)

    def strip_peaks_align(self,explst):
	scos=self.alignscores.items()
	its=[sco for sco in scos if sco[-1]>1.0]
	if len(its)==0:return 0,0,len(scos)
	vals=array([sco[-1] for sco in its])
	badind=argmax(vals)
	badsco=vals[badind]
	entrop=getentrop3(-vals)
	##scos.sort(lambda x,y: cmp(y[1],x[1]))
	badref=its[badind][0]
	if badsco<1.0:return 0,0,len(scos)
	istrue=self.istruedct[badref]
	##entrop=getentrop3(array([sco[-1] for sco in scos]))
	print 'stripstat',self.label,badref,badsco,entrop,sum(self.espins.values()),istrue
	##return self.strip_crude(scos)
	numbad=0;numgood=0
	return self.strip_iterative(explst,its,vals,numbad,numgood)

    def strip_iterative(self,explst,its,vals,numbad,numgood):
	its.sort(lambda x,y: cmp(y[1],x[1]))#largest first
	##print its
        pselec=ProbabilitySelector()
	badind,cprobt,badsco,ref=pselec.pselectpartner_rev(its)#using negative of its[-1]
	istrue=self.istruedct[ref]
	if True:
	  self.patch.remove(ref)
	  self.remove_peak(ref)
	  self.flatpeakdct.pop(ref)
	  istrue=self.istruedct[ref]
	  print 'peak removed',ref,badsco,istrue
	  if istrue:numgood+=1
	  else: numbad+=1
	curnum=len(self.flatpeakdct)
	if curnum<=5:
	  print 'stripresult',numbad,numgood,curnum,'num'
	  return numbad,numgood,curnum
	self.update_maintain()
	self.get_peak_aligns(explst)
	#prepare for next round
	scos=self.alignscores.items()
	its=[sco for sco in scos if sco[-1]>1.0]
	if len(its)==0:return numbad,numgood,curnum
	vals=array([sco[-1] for sco in its])
	badsco=max(vals)
	if badsco<1.0 or rand()<exp((1.0-badsco)/0.5):
	  print 'stripresult',numbad,numgood,curnum,'sco'
	  return numbad,numgood,curnum
	return self.strip_iterative(explst,its,vals,numbad,numgood)

    def strip_crude(self,scos):
	scos.sort(lambda x,y: cmp(y[1],x[1]))
	#now first try CRUDE stripping!
	cnt=0;numbad=0;numgood=0#false positives
	for ref,sco in scos:
	  if sco<1.0:break
	  cnt+=1
	  self.patch.remove(ref)
	  self.remove_peak(ref)
	  self.flatpeakdct.pop(ref)
	  if self.istruedct[ref]:numgood+=1
	  else: numbad+=1
	  if len(scos)-cnt<=5:break
	print 'stripresult',numbad,numgood,len(scos)-cnt
	return numbad,numgood,len(scos)-cnt

    def has_true_assign(self,peak,assityp,atndct=None,symm=False):
	return True,1
	if assityp=='na':return False,0
	if peak.allAssigns==None:
	  ##print 'warning: allAssigns is None'
	  return False,0
	for nams in peak.allAssigns:
	  found=False
	  atntrue=True
	  for n in range(len(nams)):
	    if not found:npasi=nams[n][0]
	    if nams[n][3]=='N':
		if atndct==None:break
		else:found=True
	    if atndct<>None:
	      if not symm:
	        try:atntrue&=(nams[n][3]==atndct[n][1])
	        except KeyError:print 'warning no key in atndct',n
	      else:
		axtrue=False
		for na in atndct:
		  if nams[n][3]==atndct[na][1]:
		    axtrue=True
		    break
		atntrue&=axtrue
	  if npasi-assityp==1:
	    if atndct==None or atntrue:return True,len(peak.allAssigns)
	return False,len(peak.allAssigns)

    hastrueas = staticmethod(has_true_assign)

    def eval_true_peaks(self,explst):
	patch=self.patch
	assityp=patch.assigned_type
	numtrue=0
	for ref in self.flatpeakdct:
		k,m=ref
		peak,i,atn=self.flatpeakdct[ref]
		name='none'##getAsFormat(peak.names)
		shs=peak.shifts
		pener=peak.assignenerlst[assityp]
		istrue,numas=self.has_true_assign(peak,assityp,atn,symm=k>3)#generalize
		##print 'eval: %15s %1d %2s %2d %4s'%(name,istrue,assityp,i,atn),
		print 'eval: %15s %1d %2s %2d'%(name,istrue,assityp,i),
		print ('%7.3f '*len(shs))%tuple(shs),
		print '%6s %6.3f %3d %3d  %1d'%(explst[k].name,pener,k,m,numas),atn
		if len(atn)<explst[k].dimension:print 'warning missing axis',ref,assityp,atn,shs
		if istrue:numtrue+=1
	nump=len(self.flatpeakdct)
	if nump==0:return -0.099,0,0
	return 1.0*numtrue/nump,nump,numtrue
	
    def eval_true_atom_assignments(self,explst):
	patch=self.patch
	assityp=patch.assigned_type
	for i in self:
	  for atn in self[i]:
	    if atn<>'X':
		k,m=self[i][atn][1][0]
		peak=explst[k].peakData.peaklist[m]
		name='none'##getAsFormat(peak.names)
		shs=peak.shifts
		pener=peak.assignenerlst[assityp]
		print 'eval: %15s %2s %2d %4s'%(name,assityp,i,atn),
		print ('%7.3f '*len(shs))%tuple(shs),
		print '%6s %6.3f %3d %3d'%(explst[k].name,pener,k,m)
	
    def compare_true(self,trueshifts,aas,lw=UNCERTAINTY):
	thr=lw
	miss=[];bad=[];sumdevs2=0.0;num=0
	misssc=[];badsc=[];sumdevs2sc=0.0;numsc=0
	for i in [0]:##,-1):
	  trui=trueshifts[i]
	  if aas[i]=='G':bbatns=['N','CA','C']#solid state
	  else:bbatns=['N','CA','C']##,'CB']
	  if i==-1:bbatns.remove('N')
	  if not i in self:miss+=bbatns
	  else:
	   for atn in bbatns:
	    if atn in trui:
	     if not atn in self[i]:miss.append(atn)
	     else:
	      vald=trui[atn][0]
	      stdd=trui[atn][1]
	      atas=self[i][atn]
	      atas.set_stats()
	      diff=abs(atas[2][0]-vald)
	      if diff>thr:bad.append((i,atn))
	      sumdevs2+=(diff**2);num+=1
	   for atn in trui:
	    if not atn in bbatns and atn[0]=='C':#side chain carbon (solid state)
	     if not atn in self[i]:misssc.append(atn)
	     else:
	      ##vald,stdd=trui[atn]
	      vald=trui[atn][0]
	      stdd=trui[atn][1]
	      atas=self[i][atn]
	      atas.set_stats()
	      diff=abs(atas[2][0]-vald)
	      if diff>thr:badsc.append((i,atn))
	      sumdevs2sc+=(diff**2);numsc+=1
	return miss,bad,sumdevs2,misssc,badsc,sumdevs2sc,num,numsc

    def get_etyp(self,aac,aap,dct,verb=False,patch=None,redo=False,expectfull=True,\
		 probminspec=0.05,probminx=0.1,probminx2=0.2,probbadcount=0.2):
	if verb:print 'getting type energy for',self.label,aac,aap
	if verb:self.show()
	k_least_plausible=2.0#.......?TODO: optimize this value
	##aas=(aap,aac)
	aas=(aac,aap)
	shifts=[dct[aa13dict[aa]] for aa in aas]
	self.etyps={0:0.0,-1:0.0}
	tot=0.0;tots=[0.0,0.0]
	if 0 in self and 'N' in self[0]:
	  drootsh,drootstd=shifts[0]['N']
	  orootsh,orootstd,ocnt=self[0]['N'][2]
	  tot=0.5*((drootsh-orootsh)/drootstd)**2
	  if verb:print 'nsdiff',drootsh,orootsh,tot,drootstd
	  tots[0]=tot
	else:print 'warning: no N shift',aac,aap,self
	eobs=0.75
	##eminspec=-log(0.05)#maybe even lower prob?
	eminspec=-log(probminspec)
	##specdct={0:['CA','C'],-1:['CA','C']}
	##specdct={0:['CA','C','CB'],-1:['CA','C']}
	specdct={0:['CA','C'],-1:['CA','C']}
	if HASCB:specdct[0].append('CB')
	iddct={0:{},-1:{}}
	assignamb={0:{},-1:{}}
	for i in [0,-1]:#CHECK: use only [0] in final stage?
	 if i in self:
	  specs=specdct[i]
	  current=self[i]
	  for atnc in current:
	    if not atnc in ['X','N'] and not atnc in specs:specs.append(atnc)
	  ##if verb:print 'current',i,current
	  for spatn in specs:
	   iddct[i][spatn]=False
	   if spatn in current:
	    atas=current[spatn]
	    try:
	      vald,stdd=shifts[i][spatn]
	      sdiff,remind=atas.compare_tovalue(vald,stdd,redo)
	      if redo and remind<>None:
		print 'preparing to remove ambigous atom assignment',spatn,remind,sdiff
		assignamb[i][spatn]=remind
	    except KeyError:
	      print 'WARNING: KeyError',i,spatn,aac,aap
	      sdiff=999
	    if verb:print 'sdiff',i,spatn,vald,sdiff,stdd
	    if sdiff-eobs<eminspec:
		tots[i]+=(sdiff-eobs)
		iddct[i][spatn]=True
	    else:
		tots[i]+=eminspec
	   else:
	    if spatn in shifts[i]:tots[i]+=k_least_plausible/2#spatn not in current:
	 else:tots[i]+=k_least_plausible#i not in self:
	tot=sum(tots)
	if verb:print 'tot is:',tot
	if tot>=9.0:
	  self.etyps={0:9.0,-1:9.0}
	  return 9.0,9.0#to save time

	totx=0.0
	totxs=[0.0,0.0]
	eminx =-log(probminx)
	eminx2=-log(probminx2)
	if patch<>None:self.missing={}#depricated var?
	assigndct={}
	for i in [0,-1]:
	 if i in self:
	   specs=specdct[i]
	   assigndct[i]=[]
	   assignlst=assigndct[i]
	   if patch<>None:self.missing[i]=[]
	   xataslst=self.nonspecdct[i]
	   valsxc=[atas[2][0] for atas in xataslst]
	   if verb:print valsxc
	   ##if len(valsxc[0])==0:totx+=k_least_plausible
	   ##else:
	   shi=shifts[i]
	   xatns=[k for k in shi if k[0]=='C' and (not k in specs)]## and (shi[k][0]<100 or shi[k][0]>160)]
	   #dont include aromatic carbons yet
	   if verb:print xatns
	   usedatns={}
	   for p,atas in enumerate(xataslst):#looping through the spinsystem
	      skip=False
	      shc=valsxc[p]
	      for pspatn,pval in atas[3]:
		if iddct[i][pspatn] and abs(pval-shc)<0.001:
		  skip=True
		  if redo:
		    assignlst.append([p,'X_'+pspatn,'r',0.0])
		    print 'preparing to remove assigned X atom',p,pspatn,shc
	      if not skip:
	        if len(xatns)>0:
	          minener,minatn=min([(0.5*((shc-shi[xatn][0])/shi[xatn][1])**2,xatn) for xatn in xatns])
		  #TODO: choose stochastically?
		  if minener-eobs<eminx:
		    totxs[i]+=(minener-eobs)
		    self.etyps[i]+=(minener-eobs)
		    if not minatn in usedatns:usedatns[minatn]=[]
		    usedatns[minatn].append(p)
		    if redo:
			assignlst.append([p,minatn,'a',minener])
			print 'preparing to assign atom',p,minatn,shc
		  else:
	            totxs[i]+=eminx
		    if redo:
			kp,mp=atas[1][0]
			##plab=patch[kp][mp]
			##print 'stripping?',p,minatn,plab,patch.label,shc,minener-eobs
			print 'stripping?',p,minatn,patch.label,shc,minener-eobs
			if minener-eobs>eminx*2:
			  ##print 'performing stripping',p,minatn,plab,patch.label,shc,minener-eobs
			  print 'performing stripping',p,minatn,patch.label,shc,minener-eobs
	      		  #TODO: decide stochastically whether to strip peak
			  ##patch.remove((kp,mp))
			  ##removedct[i].append((p,minatn))
			  assignlst.append([p,minatn,'r',minener])
	          if verb:print 'minener (rev)',i,shc,minener,minatn,shi[minatn],totxs[i]
	          ##if minatn in xatns:xatns.remove(minatn)
	        else:totxs[i]+=eminx
	      ##if verb:print 'non-used xatns',xatns
	   #end-for p,atas in enumerate(xataslst):#looping through the spinsystem
	   if tot+totxs[i]/2>10.0:
	     self.etyps={0:9.0,-1:9.0}
	     return tot,15.0-tot
	   shcs=[atas[2][0] for atas in xataslst]
	   for xatn in xatns:
	    if not xatn in usedatns:
	      xdb='BGDEZH'.index(xatn[1])-i
	      ##if i==0:eminx2=-log(0.25)*(1+1.0/(1+1.0*xdb))
	      if i==0 and expectfull:eminx2=-log(0.5)-log(0.25)*(1.0/(1+1.0*xdb))
	      else:eminx2=max(eminx-xdb,0.0)#will be 0.2 for CA-CD
	      if verb:print 'xdb is:',i,xatn,xdb,eminx2
	      match=False
	      if len(shcs)==0:totxs[i]+=eminx2
	      else:
	        shx,stdx=shi[xatn]
	        minener,minj=min([(0.5*((shcs[j]-shx)/stdx)**2,j) for j in range(len(shcs))])
		#TODO: choose stochastically?
	        totxs[i]+=min(minener-eobs,eminx2)
	        if verb:print 'minener',i,xatn,xdb,eminx2,shx,shcs[minj],minj,stdx,minener,totxs[i]
		if minener<3.0:match=True
	        if patch<>None and not match:
		  self.missing[i].append((xatn,shx,stdx))
	    else:
	      if len(usedatns[xatn])>1:
		shinds=usedatns[xatn]
		print 'count violation',i,xatn,len(shinds),shinds
		totxs[i]-=log(probbadcount)#OK?
		##if redo:
		  ##print 'stripping one of the two shifts to one atom'
		  ##assignlst.append([shinds,xatn,'c',None])
	   #end-for xatn in xatns:
	   if tot+totxs[i]/2>10.0:
	     self.etyps={0:9.0,-1:9.0}
	     return tot,15.0-tot
	 #end-if i in self:
	 else:totxs[i]+=k_least_plausible#not i in self
	totx=sum(totxs)
	if verb:print 'totx is:',totx
        if redo:
	  self.assignSpecific(assigndct,assignamb)
	  self.show()
	for direc in [0,-1]:
	  self.etyps[direc]=tots[direc]+totxs[direc]/2
	##return tot+(totx/2)
	return tot,totx

    def get_etyp_simple(self,j,explst):
	return sum([peak.assignenerlst[j] for peak in self.flatpeaklst])


class Patch(list):

    def __init__(self,i,j,direc='r'):
	##print 'initializing patch',self,i,j
	if direc=='r':pair=(i,j)
	else:pair=(j,i)
	list.__init__(self,pair)

    def add(self,i,direc='r'):
	##print 'extending patch',i,direc,
	if direc[0]=='r': self.append(i)
	else:self.insert(0,i)
	##print self

    def mergewith(self,other):
	self+=other


class PatchDict(dict):

    def __init__(self,pai=None,paj=None,lab='na',numexp=5):
	#TODO get numexp from len(explst) in all instances
	dict.__init__(self,[(n,{}) for n in range(numexp)])
	self.counts=[0 for n in range(numexp)]
	self.hlinked={}
	self.assigned_type=None
	self._dct={}
	if pai==None: return
	self[pai[0]][pai[1]]=lab	
	self.counts[pai[0]]=1
	if paj==None: return
	self[paj[0]][paj[1]]=lab	
	self.counts[paj[0]]=1
	self._dct={(pai,paj):lab}
	##self.assigned_link=[None,None]#left,right
	self.spin=None
	##print 'initializing patch',self,pai,paj

    def add(self,pai,paj=None,lab='na'):
	##print 'extending patch',pai
	if not pai[1] in self[pai[0]]:
	  self.counts[pai[0]]+=1
	self[pai[0]][pai[1]]=lab
	if paj<>None:
	  self._dct[(pai,paj)]=lab
	  print self,pai,paj

    def iter_items(self):
	for k in self:
	  for m in self[k]:
	    yield (k,m),self[k][m]

    def remove(self,pai):
	##print 'removing peak from PatchDict',pai
	if pai[1] in self[pai[0]]:
	  self[pai[0]].pop(pai[1])
	  self.counts[pai[0]]-=1
	else:print 'warning no such ref in patch',pai
	#also remove from has_patch?
	#also remove from self._dct ?

    def mergewith(self,other,pair,has_patch,lab='na'):
	maxCX=5
	##multi=[1,0,1,0,0]
	multi=[1,0,1,0,1]
	counts=[]
	for n in range(len(other)):
	  counts.append(len(self[n]))
	for q in range(len(multi)):
	  if (multi[q] and counts[q]>maxCX) or (not multi[q] and counts[q]>1):
	    print 'WARNING: number of counts exceeded (returning)',q,counts[q]
	    return False
	print 'merging patches',pair,lab
	for n in range(len(other)):
	  self[n].update(other[n])
	  for j in other[n]:has_patch[(n,j)]=has_patch[pair[1]]
	self._dct[pair]=lab
	self._dct.update(other._dct)
	self.counts=counts
	self.hlinked.update(other.hlinked)
	return True

    def setlabel(self):
	vals=self._dct.values()
	labs=set(vals)
	lnum=len(labs)
	if lnum==1:
	  maxlab=vals[0]
	  maxcnt=len(vals)
	else:
	  maxcnt=0;maxlab='nb'
	  for li in labs:
	   if li<>'na':
	    cnti=self._dct.values().count(li)
	    if cnti>maxcnt:
		maxcnt=cnti
		maxlab=li
	  if maxlab=='nb':
	    for n in range(len(self)):
	      for m in self[n]:
		maxlab=self[n][m]
		print 'found (single?) label:',maxlab
		##lnum=0;maxcnt=0
	self.label=maxlab;self.lnum=lnum;self.maxcnt=maxcnt

    def show(self,explst,createssy=True,pnum=None,showssy=True):
	print '---------- showing patch: %3s %1d %2d'%(self.label,self.lnum,self.maxcnt),
	if True:##self.lnum>1:
	  print set(self._dct.values()),pnum,self.hlinked
	  print self._dct
	##self.sort()
	print self
	numtrue=0;cnt=0
	for k in self:
	  for m in self[k]:
	     cnt+=1
	     ##lin=explst[k][m]
	     ##print '%15s %7s %7s %7s'%tuple(lin[:4]),k,m
	     peak=explst[k].peakData.peaklist[m]
	     peakasname='none'##getAsFormat(peak.names)
	     ##print peak.names,peak.shifts
	     print '%15s'%peakasname,
	     ##print '%7.3f %7.3f %7.3f'%peak.shifts,
	     print ('%7.3f '*len(peak.shifts))%tuple(peak.shifts),
	     print '%6s %3d %3d'%(explst[k].name,k,m),
	     if not self.label in ['na','nb']:
	       istrue,numas=SpinSystem.hastrueas('junk',peak,self.label-1)
	       print istrue
	       numtrue+=istrue
	     else:print 'bad'
	print 'counts:',self.counts
	##self.getspinsystem(explst)
	if createssy:
	  ssy=SpinSystem(self,explst)
	  ssy.numbad=cnt-numtrue
	  ssy.count=cnt
	  return ssy
	elif showssy:
	  ssy=self.spin
	  if ssy==None:print 'warning: no spin system assigned for patch'
	  else: ssy.show()


class GenericIndividual:

	pass

class DummyRA:

    def iter_assigned_spinsystems(self,ssa):
	for i in range(len(ssa.seq)-1):
	  if i in ssa.assigned_types:
	    yield ssa.assigned_types[i],ssa.toteners[i]


class ResonanceAssignment(GenericIndividual):

    def __init__(self,numres,numspinsyst,seq):
	self.numgenes=numres
	self.genestr='-'*self.numgenes
	self.numvalues=numspinsyst
	self.seq=seq
	self.linked={'l':{},'r':{}}
	self.typed={}
	self.hastype={0:'|0'}
	self.patches=[]
	self.disolved=False
	for i,r in enumerate(self.seq):
	  if r=='P':
	    ##print 'blocking proline',i
	    self.hastype[i]='|'+str(i)
	self.increner=0.0
	self.cons=None
	
    def get_brother(self,scheme):
	ra=ResonanceAssignment(len(self.seq),len(scheme.spindct),self.seq)
	ra.genestr=self.genestr
	ra.energy=self.energy
	ra.buildfromstr()
        scheme.transfer_nearest2ra(ra)
	ra.edct=self.edct##dict(self.edct.items())
	return ra
	##ra.recalculate_score(scheme.linkdct,scheme.typedct,scheme.skeys)

    def settype(self,i,j):
	if j>=len(self.seq):print 'WARNING: invalid typing:',i,j
	##if i in self.typed: print 'WARNING: allready typed:',i,j,self.typed[i]
	if i in self.typed:
	  if j<>self.typed[i]:print 'WARNING: allready typed:',i,j,self.typed[i]
	##if j in self.hastype: print 'WARNING: allready has a type:',i,j,self.hastype[j]
	if j in self.hastype:
	  if i<>self.hastype[j]:print 'WARNING: allready has a type:',j,i,self.hastype[j]
	self.typed[i]=j
	self.hastype[j]=i

    def setlink(self,direc,i,j):
	omet={'r':'l', 'l':'r'}
	if isinstance(i,str) or isinstance(j,str):
	  print 'note: linking to proline',direc,i,j
	  #linking is still "syntaxially" needed so dont break out here!
	dir1=omet[direc]
	if i in self.linked[direc]:
	  print 'WARNING: allready linked:',i,j,direc,self.linked[direc][i]
	if j in self.linked[dir1]:
	  print 'WARNING: allready linked:',i,j,dir1, self.linked[dir1][j]
	self.linked[direc][i]=j
	self.linked[dir1][j]=i

    def recalculate_score(self,linkdct,typdct,skeys,badlst=[],xnear=False):
	##print self.linked['r'].items()
	##print self.linked['l'].items()
	styp=0.0;slin=0.0;viol=0.0
	edct={}
	for k in self.typed:
	  try:
	    tk=self.typed[k]
	    styp+=typdct[k][tk]
	    if xnear and tk in self.typenearest[k]:self.typenearest[k].pop(tk)
	    edct[tk]=typdct[k][tk]
	  except KeyError:styp+=99.9
	  except IndexError:styp+=99.9
	for direc in 'l':##'lr':
	  #only use left direc - both dirs will duplicate!
	  for i in self.linked[direc]:
	   j=self.linked[direc][i]
	   if not (isinstance(i,str) or isinstance(j,str)):
	     if i in self.typed and j in self.typed:
	       if direc=='l':
		 try:
		   lnij=linkdct[i][j]
		   slin+=lnij
		   ti=self.typed[i]
		   tj=self.typed[j]
		   edct[ti]+=(lnij/2)
		   edct[tj]+=(lnij/2)
		 except KeyError:slin+=99.9
	         if xnear and j in self.linknearest[i]:self.linknearest[i].pop(j)
	      ##else:         slin+=linkdct[j][i]
	if xnear:
	  print 'removed forbidden nearest'
	  return
	nontyped=[]
	for i,gi in enumerate(skeys):
	  if not i in self.typed:
	   if not i in badlst:
	    ##viol+=50.0
	    ##viol+=10.0#not assigning spin system is reasonably OK now
	    viol+=1.0#not assigning spin system is reasonably OK now
	for i,code in enumerate(self.genestr):
	  if 0<i<len(self.genestr)-1 and self.genestr[i-1]=='-' and self.genestr[i+1]=='-':
	    print 'penalizing non-linked',i,code
	    viol+=3.0
	viol+=(self.dupnum*3.0)
	eners=array((styp,slin,viol))/len(self.seq)
	tot=sum(eners)
	print 'recalculated score: %7.4f %7.4f %7.4f  %7.4f'%tuple(list(eners)+[tot])
	self.energy=tot
	##print 'edct:',edct
	self.edct=edct

    def gettripener(self,tripenerdct,rcdct,spindct,skeys,seq):
	T_0=time.time()
	##rootnames=['HA','N','H']
	csumdct={}
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	wrongs=0;cnt=0
	for i in range(len(seq)):
	  c=self.genestr[i]
	  if c<>'|':
	    try:
		if c<>prnstr[cnt]:wrongs+=1
	        cnt+=1
	    except IndexError:cnt+=1
	  if False:##i in self.hastype: TAKEBACK
	    j=self.hastype[i]
	    if isinstance(j,int):
	      spin=spindct[skeys[j]]
	      rcj=spin.rootcoords
	      aa=seq[i]
	      val=(rcj[0]-rcdct[aa]['HA'])+(rcj[2]-rcdct[aa]['H'])+(0.1*(rcj[1]-rcdct[aa]['N']))
	      csumdct[i]=val
	tot=0.0
	for i in range(1,len(seq)-1):
	  if i in self.hastype:
	    resn=aa13dict[seq[i]]
	    if i-1 in csumdct and i+1 in csumdct and i in csumdct:
	      tup=[csumdct[i+di] for di in (-1,0,1)]
	      ##print i,resn,tup
	      if seq[i] in 'PX|':tener=10.0
	      else:tener=getener(tup,tripenerdct[seq[i]],1)
	      ##print 'residue triplet energy %2d %s %6.3f'%(i,resn,tener)
	      tener=min(5,tener-3.0)
	      tot+=tener
	tot/=len(seq)
	tot/=2.0#OK?
	print 'updated score: %2d %7.4f %7.4f  %7.4f'%(wrongs,self.energy,tot,self.energy+tot)
	##print 'ttim used:',time.time()-T_0
	return tot

    def stripbad(self,linkdct,typdct,limit=7.0):
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	maxk=None;maxtot=limit
	for k in self.typed:
	  tot=typdct[k][self.typed[k]]
	  if k in self.linked['l']:
	    j=self.linked['l'][k]
	    if not isinstance(j,str):
	      tot+=linkdct[k][j]
	  if tot>maxtot:
	    maxtot=tot;maxk=k
	if maxk<>None:
	  t=self.typed[maxk]
	  del self.typed[maxk]
	  del self.hastype[t]
	  if maxk in self.linked['l']:
	    j=  self.linked['l'][maxk]
	    del self.linked['l'][maxk]
	    del self.linked['r'][j]
	  else:j=None
	  code=prnstr[maxk]
	  self.genestr=self.genestr.replace(code,'-')
	  print 'found bad:',maxk,t,j,maxtot,code
	  return maxtot
	else:return None

    def stripAllBad(self,linkdct,typdct):
	tot=0.0;incr=0.0;maxtot=7.0
	while True:
	  incr=self.stripbad(linkdct,typdct,maxtot)
	  if incr<>None:
	    tot+=incr
	    maxtot+=1
	  else:
	    print 'total increment:',tot/len(self.seq)
	    break

    def reproduce(self):
	ra=ResonanceAssignment(self.numgenes,self.numvalues,self.seq)
	ra.genestr=self.genestr
	ra.buildfromstr()
	return ra

    def fillFromConsensus(self,thr=0.9):
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
        selec=ProbabilitySelector()
	strdct={0:'|'}
	for i,r in enumerate(self.seq):
	  if r=='P':strdct[i]='|'
	  else:strdct[i]='-'
	for j in self.cons.consp:
	  vals=self.cons.consp[j]
	  if vals[0][0]>=thr:
	    code=prnstr[j]
	    n,probi,i,ei=selec.selectpartner(vals,doexp=False)
	    strdct[i]=code
	st=''
	for i in range(len(self.seq)):st+=strdct[i]
	print st
	self.genestr=st

    def recombine(self,other,pcross=0.12,pstrip=0.2,pcorr=0.6):
	genestr=''
	pair=[self,other]
	curnum=0
	for n in range(2):
	  ##pair[n].showstate('prev'+str(n))
	  print 'prev'+str(n)+': >>>'+pair[n].genestr
	skipped=0
	N=len(self.seq)
	for i in range(N):
	  ptest=rand()
	  if ptest<pcross:curnum=1-curnum#swap direction
	  code=pair[curnum].genestr[i]
	  ##if code in genestr and code<>'|':genestr+='-';skipped+=1
	  ##else:genestr+=code
	  genestr+=code
	cntdct={}
	print 'recom: <<<'+genestr
	for i,code in enumerate(genestr):
	  if code<>'|':
	    if not code in cntdct:cntdct[code]=[]
	    cntdct[code].append(i)
	striplst=[]
	for cd in cntdct:
	  if len(cntdct[cd])>1:
	    ind=randchoice(cntdct[cd])
	    striplst.append(ind)
	    skipped+=1
	recom=''
	for i,code in enumerate(genestr):
	  if i in striplst:recom+='-'
	  else:recom+=code
	print 'recos: <<<'+recom
	if skipped*1.0/N<pstrip:
	  pstrip=(pstrip*N-skipped)/N
	  x=pcorr/(1-pcorr)
	  psc=pstrip/(1+x)
	  print 'befor skipped:',skipped,skipped*1.0/N,pstrip,psc
	  stripped=''
	  for i,code in enumerate(recom):
	    prev=None
	    ptest=rand()
	    pcmp=psc
	    if code in '|-':stripped+=code
	    else:
	      if prev==i-1:pcmp=pcorr
	      if ptest<pcmp:
	        stripped+='-'
	        skipped+=1
	      else:stripped+=code
	    prev=i
	else:stripped=recom
	print 'strip: <<<'+stripped
	print 'total skipped:',skipped,skipped*1.0/N
	ra=ResonanceAssignment(self.numgenes,self.numvalues,self.seq)
	ra.genestr=stripped
	ra.buildfromstr()
	return ra

    def showstate(self,lab='state',showener=True):
	##print self.typed
	self.dupnum=0
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	tvals=self.typed.values()
	for k in self.typed:
	  i=self.typed[k]
	  if tvals.count(i)>1 and isinstance(k,int):
	    print 'WARNING: duplicate typing',k,prnstr[k],i
	    self.dupnum+=1
	for direc in 'rl':
	 lvals=self.linked[direc].values()
	 for k in self.linked[direc]:
	  i=self.linked[direc][k]
	  if lvals.count(i)>1 and isinstance(k,int):
	    print 'WARNING: duplicate linking',direc,k,prnstr[k],i
	    self.dupnum+=1
	pstr=''
	for i in range(len(self.seq)):
	  if i in self.hastype:
	    k=self.hastype[i]
	    if isinstance(k,str):pstr+='|'
	    else:pstr+=prnstr[k]
	  else:pstr+='-'
	self.genestr=pstr
	if lab=='state':
	  for pt in self.patches:
	    pstr+=' '
	    for j in pt: pstr+=prnstr[j]
	else:
	  ##pstr+=(' %7.4f'%(self.increner/len(self.seq)))
	  if showener:
	    pstr+=(' %7.4f'%self.energy)
	  print 'oldener',self.increner/len(self.seq)
	print lab+': <<<'+pstr

    def strip_peaks(self,seq,typdct,ssa,verb=False):
	skeys=ssa.keylst
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	for i in range(len(self.seq)):
	  assigned=False
	  if not i in self.hastype:print '--------------------------------------',i
	  else:
	    j=self.hastype[i]
	    if not isinstance(j,int):print '***********************************',i,j
	    else:
	      assigned=True
	      codej=prnstr[j]
	      key=skeys[j]
	      lab,pnum=key
	      patch=ssa.patches[pnum]#the group of peaks
	      spin=ssa.spindct[j]
	      patch.spin=spin
	      spin.patch=patch#circular referencing
	      aajc=seq[i]
	      aajp=seq[i-1]
	      if key[0]=='na':istrue=False
	      else:istrue=key[0]-i==0
	      if verb:print 'recalculating etyp',i,j,key,aajc,aajp,spin.label
	      #TODO: implement stochastical decission whether to strip peak
	      etbb,etsc=spin.get_etyp(aajc,aajp,shdct,verb=True,patch=patch,redo=True)
	      #TODO: faster if non-matching shift are kept from the first run
	      if verb:print 'result etyp %2d %2d %1d %7.4f %7.4f'%(i,j,istrue,typdct[j][i],etbb+etsc),
	      if verb:print aajc,aajp,key,spin.label
	      patch.assigned_type=i-1#NOTE: was i
	      #TODO:patch.assigned_link=...
	  ##if not assigned:'do something with the "hole"'

    def iter_assigned_spinsystems(self,ssa,etotmax=10.0):
	for i in range(len(self.seq)):
	  if i in self.hastype:
	    j=self.hastype[i]
	    if isinstance(j,int):
	      etot=ssa.typeeners[i]+ssa.spineners[i]+ssa.linkeners[i]
	      ##print i,j,etot
	      if etot<etotmax:
	        spin=ssa.spindct[j]
		##print dir(spin)
		##print spin.__class__
	        yield spin,etot

    def recalculate_energy(self,seq,typdct,ssa,explst):
	skeys=ssa.keylst
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	self.fullpeakdct={}
	totscore=0.0
	ssa.typeeners=zeros(len(seq))
	ssa.spineners=zeros(len(seq))
	ssa.linkeners=zeros(len(seq))
	totbadpeaks=0;alltot=0
	sumtruefrac=0.0
	for i in range(len(self.seq)):
	  assigned=False
	  if not i in self.hastype:print '--------------------------------------',i
	  else:
	    j=self.hastype[i]
	    if not isinstance(j,int):print '***********************************',i,j
	    else:
	      assigned=True
	      codej=prnstr[j]
	      key=skeys[j]
	      lab,pnum=key
	      patch=ssa.patches[pnum]#the group of peaks
	      spin=ssa.spindct[j]
	      aajc=seq[i]
	      aajp=seq[i-1]
	      if key[0]=='na':istrue=False
	      else:istrue=key[0]-i==0
	      print 'recalculating etyp',i,j,key,aajc,aajp,spin.label
	      etbb,etsc=spin.get_etyp(aajc,aajp,shdct,verb=True,patch=patch,redo=True)
	      spin.assigned_type=i
	      spin.get_flatpeakdct(explst,self.fullpeakdct)
	      espin=spin.get_espinsystem()
	      eval_true,nump,numtrue=spin.eval_true_peaks(explst)
	      alltot+=nump
	      print 'result etyp %2d %2d %1d %7.4f %7.4f %7.4f %6.3f'%\
		     (i,j,istrue,typdct[j][i],etbb+etsc,1.00*espin,eval_true),
	      print aajc,aajp,key,spin.label,patch.assigned_type
	      listrue=False;elink=3.0;jp=-1
	      ssa.typeeners[i]=etbb+etsc
	      ssa.spineners[i]=1.00*espin
	      if i>0 and i-1 in self.hastype:
		jp=self.hastype[i-1]
		if isinstance(jp,int):
		  spinp=ssa.spindct[jp]
		  elink=spin.get_elink(spinp,verb=True,redo=True,probminspec=0.1,probminx=0.3)
		  if skeys[j][0]=='na' or skeys[jp][0]=='na':listrue=False
		  else:listrue=skeys[j][0]-skeys[jp][0]-1==0
		  print 'result elink for %2d %2d %7.4f %1d'%(j,jp,elink,listrue),skeys[j],skeys[jp]
	          ssa.linkeners[i]=elink
	      else:
	          ssa.linkeners[i]=2.0
	      etot=etbb+etsc+elink+1.00*espin
	      print 'result total %2d %2d %2s %1d %1d %7.4f %7.4f %7.4f %7.4f %6.3f'%\
		    (i,j,jp,istrue,listrue,etbb+etsc,1.00*espin,elink,etot,eval_true)
	      totscore+=etot
	      sumtruefrac+=eval_true
	      totbadpeaks+=(nump-numtrue)
	return totscore,totbadpeaks,sumtruefrac,alltot

    def showassignments(self,spindct,seq,skeys,typedct,linkdct):
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	outfile=open('assigns37b.str','w')
	outalos=open('talos37b.tab','w')
	cnt=1
	for i in range(len(self.seq)):
	  assigned=False
	  if not i in self.hastype:print '--------------------------------------'
	  else:
	    j=self.hastype[i]
	    if not isinstance(j,int):print '***********************************'
	    else:
	      assigned=True
	      codej=prnstr[j]
	      key=skeys[j]
	      spin=spindct[key]
	      elink=0.000
	      if i>0 and i-1 in self.hastype:
		pj=self.hastype[i-1]
		if isinstance(pj,int):elink=linkdct[j][pj]
	      etyp=typedct[j][i]
	      lin='%1s %2d %2d %1s %3s %6.3f %6.3f '%(seq[i],i+1,j,codej,key,elink,etyp)
	      ##print dir(spin)
	      lin+='%6.3f %6.3f %6.3f'%spin.rootcoords
	      rootnames=['HA','N','H']
	      resn=aa13dict[seq[i]]
	      for n,atname in enumerate(rootnames):
		elem=atname[0]
		val=spin.rootcoords[n]
		if atname=='N':val-=spin.aliased
		outfile.write('%3d %2d %3s %4s %1s %6.2f . 1\n'%(cnt,i+1,resn,atname,elem,val))
		outalos.write('%4s %1s    %4s     %8.2f\n'%(i+1,seq[i],atname,val))
		cnt+=1
	      hdct=spin.hetdct
	      if not 'C13' in hdct:lin+=('   0.00'*3)
	      else:
		elem='C'
	        for atpair in [('CA','0'),('CB','0'),('C','-1')]:
		  atname=atpair[0];off=string.atoi(atpair[1])
  		  if atpair in hdct['C13']:
		    specres=aa13dict[seq[i+off]]
		    val=hdct['C13'][atpair]; lin+=' %6.2f'%val
		    outfile.write('%3d %2d %3s %4s %1s %6.2f . 1\n'%(cnt,i+1+off,specres,atname,elem,val))
		    outalos.write('%4s %1s    %4s     %8.2f\n'%(i+1+off,seq[i+off],atname,val))
		    cnt+=1
  		  elif (atpair[0],'na') in hdct['C13']:
		    val=hdct['C13'][(atname,'na')]; lin+=' %6.2f'%val
		    outfile.write('%3d %2d %3s %4s %1s %6.2f . 1\n'%(cnt,i+1,resn,atname,elem,val))
		    outalos.write('%4s %1s    %4s     %8.2f\n'%(i+1,seq[i],atname,val))
		    cnt+=1
  		  else:lin+=('   0.00')
  	        for atpair in [('CA','-1'),('CB','-1')]:
  		  if atpair in hdct['C13']:lin+=' %6.2f'%hdct['C13'][atpair]
  		  elif (atpair[0],'na') in hdct['C13']:lin+=' %6.2f'%hdct['C13'][(atpair[0],'na')]
  		  else:lin+=('   0.00')
	      print lin
	  if not assigned:
	    if i+1 in self.hastype and isinstance(self.hastype[i+1],int):
	      resn=aa13dict[seq[i]]
	      j=self.hastype[i+1]
	      spin=spindct[skeys[j]]
	      hdct=spin.hetdct
	      if 'C13' in hdct:
		elem='C'
  	        for atpair in [('CA','-1'),('CB','-1')]:
		  atname=atpair[0]
		  val=None
  		  if atpair in hdct['C13']:
		    val=hdct['C13'][atpair]
  		  elif (atpair[0],'na') in hdct['C13']:
		    val=hdct['C13'][(atpair[0],'na')]
		  if val<>None:
		    outfile.write('%3d %2d %3s %4s %1s %6.2f . 1\n'%(cnt,i+1,resn,atname,elem,val))
		    outalos.write('%4s %1s    %4s     %8.2f\n'%(i+1,seq[i],atname,val))
		    cnt+=1
	      	    assigned=True
	    if not assigned:
		    outfile.write('%3d %2d %3s %4s %1s  999  . 1\n'%(cnt,i+1,resn,atname,elem))
		    cnt+=1
	outfile.close()

    def buildfromstr(self):
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	for n in range(len(self.seq)):
	  code=self.genestr[n]
	  if code<>'-':
	    if code<>'|':
	      i=prnstr.index(code)
	      self.settype(i,n)
	    else:i='|'+str(n)
	    if n<len(self.seq)-1:
	      code1=self.genestr[n+1]
	      if code1<>'-':
		if code1<>'|':j=prnstr.index(code1)
		else:j='|'+str(n+1)
		self.setlink('r',i,j)
	self.showstate('clone',showener=False)

    def eval_diff(self,other):
	gs0=self.genestr
	gs1=other.genestr
	sumdi=0.0
	for i in range(len(gs0)):
	  sumdi+=(gs0[i]<>gs1[i])
	return sumdi

    def apply_prelits(self,linkdct,typedct,skeys,prelits):
	for direc,i,j in prelits:
          tits,lits,popts,ptvars=self.choice_link('l',i,j)
          tot=self.get_score(tits,lits,typedct,linkdct,ptvars)
	  self.execute_choice(tits,lits,popts)
	  if ptvars<>None:self.execute_patch_connections(*ptvars)
	  self.increner+=tot

    def getvalues_link(self,i,typedct,linkdct,dir0,nearest=None):
	#bug for dir0=='r' ?
	es=[]
	pnj=None
	#was dir0=='l':li=linkdct[i] else rev[i]
	dir1={'r':'l','l':'r'}[dir0]
	##for j in li:
	##for j in linkdct:
	for j in nearest:
	 if j<>i:
	  if self.cons==None or (not i in self.cons.linked[dir0] or j in self.cons.linked[dir0][i]):
	   if not j in self.linked[dir1]:
	    if not (j in self.typed and i in self.typed):
		tits,lits,popts,ptvars=self.choice_link(dir0,i,j)
		tot=self.get_score(tits,lits,typedct,linkdct,ptvars)
		##tot=nearest[j]
		##if tot==0.0 and dir0=='l':print 'warning tot is 0.0',i,j
	        ##es.append((li[j],j))
		es.append((tot,j))
	if len(es)==0:
	   print 'no possible links',dir0,i
	   return None
	return es
	
    def get_score(self,tits,lits,typedct,linkdct,ptvars):
	tot=0.0
	if len(tits)==0 and len(lits)==0:print 'warning no typing/linking'
	for I,K in set(tits):#do typing
	  if K in self.hastype:tot+=99.999
	  elif K>=len(self.seq) or K<0:tot+=99.999
	  else:
	    try:tot+=typedct[I][K]
	    except KeyError:
		print 'WARNING: no such key in linkdct',i,j
		tot+=99.9
	    ##print I,K,typedct[I][K]
	    if self.cons<>None:
	      if not K in self.cons.typdct[I]:
		tot-=log(1.0/self.cons.num)#99.999
	      else:
		tot-=log(1.0*self.cons.typdct[I][K]/self.cons.num)#99.999
	#now the links...
	for dir0,i,j in set(lits):
	  if not (isinstance(i,str) or isinstance(j,str)):
	    if dir0=='l':
		if i in self.linked['l']:
		  print 'note: allready linked:',i,j,self.linked['l'][i]
		try:tot+=linkdct[i][j]
		except KeyError:
		  print 'WARNING: no such key in linkdct',i,j
		  tot+=99.9
	        if self.cons<>None:
		  if i in self.cons.linked['l']:
	            if not j in self.cons.linked['l'][i]:
		      tot-=log(1.0/self.cons.num)#99.999
	            else:
		      tot-=log(1.0*self.cons.linked['l'][i][j]/self.cons.num)#99.999
	    ##else:        tot+=linkdct[j][i] #duplicate!
	#penalizing circular patching
	if ptvars<>None:
	  patchi,patchj,pni,pnj,dir0,i,j=ptvars
	  if pni<>None and pni==pnj:
	    ##print 'circular patching:',pni,pnj
	    tot+=99.999
	return tot

    def get_bonus(self,numt,numl,nump,prevener):
	totnum=numt+numl
	##return max(0,(totnum-2)*1.0)
	return max(0,(numt-1)*1.0)
	##if numt<=1:return 0.0
	##return (1-1/numt)*prevener
	

    def getvalues_type(self,i,typedct,linkdct,nearest,verb=False):
	es=[]
	if i in self.linked['l']:return None #left side of patch
	if verb:print 'getting type values for',i,nearest
	##for k in typedct[i]:
	for k in nearest:
	 if self.cons==None or k in self.cons.typdct[i]:
	  if not k in self.typed.values():#alternatively duplicate use of typing is allowed
	    tits,lits,popts,ptvars=self.choice_type(i,k)
	    tot=self.get_score(tits,lits,typedct,linkdct,ptvars)
	    if verb:print 'typscore',k,self.seq[k],typedct[i][k],tot
	    ##tot=nearest[k]
	    ##print k,tot,
	    if tot<90:es.append((tot,k))
	if len(es)==0:
	   print 'no possible typings',i
	   return None
	return es
	
    def getentrop(self,es,scale=None):
	eners=array(es)[:,0]
	if min(eners)<6.0: #its better check the min, but slower
	##eners=array(es+[(6.0,999)])[:,0]
	  eners=hstack((eners,array((6.0))))
	if scale<>None:eners*=scale
	##ps=exp(-array(es))[:,0]
	ps=exp(-eners)
	ps/=sum(ps)
	es1=-log(ps)
	##for n in range(len(ps)):
##		if ps[n]==0.0:es1[n]=0.0
	return sum(ps*es1)
	
    def ispatched(self,i,direc):
	pn=None;patch=[]
	if i in self.linked[direc]:
	  for pnum,pt in enumerate(self.patches):
	    if (direc=='r' and i==pt[0]) or\
	       (direc=='l' and i==pt[-1]):  pn=pnum;patch=pt
	return pn,patch

    def extendTypingInPatch(self,j,direc,patch,pn,i,deltar=1):
	#patch can be empty => no action
	seqi=self.typed[i]
	for ind,ip in enumerate(patch):
	  if direc=='r':self.settype(ip,seqi+ind+deltar)
	  else:         self.settype(ip,seqi+ind-len(patch))
	if pn<>None:self.patches.pop(pn)

    def findTypingInPatch(self,seqi,direc,patch,i,tits,deltar=1):
	#patch can be empty => no action
	for ind,ip in enumerate(patch):
	  if direc=='r':tits.append((ip,seqi+ind+deltar))
	  else:         tits.append((ip,seqi+ind-len(patch)))

    def disolve_patches(self,linkdct,typedct):
	self.disolved=True
	while len(self.patches)>0:
	  patch=self.patches[0]
	  for ind,ip in enumerate(patch):
	    if ind>0:
	      if ip in self.linked['l']:#it should be!
		print 'releasing link:',ind,ip,'l',self.linked['l'][ip]
		self.linked['l'].pop(ip)
	    if ind<len(patch)-1:
	      if ip in self.linked['r']:
		print 'releasing link:',ind,ip,'r',self.linked['r'][ip]
		self.linked['r'].pop(ip)
	
	  for ip in patch:
	    for j in self.linknearest[ip]:
    		tot,tits,lits,popts,ptvars=self.getlinkener(ip,j,typedct,linkdct)
	        self.linknearest[j][ip]=tot#overwrite
	    for k in self.typenearest[ip]:
		tot,tits,lits,popts,ptvars=self.gettypener(ip,k,typedct,linkdct)
		if ptvars<>None and ptvars[2]<>None and ptvars[2]==ptvars[3]: tot=99.9
		self.typenearest[ip][k]=tot
	  self.patches.pop(0)

    def release_single(self,t,i):
	print 'removing residue:',t,i
	##i=self.hastype[t]
	self.hastype.pop(t)
	try:self.typed.pop(i)
	except KeyError:print 'WARNING no type key',t,i
	if i in self.linked['l']:
	  j=self.linked['l'][i]
	  self.linked['l'].pop(i)
	  try:self.linked['r'].pop(j)
	  except KeyError:
	    print 'WARNING no link key (r)',i,j
	if i in self.linked['r']:
	  j=self.linked['r'][i]
	  self.linked['r'].pop(i)
	  try:self.linked['l'].pop(j)
	  except KeyError:
	    print 'WARNING no link key (l)',i,j

    def remove_grow(self,scheme,numrem=5):
	remlst=[]
	choicelist=[(self.edct[t],t) for t in self.edct]
	choicelist.sort(lambda x,y: cmp(y[0],x[0]))#reverse
        selec=BestSelector(len(choicelist)/3.0)
	while len(remlst)<numrem:
	  ##t=randchoice(self.hastype.keys())
	  maxi,bestprob,t,minener=selec.selectpartner(choicelist)
	  print 'selectingrem',maxi,bestprob,t,minener,len(choicelist)
	  if t in self.hastype:
	   i=self.hastype[t]
	   if isinstance(i,int):
	    self.release_single(t,i)
	    remlst.append(t)
	    choicelist.pop(maxi)
	  else: print 'WARNING: type not found',t
	print 'removed residues:',remlst
	self.grow(scheme,initcnt=60)

    def execute_choice(self,tits,lits,pops):
	##print tits
	for i,j in tits:
	  self.settype(i,j)
	for direc,i,j in lits:
	  self.setlink(direc,i,j)
	for popn in pops:
	 if popn<>None:
	  self.patches.pop(popn)

    def transfer_nearest_exclforbid(self,ra):
	ra.linknearest=dict([(k,{}) for k in self.linknearest])
	ra.typenearest=dict([(k,{}) for k in self.typenearest])
	ra.linknearestrev=dict([(k,{}) for k in self.linknearestrev])
	ra.typenearestrev=dict([(k,{}) for k in self.typenearestrev])
	for i in self.linknearest.keys():
	  for j in self.linknearest[i].keys():
	    if self.linknearest[i][j]<10.0:pass

    def remove_forbidden_nearest(self):
	for i in self.linknearest.keys():
	  for j in self.linknearest[i].keys():
	    if self.linknearest[i][j]>90.0:
		self.linknearest[i].pop(j)
	for i in self.typenearest.keys():
	  for j in self.typenearest[i].keys():
	    if self.typenearest[i][j]>90.0:
		self.typenearest[i].pop(j)

    def update_nearest(self,method,tits0,lits0,pops0,ptvars0,i0,j0,linkdct,typedct):
	for i,j in tits0:
	  self.typenearest[i][j]=99.99
	  for k in self.linknearest[i]:
             tot,tits,lits,popts,ptvars=self.getlinkener(i,k,typedct,linkdct)
	     if ptvars<>None and ptvars[2]<>None and ptvars[2]==ptvars[3]:
		tot=99.9;##print 'penalizing circular patching',i,k
	     self.linknearest[i][k]=tot#overwrite
	     ##print 'updating linking (l)',i0,j0,i,k,tot
	     ##if i-k-1==0 and tot>90.0:
		##print 'Warning: overwriting good score (l)',i0,j0,i,k,tot,
		##print self.linked['l'][i]==k,self.linked['l'][i]
	  for k in self.linknearestrev[i]:
             tot,tits,lits,popts,ptvars=self.getlinkener(k,i,typedct,linkdct)
	     if ptvars<>None and ptvars[2]<>None and ptvars[2]==ptvars[3]:
		tot=99.9;##print 'penalizing circular patching',i,k
	     self.linknearestrev[i][k]=tot#overwrite
	     self.linknearest[k][i]=tot#overwrite
	     ##print 'updating linking (r)',i0,j0,i,k,tot
	     ##if k-i-1==0 and tot>90.0:
		##print 'Warning: overwriting good score (r)',i0,j0,i,k,tot,
		##print self.linked['l'][k]==i,self.linked['l'][k]
	  for delta in [-1,1]:#TODO: debug this with worse data
	    t=j+delta
	    if not t in self.hastype:
	      if t in self.typenearestrev:
		for k in self.typenearestrev[t]:#k is the spin system
		  tot,tits,lits,popts,ptvars=self.gettypener(k,t,typedct,linkdct)
		  ##print 'updating typing (neighbor)',i0,j0,i,j,k,delta,tot
		  self.typenearest[k][t]=tot
		  if delta==-1:
             	    tot,tits,lits,popts,ptvars=self.getlinkener(i,k,typedct,linkdct)
		    ##print 'updating linking (neighbor)',i0,j0,i,j,k,delta,tot
		    if k in self.linknearest[i]:self.linknearest[i][k]=tot
		  elif delta==1:
             	    tot,tits,lits,popts,ptvars=self.getlinkener(k,i,typedct,linkdct)
		    ##print 'updating linking (neighbor)',i0,j0,i,j,k,delta,tot
		    if i in self.linknearest[k]:self.linknearest[k][i]=tot
	for direc,i,j in lits0:
	  ##print method,i0,j0,(direc,i,j)
	  if isinstance(i,int):
	   if direc=='r':
	     for k in self.linknearest[i]:
               tot,tits,lits,popts,ptvars=self.getlinkener(i,k,typedct,linkdct)
	       self.linknearest[i][k]=tot#overwrite
	       ##print 'updating linking within link (r)',i0,j0,i,k,tot
	   elif direc=='l':
	     for k in self.linknearestrev[i]:
               tot,tits,lits,popts,ptvars=self.getlinkener(k,i,typedct,linkdct)
	       self.linknearest[k][i]=tot#overwrite
	       ##print 'updating linking within link (l)',i0,j0,i,k,tot
	   if isinstance(j,int):
	     if direc=='r'   and j in self.linknearest[i]:self.linknearest[i][j]=99.9
	     elif direc=='l' and i in self.linknearest[j]:self.linknearest[j][i]=99.9
	   if not i in self.typed:
	    for k in self.typenearest[i]:
             tot,tits,lits,popts,ptvars=self.gettypener(i,k,typedct,linkdct)
	     if ptvars<>None and ptvars[2]<>None and ptvars[2]==ptvars[3]:
		tot=99.9;##print 'penalizing circular patching',i,k
	     self.typenearest[i][k]=tot#overwrite (could be all 99.9 if in end of patch)
	     ##print 'updating typing (i)',i0,j0,method,direc,i,k,tot
	  if isinstance(j,int):## and isinstance(j,int):
	   if direc=='l':
	     for k in self.linknearest[j]:
               tot,tits,lits,popts,ptvars=self.getlinkener(j,k,typedct,linkdct)
	       self.linknearest[j][k]=tot#overwrite
	       ##print 'updating linking within link (r)',i0,j0,j,k,tot
	   elif direc=='r':
	     for k in self.linknearestrev[j]:
               tot,tits,lits,popts,ptvars=self.getlinkener(k,j,typedct,linkdct)
	       self.linknearest[k][j]=tot#overwrite
	       ##print 'updating linking within link (l)',i0,j0,j,k,tot
	   if not j in self.typed:
	    for k in self.typenearest[j]:
             tot,tits,lits,popts,ptvars=self.gettypener(j,k,typedct,linkdct)
	     if ptvars<>None and ptvars[2]<>None and ptvars[2]==ptvars[3]:
		tot=99.9;##print 'penalizing circular patching',j,k
	     self.typenearest[j][k]=tot#overwrite
	     ##print 'updating typing (j)',i0,j0,method,direc,j,k,tot
	if ptvars0<>None:
	  ##print 'ptvars0',ptvars0
          patchi,patchj,pni,pnj,dir0,i0,j0=ptvars0
	  twopatches=patchi+patchj
	  #NOTE updation is actually only needed at the ends of the patch?...
	  for p in twopatches:
	    for q in twopatches:
	       if q in self.linknearest[p]:self.linknearest[p][q]=99.9
	       if p in self.linknearest[q]:self.linknearest[q][p]=99.9
	    ##print 'extra typing?',len(twopatches),p
	    if isinstance(p,int):
	      for k in self.linknearest[p]:
                tot,tits,lits,popts,ptvars=self.getlinkener(p,k,typedct,linkdct)
	        self.linknearest[p][k]=tot#overwrite
	        ##print 'updating linking (p)',i0,j0,p,k,tot
	      for k in self.linknearestrev[p]:
                tot,tits,lits,popts,ptvars=self.getlinkener(k,p,typedct,linkdct)
	        self.linknearest[k][p]=tot#overwrite
	        ##print 'updating linking rev (p)',i0,j0,p,k,tot
	      if p<>i0 and p<>j0:
	        for k in self.typenearest[p]:
                 tot,tits,lits,popts,ptvars=self.gettypener(p,k,typedct,linkdct)
	         self.typenearest[p][k]=tot#overwrite
	         ##print 'updating typing (p)',i0,j0,method,direc,p,k,tot
	##self.remove_forbidden_nearest() #not efficient


    def choice_type(self,i,j,verb=False):
	  prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	  tits=[];lits=[];popn=None
	  deltas={'r':1,'l':-1}
	  ##self.settype(i,j)
	  ##tits.append((i,j)) #this is done at the end or in the patch
	  popn,patchi=self.ispatched(i,'r')
	  if verb:print 'typing initiated',i,j,prnstr[i],patchi #allways towards right (C-terminal)
	  for fdir in 'rl':
	    if self.hastype.has_key(j+deltas[fdir]):
	      oi=self.hastype[j+deltas[fdir]]
	      if verb:print 'connecting flanking typed spin systems',i,oi,j,j+deltas[fdir]
	      ##self.setlink(fdir,i,oi)
	      lits.append((fdir,i,oi))
	  if len(patchi)>0:
	    if verb:print 'extending typing in patch',i,j,patchi
	    self.findTypingInPatch(j,'r',patchi,i,tits,deltar=0)
	    ##flankj=self.typed[patchi[-1]]+1
	    flankj=tits[-1][1]+1#OK?
	    if self.hastype.has_key(flankj):
	      oip=self.hastype[flankj]
	      if verb:print 'connecting flanking patch (t)',i,oip,j,flankj
	      ##self.setlink('r',patchi[-1],oip)
	      lits.append(('r',patchi[-1],oip))
	  else:tits.append((i,j))
	  return tits,lits,[popn],None
	  ##self.execute_choice(tits,lits,[popn])

    def choice_link(self,dir0,i,j,verb=False):
	  prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	  tits=[];lits=[];pops=[];patchpairs=None
	  omet={'r':'l', 'l':'r'}
	  deltas={'r':1,'l':-1}
	  if verb:print 'linking ',dir0,i,j,prnstr[i],prnstr[j]
	  dir1=omet[dir0]
	  ##self.setlink(dir0,i,j)
	  lits.append((dir0,i,j))
	  pnj,patchj=self.ispatched(j,dir0)
	  pni,patchi=self.ispatched(i,dir1)
	  if i in self.typed:
	    tits.append((j,self.typed[i]+deltas[dir0]))
	    flank2=self.typed[i]+deltas[dir0]*2
	    if self.hastype.has_key(flank2):
	      oj=self.hastype[flank2]
	      if verb:print 'connecting flanking typed spin systems (linkedi)',i,j,oj,flank2
	      lits.append((dir0,j,oj))
	    if len(patchj)>0:
	      seqi=self.typed[i]
	      self.findTypingInPatch(seqi,dir0,patchj,i,tits);pops.append(pnj)
	      flank2=seqi+deltas[dir0]*(len(patchj)+1)
	      if self.hastype.has_key(flank2):
		oj=self.hastype[flank2]
		if verb:print 'connecting flanking patchj (linked)',i,j,oj,flank2
		lits.append((dir0,patchj[{'r':-1,'l':0}[dir0]],oj))
	  else:
	    if j in self.typed:
	      if verb:print 'linking to typed',dir0,i,j
	      typi=self.typed[j]-deltas[dir0]
	      tits.append((i,typi))
	      ##flanki=self.typed[i]-deltas[dir0]
	      flanki=self.typed[j]-deltas[dir0]-deltas[dir0]
	      if self.hastype.has_key(flanki):
	        oi=self.hastype[flanki]
	        if verb:print 'connecting flanking typed spin systems (linkedj)',i,j,oi,flanki
	        lits.append((dir1,i,oi))
	      if len(patchi)>0:
	        self.findTypingInPatch(self.typed[j],dir1,patchi,j,tits);pops.append(pni)
	        ##flank2=self.typed[i]-deltas[dir0]*len(patchi)
	        flank2=typi-deltas[dir0]*len(patchi)
	        if self.hastype.has_key(flank2):
		  oi=self.hastype[flank2]
		  coni=patchi[{'r':-1,'l':0}[dir1]]
		  if verb:print 'connecting flanking patchi (linked)',i,j,coni,oi,flank2
		  lits.append((dir1,coni,oi))
	    else:patchpairs=(patchi,patchj,pni,pnj,dir0,i,j)
	  return tits,lits,pops,patchpairs
	  ##self.execute_choice(tits,lits,pops)
	  ##if patchpairs<>None:self.execute_patch_connections(*patchpairs)

    def execute_patch_connections(self,patchi,patchj,pni,pnj,dir0,i,j):
	      dir1={'r':'l', 'l':'r'}[dir0]
	      if len(patchj)+len(patchi)==0:
	        print 'patching initiated',dir0,i,j,
	        self.patches.append(Patch(i,j,dir0))
		print self.patches[-1]
	      elif len(patchj)==0 and len(patchi)>0:
	        print 'patchj extended',dir0,i,j
		patchi.add(j,dir0)
	      elif len(patchj)>0 and len(patchi)==0:
	        print 'patchj extended',dir0,i,j
		patchj.add(i,dir1)
	      else:
		#keep only the (left) hand side patchi
	        print 'merging patches',dir0,i,j,pni,pnj,patchi,patchj
		if pni==pnj:print 'WARNING: merging identical patches (circular violation)',pni,patchi
		if dir0=='r':
		  patchi.mergewith(patchj)
		  self.patches.pop(pnj)
		else:
		  patchj.mergewith(patchi)
		  self.patches.pop(pni)

    def choice(self,method,i,j):
	if method[0]=='t':
	  return self.choice_type(i,j,verb=True)
	else:
	  dir0=method[1]
	  return self.choice_link(dir0,i,j,verb=True)

    def findpartner(self,i,method,linkdct,skeys,rev,typedct,its):
	its.sort()
	print its
	if len(its)==1 and str(its[0])=='nan':
	  print 'WARNING nan found in its',its,i
	  return 1,None
        selec=ProbabilitySelector()
        ##selec=BestSelector()
	omet={'r':'l', 'l':'r'}
	if method[0]=='l':#link
	  try:n,probj,j,ej=selec.selectpartner(its)
	  except TypeError:
	    print 'WARNING, cannot select partner (link)',its
	    return 1,None 
	  ##print its
	  ##print 'found (best?) partner link: %2d %2d %3s %3s %2d %7.4f %6.3f'%(i,j,skeys[i],skeys[j],n,probj,ej)
	if method[0]=='t':#link
	  try:n,probj,j,ej=selec.selectpartner(its)
	  except TypeError:
	    print 'WARNING, cannot select partner (type)',its
	    return 1,None 
	  ##print 'found (best?) partner type: %2d %2d %3s %3s %2d %7.4f %6.3f'%(i,j,skeys[i],self.seq[j],n,probj,ej)
	if ej>90:
	  if not self.disolved and len(self.patches)>0:
	    print 'warning: high energy partnering (disolve)',i,j,ej
	    ##self.disolve_patches()
	    self.disolve_patches(linkdct,typedct)
	    return 1,None
	  else:
	    print 'not disolving again (or no patch)'
	    self.increner+=7.0
	    if len(self.patches)>0:self.increner+=(len(self.patches[0])*50.0)
	    return 1,None##len(self.patches[0])
	else:
	  tits,lits,pops,ptvars=self.choice(method,i,j)
	  self.execute_choice(tits,lits,pops)
	  if ptvars<>None:self.execute_patch_connections(*ptvars)
	  self.increner+=ej
	  T_0=time.time()
	  ##self.update_nearest(method,tits,lits,pops,ptvars,i,j,linkdct,typedct)
	  print 'Time used (updation):',time.time()-T_0
	  return None,(tits,lits,pops,ptvars)

    def grow(self,scheme,mode='increment',initcnt=0):
	T_0=time.time()
	cnt=initcnt
	while len(self.typed)<len(scheme.skeys):
	  if mode=='increment':
	    flag=self.increment(scheme.spindct,scheme.linkdct,scheme.skeys,scheme.rev,scheme.typedct,
				updateentrop=(cnt%6==0 or (cnt%3==0 and cnt>30) or cnt>50))
		##updateentrop=(cnt%15==0 or (cnt%8==0 and cnt>25) or (cnt%3==0 and cnt>40) or cnt>53))
	    if False:##9<cnt<41 and cnt%10==0:
		self.recalculate_score(scheme.linkdct,scheme.typedct,scheme.skeys,xnear=True)
	    if flag<>None:break
	  elif mode=='tourn':
	    bestener,trynum=self.tournament(scheme.spindct,scheme.linkdct,scheme.skeys,scheme.rev,scheme.typedct,
				            maxrounds=max(40,((len(self.typed)-len(scheme.skeys)**2)/10)))
	    if bestener>10.0 or trynum>=300:
		print 'switching to exhaustive increment (lowest entropy)',bestener,trynum
		mode='increment'
	  print 'Time used (accum):',time.time()-T_0
	  cnt+=1
	##self.stripAllBad(scheme.linkdct,scheme.typedct)
	self.recalculate_score(scheme.linkdct,scheme.typedct,scheme.skeys,scheme.badlst)
	##self.gettripener(scheme.tripenerdct,scheme.rcdct,scheme.spindct,scheme.skeys,scheme.seq)
	self.showstate(lab='final')
	print 'time grow:',time.time()-T_0
	##ra1=self.reproduce()

    def gettypener(self,i,j,typedct,linkdct):
	     tot=99.9;tits,lits,popts,ptvars=[],[],[],None
	     if not i in self.typed:
	      if not i in self.linked['l']:#left side of patch
	       if not j in self.typed.values():#alternatively duplicate use of typing is allowed
		tits,lits,popts,ptvars=self.choice_type(i,j)
		tot=self.get_score(tits,lits,typedct,linkdct,ptvars)
		tot-=self.get_bonus(len(tits),len(lits),len(popts),tot)
	     return tot,tits,lits,popts,ptvars

    def getlinkener(self,i,j,typedct,linkdct):
	     tot=99.9;tits,lits,popts,ptvars=[],[],[],None
	     if not i in self.linked['l']:
	      if not j in self.linked['r']:
	        if not (j in self.typed and i in self.typed):
		  tits,lits,popts,ptvars=self.choice_link('l',i,j)
		  tot=self.get_score(tits,lits,typedct,linkdct,ptvars)
		  tot-=self.get_bonus(len(tits),len(lits),len(popts),tot)
	     return tot,tits,lits,popts,ptvars

    def tournament(self,spindct,linkdct,skeys,rev,typedct,minrounds=30,maxrounds=40,maxener=0.0,maxtrys=300):
	T_0=time.time()
	enerdct={}
	bestener=999
	trynum=0
	while True:
	  met=randchoice(['ty','ll'])
	  if met=='ty':
	    #TODO redefine updation of nearest so double typing etc. is penalized (tot=99.9)
	    i=randchoice(self.typenearest.keys())
	    j=randchoice(self.typenearest[i].keys())
	    key=(met,i,j)
	    if not key in enerdct:
		##tot,tits,lits,popts,ptvars=self.gettypener(i,j,typedct,linkdct)
		tot=self.typenearest[i][j]
		if tot<90.0:
		  enerdct[key]=tot##,(tits,lits,popts,ptvars)
	  elif met=='ll':
	    i=randchoice(self.linknearest.keys())
	    j=randchoice(self.linknearest[i].keys())
	    key=(met,i,j)
	    if not key in enerdct:
    		##tot,tits,lits,popts,ptvars=self.getlinkener(i,j,typedct,linkdct)
    		tot=self.linknearest[i][j]
		if tot<90.0:
		  enerdct[key]=tot##,(tits,lits,popts,ptvars)
	  trynum+=1
	  if len(enerdct)>=maxrounds or (len(enerdct)>=minrounds and bestener<maxener) or trynum>maxtrys:break
	##its=[(enerdct[k][0],k,enerdct[k][1]) for k in enerdct]
	its=[(enerdct[k],k) for k in enerdct]
	its.sort()
	##print its
	bestener=its[0][0]
	bestmet,besti,bestj=its[0][1]
	##tits,lits,popts,ptvars=its[0][2]
	if bestmet[0]=='l':#link
    	  tot,tits,lits,popts,ptvars=self.getlinkener(besti,bestj,typedct,linkdct)
	  print 'selected (best?) partner link: %2d %2d %3s %3s %6.3f %6.3f'%(besti,bestj,skeys[besti],skeys[bestj],bestener,tot)
	elif bestmet[0]=='t':#link
	  tot,tits,lits,popts,ptvars=self.gettypener(besti,bestj,typedct,linkdct)
	  print 'selected (best?) partner type: %2d %2d %3s %3s %6.3f %6.3f'%(besti,bestj,skeys[besti],self.seq[bestj],bestener,tot)
	if bestener<90.0:
	  self.execute_choice(tits,lits,popts)
	  if ptvars<>None:self.execute_patch_connections(*ptvars)
	  self.increner+=bestener
	  self.update_nearest(bestmet,tits,lits,popts,ptvars,besti,bestj,linkdct,typedct)
	self.showstate()
	print 'time used: (step)',time.time()-T_0
	return bestener,trynum

    def increment(self,spindct,linkdct,skeys,rev,typedct,updateentrop=True):
	T_0=time.time()
	minent=999; minmethod=None; mini=None; min_es=None
	##T_0=time.time()
        ##selec=ProbabilitySelector()
        selec=BestSelector()
	revdct={}
	if updateentrop:
	 choicelist=[];varlst=[];self.usedchoices=[]
	 for i,gi in enumerate(skeys):
	  revdct[i]={}
	 for i,gi in enumerate(skeys):
	  ##for met in ['ll','lr','ty']:
	  for met in ['ll','ty']:
	    es=None
	    if met=='ty':
	      if not i in self.typed:
		##print i,self.typenearest.keys(),self.typenearest[i]
		es=self.getvalues_type(i,typedct,linkdct,self.typenearest[i])
		#TODO: will be faster with list comprehensions?
	    elif not i in self.linked[met[1]]:
	       	es=self.getvalues_link(i,typedct,linkdct,met[1],self.linknearest[i])
		if es<>None:
		  for tot,j in es:revdct[j][i]=tot
	    if es<>None and min(es)[0]<16.0:
	      ##print es
	      entrop=self.getentrop(es)
	      choicelist.append((entrop,len(varlst)))
	      varlst.append((i,met,es))
	      if entrop<minent:
		  mini=i;minent=entrop;minmethod=met;min_es=es[:]
	  ##if es==None and not i in self.typed:print 'no total possibilities for',i,gi
	 #or choose statistically from a list of lowest entropies => better sampling
	 for j in []:##revdct: skipping this saves 25% runtime
	  dctj=revdct[j]
	  if len(dctj)>0:
	    es=[(dctj[i],i) for i in dctj]
	    if es<>None and min(es)[0]<12.0:
	      entrop=self.getentrop(es)
	      choicelist.append((entrop,len(varlst)))
	      varlst.append((j,'lr',es))
	      if entrop<minent:
		mini=j;minent=entrop;minmethod='lr';min_es=es[:]
	 if mini==None:#still
	  nontyped=[]
	  for i,gi in enumerate(skeys):
	    if not i in self.typed:
		nontyped.append(i)
		print 'not typed:',i,gi
	  print 'premature exit',nontyped
	  if not self.disolved and len(self.patches)>0:
	    self.disolve_patches(linkdct,typedct)
	  else:
	    print 'Exiting',nontyped
	    return len(nontyped)
	 choicelist.sort()
	else:
	  choicelist=self.choicelist
	  varlst=self.varlst
	if len(choicelist)<7:print choicelist
	if len(choicelist)>0:
	 for numtrys in range(10):
	  #NOTE some trys will exceed 10 and produce errors. problem? - use choicedict...
	  maxi,bestprob,bestn,minent=selec.selectpartner(choicelist)
	  mini,minmethod,min_es=varlst[bestn]
	  ##print 'testing for choice:',bestn,minent,mini
	  ##if not bestn in self.usedchoices:
	  if not mini in self.usedchoices:
	    self.usedchoices.append(mini)
	    if updateentrop:break
	    ##print 'overwriting min_es',mini,minmethod,min(min_es)
	    if minmethod=='ty':
	      ##if not i in self.typed:
		min_es=self.getvalues_type(mini,typedct,linkdct,self.typenearest[mini],verb=True)
	    else:
		#getvalues_link has a bug for met=='lr'
	       	min_es=self.getvalues_link(mini,typedct,linkdct,minmethod[1],self.linknearest[mini])
	    if min_es<>None:
	     if minmethod<>'ty':#OK?
	      for n in range(len(min_es)-1,-1,-1):
	       en,mn=min_es[n]
	       for ui in self.usedchoices:
	        if ui==mn:
		  print 'removing choice:',mn
		  min_es.pop(n)
		  break
	     ##newentrop=self.getentrop(min_es)
	     ##min_es.sort()
	     if len(min_es)>0:
	      ##print 'overwritten min_es',mini,minmethod,min(min_es)##,min_es[:5]
	      if min(min_es)[0]<12.0: break
	 print maxi,bestprob,bestn,minent,len(varlst),len(choicelist),numtrys
	 ##mini,minmethod,min_es=varlst[bestn]
	 if min_es==None or len(min_es)==0 or minent>10.0:viol=2
	 else:
	   print 'minimum entropy: %2d %3s %2s %6.3f %2d'%(mini,skeys[mini],minmethod,minent,len(min_es))
	   ##min_es.sort()#TAKEBACK
	   ##print min_es[:5]
	   viol,choicevars=self.findpartner(mini,minmethod,linkdct,skeys,rev,typedct,min_es)
	 if viol==None:
	  tits,lits,pops,ptvars=choicevars
	  for i,k in tits:
	    self.usedchoices.append(i)
	  for direc,i,j in lits:
	   ##if direc=='l':
	    self.usedchoices.append(i)
	   ##else:
	    self.usedchoices.append(j)
	 choicelist.pop(maxi)
	 ##choicelist[bestn]=(99.9,choicelist[bestn][1])
	 ##choicelist.sort()
	 ##varlst.pop(bestn)
	 self.choicelist=choicelist
	 self.varlst=varlst
	 if viol<>None:
	  print 'premature exit',viol
	  return viol
	 self.showstate()
	print 'time used: (step)',time.time()-T_0


class SpinSystemAssignment(ResonanceAssignment):

    def __init__(self,seq,explst):##numexp,multi):
	self.numgenes=len(seq)
	self.genestr='-'*self.numgenes
	##self.numvalues=numspinsyst
	self.seq=seq
	self.linked={}
	self.patches=[]
	self.disolved=False
	self.skippedmerged=set([])
	for i,r in enumerate(self.seq):
	  if r=='P':
	    print 'blocking proline',i
	    ##self.hastype[i]='|'+str(i)
	self.increner=0.0
	self.cons=None
	self.numexp=len(explst)
	self.multi=[]
	self.has_patch={}
	for i in range(self.numexp):
	  mult=sum(explst[i].multi)
	  if mult>0:self.multi.append(1)
	  else:self.multi.append(0)
	self.numpatches=0
	self.fullpeakdct={}
	self.assigned_types={}
	self.hlinkpairs=[]
	
    def setlink(self,pkeys,elink=0,lab='na'):
	for n in range(2):
	  k0=pkeys[n];k1=pkeys[1-n]
	  if k0[1]<>None:
	    if not k0 in self.linked:self.linked[k0]=dict([(q,{}) for q in range(self.numexp)])
	    ##print self.linked[k0]
	    ##self.linked[k0][k1]=lab
	    self.linked[k0][k1[0]][k1[1]]=lab

    def oldispatched(self,pair):
	if pair in self.linked:
	  for pnum,pt in enumerate(self.patches):
	    if pair[1] in pt[pair[0]]:return pnum,pt
	return None,[]

    def ispatched(self,pair):
	if pair in self.has_patch:
	  pnum=self.has_patch[pair]
	  pt=self.patches[pnum]
	  #check whether the patch is currently active?...
	  ##if pt<>'retired':
	  return pnum,pt
	return None,None

    def showpatches(self,patches,explst):
	for pt in patches:
	  pt.setlabel()
	  pt.show(explst)

    def extend_linking_between_patches(self,patches,pkeys,ax0,lab,allneardct,allneardct0,pnums,dopop=True,execute=True):
	##allax=[0,1,2,'u','c']
	allax=[0,1,2,'u','c','s']
	singpairs=[]
	for I in SINGLES:singpairs.append((I,I))
	for direc in 'lr':
	  if direc in patches[0].hlinked and direc in patches[1].hlinked and patches[0].hlinked[direc]<>patches[1].hlinked[direc]:
	    print 'not merging hlinked',pkeys,patches[0].hlinked,patches[1].hlinked
	    return False
	pairlst=[]
	counts=[0 for q in range(self.numexp)]
	for i in range(len(patches[0])):
	  for k in patches[0][i]:
	    pa0=(i,k)
	    counts[i]+=1
	    for j in range(len(patches[1])):
	      for m in patches[1][j]:
		pa1=(j,m)
		if (i,j) in singpairs:##[(1,1),(3,3)]:
		 if k<>j:
		  ##print 'warning: invalid merging',(i,j)
		  return False
		elif i<=j and max(i,j)<4:
		 if allneardct0<>None:
		  isin=False
		  for ax1 in allax:
		    rpair=(i,j,ax1)
		    if rpair in allneardct0:
		      nearest=allneardct0[rpair][0]
		      if k in nearest and m in nearest[k]:
			##print 'thisone isin (between)',(pkeys,ax0),pa0,pa1,lab
			isin=True;break
		      if i==j:
		       if m in nearest and k in nearest[m]:
			##print 'thisone isin (between rev)',(pkeys,ax0),pa0,pa1,lab
			isin=True;break
		      if (pa0,pa1)==pkeys or (pa1,pa0)==pkeys:
			isin=True;break
		  if not isin:
		    ##print 'NOTE not isin: (between)',(pkeys,ax0),pa0,pa1,lab
		    if rand()<0.5:return False #was without rand() test
		##counts[j]+=1
		newpair=(pa0,pa1)
		#if not (pa0,pa1)==pkeys or (pa1,pa0)==pkeys:
		pairlst.append(newpair)
		##self.setlink(newpair,0.0,'lm')
	if sum(counts)>15:
	  num=normalvariate(15.0,4.0)#TODO: generalize numbers
	  if num<sum(counts) and\
	  not pnums in self.skippedmerged and\
	  not (pnums[1],pnums[0]) in self.skippedmerged:
	    print 'skipping merge',sum(counts),counts,pnums,pkeys,ax0,lab
	    self.skippedmerged.add(pnums)
	    return False#OK?
	for pair in pairlst:
	 if execute:
	  self.setlink(pair,0.0,'lm')
	  if dopop:
	    self.poppair(pair,ax0,allneardct)
	return True
	#TODO: some peaks might should not be linked indirectly

    def poppair(self,newpair,ax0,allneardct):
	  for r in range(2):
	    rpair=(newpair[r][0],newpair[1-r][0],ax0)
	    if rpair in allneardct:
	      nearest=allneardct[rpair][0]
	      rpair1=(newpair[r][1],newpair[1-r][1],ax0)
	      ##print nearest.keys(),rpair1
	      if rpair1[0] in nearest:
		if rpair1[1] in nearest[rpair1[0]]:
		  ##print 'Popping',rpair,rpair1
		  nearest[rpair1[0]].pop(rpair1[1])

    def extend_linking_within_patch(self,patch,pnum,pkeys,ax0,lab,allneardct,allneardct0,explst,dopop=True,execute=True,mode=1):
	##allax=[0,1,2,'u','c']
	singpairs=[]
	for I in SINGLES:singpairs.append((I,I))
	allax=[0,1,2,'u','c','s']
	pairlst=[]
	projener=0.0
	numin=0
	for n in range(len(patch)):
	  for m in patch[n]:
	    pao=(n,m)
	    for q in range(2):
	      paq=pkeys[q];paqo=pkeys[1-q]
	      if paq in self.linked:liqn=self.linked[paq][n]
	      else:
		if n==paqo[0]:liqn={paqo[1]:lab}
		else:liqn={}
		##print 'derived liqn',liqn
	      ##print 'testsim:',paq,liqn,n,paqo
	      if not m in liqn:
	       if paq<>pao:
		newpair=(paq,pao)
		if (paq[0],pao[0]) in singpairs:#was [(1,1),(3,3)]:
		 if pao[1]<>paq[1]:
		  ##print 'warning: invalid adding',newpair
		  return False,0.0
		elif paq[0]<=pao[0]<4:
		  isin=False
		  for ax1 in allax:
		    rpair=(paq[0],pao[0],ax1)
		    if rpair in allneardct0:
		      nearest=allneardct0[rpair][0]
		      if paq[1] in nearest and pao[1] in nearest[paq[1]]:
			projener+=nearest[paq[1]][pao[1]][0];numin+=1
			isin=True;break
		  if not isin:
		    ##print 'NOTE not isin: (within )',newpair,lab
		    return False,0.0
		pairlst.append(newpair)
	if numin>0:projener/=numin
	print 'projener is:',pkeys,lab,projener
	if mode==2:
	   print 'assityp:',patch.assigned_type
	   other,thispair=pkeys
	   if (pnum,other) in self.extdct and not execute:
	     projener=self.extdct[(pnum,other)]
	     print 'using old projener'
	   else:
	    spin=patch.spin
	    expk=explst[other[0]]
	    peak=expk.peakData.peaklist[other[1]]
	    shs=peak.shifts
	    if patch.assigned_type<>None:
	     print patch
	     print 'pkeyslab:',pkeys,lab
	     spin.show()
	     peakasname='none'##getAsFormat(peak.names)
	     print peakasname,shs,
	     pener=peak.assignenerlst[patch.assigned_type]
	     pemat=peak.assignenermat[patch.assigned_type]
	     pasnm=peak.assignamesmat[patch.assigned_type]
	     print pener,pemat,pasnm
	     projener=spin.ask_peak(peak,expk,pemat,pasnm,other,execute=execute)
	     self.extdct[(pnum,other)]=projener
	    else:
	     if execute:
	      if spin<>None:spin.addnonspecificpeak(patch,peak,expk,other,shs)
	      else:
	       print 'patch is not (yet) related to spin',shs,peak,other
	       print patch##patch.show(explst)
	for pair in pairlst:
	 if mode==2:pass
	 if execute:
	  self.setlink(pair,0.0,'la')
	  if dopop:
	    self.poppair(pair,ax0,allneardct)
	    ##print 'trying to pop',newpair
	#TODO: some peaks might should not be linked indirectly
	#TODO: calculated accum elink decide whether to init new patch (also for merging)
	return True,projener

    def hsetlink(self,pns,pnums):
	for i in range(2):
	  pns[i].hlinked['rl'[i]]=pnums[1-i]#eller omvendt?

    def hconnect(self,pkeys,ax0,lab,explst,elink,allneardct,dopop=True,execute=True,mode=1):
	ener=0.0
	pnums=[];pns=[];names=[]
	direcs='rl'
	for p in range(2):
	  pair=pkeys[p]
          peak=explst[pair[0]].peakData.peaklist[pair[1]]
	  peaknam='none'##getAsFormat(peak.names)
	  names.append(peaknam)
	for p in range(2):
	  pair=pkeys[p];other=pkeys[1-p]
	  pnum,pn=self.ispatched(pair)
	  onum,on=self.ispatched(other)
	  if pnum<>None:
	    direc=direcs[p]
	    if direc in pn.hlinked:
	      ##print 'patch allready hlinked',direc,pnum,pair,other,pn.hlinked[direc],p,names,
	      print pkeys in self.hlinkpairs,pn.hlinked[direc]==onum
	      break
	  pnums.append(pnum)
	  pns.append(pn)
	if len(pnums)==2:
	 for p in range(2):
	   pnum=pnums[p]
	   if pnum==None:
	     pair=pkeys[p]
	     ##print 'creating patch from single peak',pair
	     patch=PatchDict(pair,lab=lab,numexp=len(explst))
	     self.patches.append(patch)
	     self.has_patch[pair]=len(self.patches)-1
	     self.numpatches+=1
	     pnum=self.has_patch[pair]
	     pn=self.patches[pnum]
	     pnums[p]=pnum;pns[p]=pn
	 print 'hlinking',pnums,pkeys,names
	 if execute:
	   self.hsetlink(pns,pnums)
	   if dopop:self.poppair(pkeys,ax0,allneardct)
	   self.hlinkpairs.append(pkeys)

    def connect(self,pkeys,ax0,lab,explst,elink,allneardct,allneardct0=None,dopop=True,execute=True,mode=1):
	ener=0.0;projener=0.0
	if execute:
	  self.setlink(pkeys,elink,lab)
	  self.poppair(pkeys,ax0,allneardct)
	##if mode==1:searchrange=range(2)
	##else:searchrange=[0]
	for p in range(2):
	##for p in searchrange:
	  pair=pkeys[p];other=pkeys[1-p]
	  pnum,pn=self.ispatched(pair)
	  if pnum<>None:
	    opnum,pm=self.ispatched(other)
	    if opnum<>None:
	      if pnum==opnum:
	       if execute:
		##print 'allready connected',pnum,pkeys,lab
		return 0,'skip',90.0
	      else:
		##print 'two patches',pnum,opnum,pn,pm,pkeys
		##self.showpatches((pn,pm),explst)
		domerge=self.extend_linking_between_patches((pn,pm),(other,pair),ax0,lab,allneardct,allneardct0,(pnum,opnum),dopop,execute)
		#TODO: derive similar to projener
		if mode==2:ener=50.0#TODO implement linking between?...
		if domerge:
	         if execute:
		  ##pn.mergewith(pm,pkeys,lab)
		  usemerge=pn.mergewith(pm,(other,pair),self.has_patch,lab)
		  ##self.patches.pop(opnum)
		  if usemerge:
		   for direc in 'lr':
		    if direc in pm.hlinked:
		      odir={'l':'r','r':'l'}[direc]
		      qnum=pm.hlinked[direc]
		      pq=self.patches[qnum]
		      pq.hlinked[odir]=pnum#OK?!!!
		   self.patches[opnum]='retired'
		   self.has_patch[other]=self.has_patch[pair]
		   self.numpatches-=1
		 return 1,'merged',ener
		return 0,'merge_not',90.0
	    doadd,projener=self.extend_linking_within_patch(pn,pnum,(other,pair),ax0,lab,allneardct,allneardct0,explst,dopop,execute,mode)
	    if doadd:
	     if execute:
	      pn.add(other,pair,lab)
	      ##print 'added pair to patch',other,pnum,opnum
	      self.has_patch[other]=self.has_patch[pair]
	      return 1,'added',projener
	     ##self.current_projener=projener
	     return 1,'add',projener
	    else:
	      ##print 'didnt add pair to patch',other,pnum,opnum
	      return 0,'add_not',90.0
	    ##else:return 1,'added?'#maybe adding...
	#no merging nor add nor skip => initialize new patch
	if execute:
	  patch=PatchDict(pkeys[0],pkeys[1],lab,numexp=len(explst))
	  self.patches.append(patch)
	  self.has_patch[pkeys[0]]=len(self.patches)-1
	  self.has_patch[pkeys[1]]=len(self.patches)-1
	  ##or self.has_patch[pkeys[1/0]]=patch?
	  self.numpatches+=1
	ener=projener
	return 1,'new',ener

    def linkuniq(self,allneardct,explst,mode='v',elinkmax=1.00,allneardct0=None):#elinkmax is lw/2
	T_0=time.time()
	nlu=0
	for i in range(self.numexp):
	  for j in range(i,self.numexp):
	    for ax0 in (0,1,2,'u','c'):
	      if (i,j,ax0) in allneardct:
		nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[(i,j,ax0)]
		for k in uniq:
		  ##vals=nearest.pop(k)#note: removing key
		  vals=nearest[k]#note: removing key
		  if len(vals)==0:print 'warning vals are now empty',i,j,ax0,k
		  else:
		   m=vals.keys()[0]#TODO m,elink,lab=uniq[k]
		   elink,cnt,lab=vals.values()[0]
		   if lab<>'na':
		    if elink<=elinkmax and cnt>=2:
		     if rand()<exp(-elink/(elinkmax/3)):
		      print 'linking fwd',mode,(i,j,ax0),k,m,elink,cnt,lab,m in uniqrev
		      ##if m in uniqrev:
		      pkeys=((i,k),(j,m))
		      if mode=='v':self.connect(pkeys,ax0,lab,explst,elink,allneardct,allneardct0)##,dopop=False)
		      elif mode=='h':self.hconnect(pkeys,ax0,lab,explst,elink,allneardct)
		      ##print 'fwd number of patches',self.numpatches
		      nlu+=1
		      nearest.pop(k)
		for k in uniqrev:
		  ##vals=nearestrev.pop(k)#note: removing key
		  vals=nearestrev[k]
		  if len(vals)==0:print 'warning vals are now empty',i,j,ax0,k
		  else:
		   m=vals.keys()[0]#TODO m,elink,lab=uniq[k]
		   ##print vals.values()[0]
		   ##print vals
		   elink,cnt,lab=vals.values()[0]
		   if lab<>'na':
		    if elink<=elinkmax and cnt>=2:
		     if rand()<exp(-elink/(elinkmax/3)):
		      print 'linking rev',mode,(i,j,ax0),k,m,elink,cnt,lab,m in uniq
		      ##if m in uniq:
		      ##pkeys=((j,k),(i,m))
		      pkeys=((i,m),(j,k))
		      if mode=='v':self.connect(pkeys,ax0,lab,explst,elink,allneardct,allneardct0)##,dopop=False)
		      elif mode=='h':self.hconnect(pkeys,ax0,lab,explst,elink,allneardct)
		      ##print 'rev number of patches',self.numpatches
		      nlu+=1
		      nearestrev.pop(k)
	print 'uniquely linked:',nlu,mode
	print 'luniq time used:',time.time()-T_0

    def get_linkvalues(self,vals,k,i,j,ax0,allneardct,allneardct0,explst,mode=1):
	its=[]
	dct={}
	for m in vals:
	  ener,cnt,mlab=vals[m]
	  pkeys=((i,k),(j,m))
	  ##print 'getting linkvalues for',pkeys,mlab,ener
	  if mode==3:
	    if isinstance(ener,dict):
	      ##print 'energy from dict',k,i,j,ener
	      for atyi in ener:
		eneri=ener[atyi]
		##its.append((eneri,(m,atyi)))
		if not atyi in dct:
		  dct[atyi]=(m,eneri)
		elif eneri<dct[atyi][1]:
		  dct[atyi]=(m,eneri)
	    else:
	      print 'energy is single value (skip)',k,i,j,ener
	  else:
	    action,flag,curener=self.connect(pkeys,ax0,mlab,explst,ener,allneardct,allneardct0,execute=False,mode=mode)
	    ener+=curener
	    if action:its.append((ener,m))
	if mode==3:
	  for atyi in dct:its.append((dct[atyi][1],(dct[atyi][0],atyi)))
	return its

    def accept_counts(self,s,patches):
	##return s[0]<2 and s[1]<6 and s[2]<2 and s[3]<6
	for j in SINGLES:##[1,3]:
	  if s[j]>1:
	    if s[j]>2:return False
	    elif not patches[0].keys()[0] in patches[1]:return False
	for j,val in enumerate(s):
	  if not j in SINGLES and val>5:return False
	return True

    def perform_mergins(self,totnumpeaks,explst):
	splitnum=min(ALLMULT)
	totespin=0.0
	newkeylst=[]
	newspindct={}
	newconvdct={}
	conf=self.confirmedchoices
	conf1=[tup[0] for tup in self.confirmedchoices]
	conf2=[int(tup[1]) for tup in self.confirmedchoices]
	print 'merging spin systems',len(conf),conf1,conf2
	mergelst=[]
	allcombset=set([])
	for i in range(len(self.keylst)):
	   ssy=self.spindct[i]
	   lab,pnum=self.keylst[i]
	   pt=self.patches[pnum]
	   ##if pt.counts[:splitnum]==[0,0,0,0]:
	   if sum(pt.counts[:splitnum])==0:
	      ##lst1.append(i)
	      if i in conf1:
		j=conf2[conf1.index(i)]
		print 'merge with other',i,j
		besttup=conf[conf1.index(i)][2]
	        print '%2d %2d %2s %2s %3d %3d %2d %2d %6s %1d %7.4f %7.4f %7.4f'%besttup
		ssyj=self.spindct[j]
		ssyj.merge_with(ssy)
		ssyj.show()
	      else:
		print 'remove spin system',i#retired
		#now release links and hlinks?...
		#also modify patches?
	   else:
	     newspindct[len(newkeylst)]=ssy
	     newconvdct[pnum]=len(newkeylst)
	     newkeylst.append((lab,pnum))
	     merged=False
	     if pt.counts[splitnum]==0:
	      ##lst2.append(i)
	      if i in conf2:
		j=conf1[conf2.index(i)]
		print 'merged with other (maybe later)',i,j
		merged=True
		mergelst.append(ssy)
	     if not merged:
		espin=sum(ssy.espins.values())
		totespin+=espin
		ssy.setallrefs()
		allcombset|=ssy.combrefset
	for ssy in mergelst:
		espin=ssy.get_espinsystem()
		totespin+=espin
		ssy.setallrefs()
		allcombset|=ssy.combrefset
		print 'espin is:',espin##,len(ssy.flatpeakdct)
	#overwrite data structures with new
	self.keylst=newkeylst
	self.spindct=newspindct
	self.convdct=newconvdct
	totnonlinked=totnumpeaks-len(allcombset)
	score=totnonlinked+1.00*totespin
	print 'mergeresult:',totnonlinked,totespin,len(newkeylst),score
	return score

    def strip_spinsystems(self,explst):
	totnumbad=0;totnumgood=0#false positives
	totnum=0
	for i,ssy in self.spindct.items():
	  if ssy.rank>4.0:
	    print 'stripping peak by align ----------------',i
	    ssy.show()
	    ssy.get_flatpeakdct(explst,usenonspec=True)
	    if len(ssy.flatpeakdct)>5:
	      ssy.get_peak_aligns(explst)
	      numbad,numgood,numpeaks=ssy.strip_peaks_align(explst)
	      totnumbad+=numbad;totnumgood+=numgood;totnum+=numpeaks
	      ssy.update_maintain()
	      ssy.show()
	print 'final_stripresult',totnumbad,totnumgood,totnum

    def increment_mergessys(self,explst,updateentrop=True):
	T_0=time.time()
	splitnum=min(ALLMULT)
        selec=BestSelector()
	if updateentrop:
	 choicelist=[];varlst=[];self.usedchoices=[]
	 self.confirmedchoices=[]
	 lst1=[];lst2=[]
	 for i in range(len(self.keylst)):
	   ssy=self.spindct[i]
	   lab,pnum=self.keylst[i]
	   pt=self.patches[pnum]
	   ##if pt.counts[:splitnum]==[0,0,0,0]:lst1.append(i)
	   if sum(pt.counts[:splitnum])==0:lst1.append(i)
	   elif pt.counts[splitnum]==0:    lst2.append(i)#TODO generalize
	 for n in range(len(lst1)):
	   q=lst1[n]
	   ##nvals=[(0.1,-1,None,None)]
	   nvals=[(exp(0.9),-1,None,None)]
	   for l in range(len(lst2)):
	     p=lst2[l]
	     ssyq=self.spindct[q]
	     ssyp=self.spindct[p]
	     cnt,num1,num2=ssyq.get_merge_score(ssyp,explst)
	     labq,qnum=self.keylst[q]
	     labp,pnum=self.keylst[p]
	     ptq=self.patches[qnum]
	     ptp=self.patches[pnum]
	     shared=len(set(ptq._dct.values())&set(ptp._dct.values()))
	     ##probmatch=1-0.50**cnt
	     probmatch=exp(cnt)
	     ener=-log(probmatch)
	     tup=(q,p,labq,labp,qnum,pnum,num1,num2,labq==labp,shared,cnt,probmatch,ener)
	     ##print 'fcount: %2d %2d %2s %2s %3d %3d %2d %2d %6s %1d %7.4f %7.4f %7.4f'%tup
	     if cnt>0.9:
		nvals.append((probmatch,p,l,tup))#tup is for debugging only
	        ##ptq.show(explst,False,qnum,False)
	        ##ptp.show(explst,False,pnum,False)
	   if len(nvals)>1:
	     nvals.sort();nvals.reverse()
	     ##print nvals
	     probs=(array([elem[0] for elem in nvals]))
	     probs/=sum(probs)
	     ##entrop=getentrop5(probs)
	     entrop=getentrop4(probs)#pre normalized
	     choicelist.append((entrop-log(max(probs))/2,len(varlst)))
	     print 'Entrop_merge: %2d %2d %2s %3d %6.3f %6.3f %6.3f %2d'%\
		(n,q,labq,qnum,entrop,max(probs),entrop-log(max(probs))/2,len(nvals))
	     varlst.append((n,q,probs,nvals))
	 ##print choicelist
	 choicelist.sort()
	else:#not updateentrop
	  choicelist=self.choicelist
	  varlst=self.varlst
	action,flag,ep=0,None,0.1
        pselec=ProbabilitySelector()
	if len(choicelist)>0:
	  maxi,bestprob,bestn,minent=selec.selectpartner(choicelist)
	  minn,minq,probs,nvals=varlst[bestn]
	  ##print nvals
	  print 'minimum entropy (merge): %2d %2d %6.3f %6.3f %2d'%\
	        (minn,minq,minent,bestprob,len(nvals))
	  ##its=array([(elem[0],elem[1]) for elem in nvals])
	  its=array([(probs[i],nvals[i][1]) for i in range(len(nvals))])
	  ##print its
	  j,probp,minp,ep=pselec.selectpartner(its,doexp=False)#NOTE: ep is probability here
	  if int(minp)<>-1:#OK? minp==-1 is "false" connection
	    if not minp in self.usedchoices:
	      action=1
	      besttup=nvals[j][-1]
	      print 'selected (best?, merge) partner:',j,
	      #besttup=(q,p,labq,labp,qnum,pnum,num1,num2,labq==labp,shared,cnt,probmatch,ener)
	      print '%2d %2d %2s %2s %3d %3d %2d %2d %6s %1d %7.4f %7.4f %7.4f'%besttup,
	      print '%2d %7.4f %7.4f'%(minp,probp,ep)
	      if ep>0.25:
		print 'storing minq and minp',minq,minp,besttup[8],besttup[9]
		self.confirmedchoices.append((minq,minp,besttup))#besttup for debugging only
		#minq is the side-chain only (no root) spin systems (lst1)
		self.usedchoices.append(minp)
	  ##else:
	      ##print 'selected (best?, merge) partner:',
	      ##print '%2d %7.4f %7.4f (none!)'%(minp,probp,ep)
	  choicelist.pop(maxi)
	  self.choicelist=choicelist
	  self.varlst=varlst
	print 'time mergestep:',time.time()-T_0
	return len(choicelist),action,flag,ep#NOTE: ep is probability here

    def incrementmore_patches(self,allneardct,allneardct0,explst,updateentrop=True):
	nummult=len(ALLMULT)
	allax=[0,1,2,'u','c']
	T_0=time.time()
        selec=BestSelector()
	if updateentrop:
	 choicelist=[];varlst=[];self.usedchoices=[]
	 lst=[]
	 for pnum,pt in self.iter_patches():
	   pt.setlabel()
	   ##if 0 in pt.counts:
	   if 0 in pt.counts[:-nummult]:
	     ##print 'found incomplete patch',pnum,pt.counts,pt.label
	     lst.append(pnum)
	 for n in range(len(lst)):
	   q=lst[n]
	   nvals=[]
	   for l in range(n+1,len(lst)):
	     p=lst[l]
	     ptq=self.patches[q]
	     ptp=self.patches[p]
	     cq=ptq.counts[:-nummult]#TODO: generalize
	     cp=ptp.counts[:-nummult]
	     csum=array(cq)+array(cp)
	     if self.accept_counts(csum,(ptq,ptp)):
		##print 'found possible pairing',q,p,cq,cp,csum,ptq.label,ptp.label,ptq.label==ptp.label
		##ptq.show(explst,False,showssy=False)
		##ptp.show(explst,False,showssy=False)
		maxshared=0;pair=None;order=None
		for i in range(len(cq)):
		 if cq[i]>0:
		  for j in range(len(cp)):
		   if cp[j]>0:
		    for ax0 in ['u']:##allax:
		     if (i,j,ax0) in allneardct:
		      nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[(i,j,ax0)]
		      print i,j,ax0,len(labels),labels
		      shaij=len(labels)
		      if shaij>maxshared:
			maxshared=shaij
			pair=(i,j,ax0);order=0
		     elif (j,i,ax0) in allneardct:
		      nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[(j,i,ax0)]
		      print j,i,len(labels),labels
		      shaij=len(labels)
		      if shaij>maxshared:
			maxshared=shaij
			pair=(j,i,ax0);order=1
		if maxshared>=1:##2:#1
		      i,j,ax0=pair
		      nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[pair]
		      print 'maxshared pair',maxshared,pair,order
		      if order==0:
			pt0=ptq;pt1=ptp
		      else:
			pt1=ptq;pt0=ptp
		      sumener=0.0;labs=[]
		      pkeys=None
		      for k in pt0[i]:
			if k in nearest:
			  vals=nearest[k]
		          for m in pt1[j]:
			    if m in vals:
			      print 'might be consistent',i,j,k,m,vals[m]
			      sumener+=vals[m][0]
			      ##labs.append(vals[m][1])
			      labs.append(vals[m][2])
			      pkeys=((i,k),(j,m))
			    else:
			      sumener+=5.0#OK number?
			else:
			  sumener+=5.0
		      aveener=sumener/len(pt0[i])/len(pt1[j])
		      if pkeys<>None and aveener<3.0 and maxshared>=2:
			print 'aveener',n,l,i,j,ax0,aveener,labs
			nvals.append((l,pkeys,ax0,labs,aveener))
	   if len(nvals)>0:
	     eners=(array([elem[-1] for elem in nvals]))
	     if len(nvals)==1:entrop=0.0
	     else: entrop=getentrop3(eners)
	     choicelist.append((entrop+min(eners)/2,len(varlst)))
	     varlst.append((n,'patches',nvals))
	 ##print choicelist
	 ##print varlst
	 choicelist.sort()
	else:#not updateentrop
	  choicelist=self.choicelist
	  varlst=self.varlst
	action,flag,el=0,None,None
        pselec=ProbabilitySelector()
	if len(choicelist)>0:
	  maxi,bestprob,bestn,minent=selec.selectpartner(choicelist)
	  met=varlst[bestn][1]
	  if met=='patches':
	    minn,met,nvals=varlst[bestn]
	    print maxi,bestprob,bestn,minent,minn,met,nvals
	    its=[(elem[-1],elem[0]) for elem in nvals]
	    n,probl,minl,el=pselec.selectpartner(its)
	    minl0,pkeys,ax0,labs,aveener=nvals[n]
	    if aveener<2.0:##3.0:
	      mini,mink=pkeys[0];minj,minm=pkeys[1]
	      try:lm1=labs[-1]
	      except IndexError:
		print 'WARNING: problem with lab',labs
		lm1='non'
	      ##if not lm1 in ['na','nb','non']:
	      action,flag,curener=self.connect(pkeys,ax0,lm1,explst,el,allneardct,allneardct0)
	      ##print 'selected (best?, patch) partner:',
	      ##print '%1d %3d %1d %3d %2d %3s %2d %7.4f %6.3f %6.3f %6.3f %s %s'%\
	       ##(mini,mink,minj,minm,len(nvals),lm1,n,probl,el,curener,aveener,flag,action)
	  choicelist.pop(maxi)
	  self.choicelist=choicelist
	  self.varlst=varlst
	print 'time incrmorestep:',time.time()-T_0
	return len(choicelist),action,flag,el

    def incrementmore_patch2peak(self,allneardct,explst,updateentrop=True):
	T_0=time.time()
	nummult=len(ALLMULT)
	allax=[0,1,2,'u','c']
        selec=BestSelector()
	if updateentrop:
	 choicelist=[];varlst=[];self.usedchoices=[]
	 lst=[]
	 for pnum,pt in self.iter_patches():
	   ##if 0 in pt.counts:
	   if 0 in pt.counts[:-nummult]:
	    if pt.counts[:-nummult].count(0)>1 or rand()<0.5:
	     print 'found incomplete patch',pnum,pt.counts
	     lst.append(pnum)
	 for n in range(len(lst)):
	   q=lst[n]
	   ptq=self.patches[q]
	   ##ptq.show(explst,False,showssy=False)
	   cq=ptq.counts[:-nummult]
	   maxshared=0;pair=None;order=None
	   for j in range(len(cq)):
	    if explst[j].rangeType=='intra':
	     if cq[j]==0:
		hitdct={}
		for i in range(len(cq)):
	         if explst[i].rangeType=='intra':
		  if cq[i]>0:
		   for ax0 in allax:
		    if (i,j,ax0) in allneardct:
		      pij=(i,j,ax0);ordij=0
		    elif (j,i,ax0) in allneardct:
		      pij=(j,i,ax0);ordij=1
		    else:pij=None
		    if pij<>None:
		     nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[pij]
		     shaij=len(labels)
		     if shaij>maxshared:
			maxshared=shaij
			pair=pij;order=ordij
		     if shaij>=2:#OK? generalize?
		      ##print 'patch2peak:',n,q,i,j,pij,ordij,cq
		      numhits=0
		      for k in ptq[i]:
			if ordij==1:nearest0=nearestrev
			else:nearest0=nearest
			if k in nearest0:
			  vals=nearest0[k]
		  	  if len(vals)>0:
		            ##its=[(vals[m][0],m) for m in vals]#ener,m
			    for m in vals:
				enerm,cntm,labm=vals[m]
				if not m in hitdct:hitdct[m]=[0.0,0,{}]
				hitdct[m][0]+=enerm
				hitdct[m][1]+=1
				if not labm in hitdct[m][2]:hitdct[m][2][labm]=0
				hitdct[m][2][labm]+=1
		if len(hitdct)>0:
		  print 'total hits:',len(hitdct),hitdct
		  ##its=[hitdct[m][0]/hitdct[m][1],m) for m in hitdct]
		  its=[]
		  for m in hitdct:
		    enerm=hitdct[m][0]/hitdct[m][1]
	    	    notlinked=(j,m) in self.nonlinkedlst
		    if notlinked:enerm/=1.5#does not seem to have significant effect
		    its.append((enerm,m))
		  its.sort()
		  minit=min(its)
		  minener=minit[0];minm=minit[1]
		  ##print n,q,j,its
		  ##print minit,minener,minm
		  peak=explst[j].peakData.peaklist[minm]
		  peaknam='none'##getAsFormat(peak.names)
		  ##print peak.shifts,peaknam
		  entrop=self.getentrop(its)
		  labdct=hitdct[minm][2]
		  ##print labdct
		  labits=labdct.items()
		  maxpair=max(labits,key=lambda x: x[1])
		  minlab=maxpair[0]
		  print 'entrop (pat2pe): %1d %3d %2d %3s %6.3f %7.4f %7.4f'%\
		    (j,minm,len(its),minlab,minener,entrop,entrop+minener/2.0)
		  if minener<5.0:
		    choicelist.append((entrop+minener/2.0,len(varlst)))
		    varlst.append(((q,j),'pat2pe',its,hitdct))
		else:
		  print 'warning no hits',j
	 ##print choicelist
	 ##print varlst
	 choicelist.sort()
	else:#not updateentrop
	  choicelist=self.choicelist
	  varlst=self.varlst
	action,flag,em=9.9,None,None
        pselec=ProbabilitySelector()
	if len(choicelist)>0:
	  maxi,bestprob,bestn,minent=selec.selectpartner(choicelist)
	  met=varlst[bestn][1]
	  if met=='pat2pe':
	    vars2,met,its,hitdct=varlst[bestn]
	    ##print maxi,bestprob,bestn,minent,vars2,its
	    q,minj=vars2
	    n0,probm,minm,em=pselec.selectpartner(its)
	    minlab=max(hitdct[minm][2].items(),key=lambda x: x[1])[0]
	    notlinked=(minj,minm) in self.nonlinkedlst
	    if em<2.0:##5.0:
	      ptq=self.patches[q]
	      ptq.add((minj,minm),lab=minlab)
	      ##print (q,minj,minm,len(vals),minlab,n,probm,em)
	      ##print 'selected (best?, pat2pe) partner:',
	      ##print '%2d %1d %3d %2d %3s %2d %7.4f %6.3f'%\
	        ##(q,minj,minm,len(its),minlab,n0,probm,em),notlinked
	    if notlinked:
	      self.setlink(((minj,minm),(0,-1)),lab=minlab)
	      self.nonlinkedlst.remove((minj,minm))
	  choicelist.pop(maxi)
	  self.choicelist=choicelist
	  self.varlst=varlst
	print 'time incrmorestep:',time.time()-T_0,len(self.nonlinkedlst)
	return len(choicelist),action,flag,em

    def pop_partner(self,expj,lits):
	if None in expj.atnames and lits>5:
	  if rand()>0.5:return False
	return True	

    def get_distrstats(self,pair):
	normps=[array(peak.normps) for peak in pair]
	s=sum(normps[0]*normps[1]) #joint probability
	l0=log(normps[0])
	l1=log(normps[1])
	diff=l0-l1
	Dkl=sum(diff*normps[0]-diff*normps[1]) #divergence (symmetric)
	akl=sum(abs(diff)*(normps[0]+normps[1]))
	cent=-sum(l0*normps[1]+l1*normps[0]) #cross-entropy
	return s,Dkl,akl,cent

    def modify_allneardct(self,allneardct,explst):
	 for i,j,ax0 in allneardct:
		nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[(i,j,ax0)]
		for k in nearest.keys():#fwd TODO:rev
		  vals=nearest[k]
		  if len(vals)>0:
		     peak0=explst[i].peakData.peaklist[k]
		     bestpsum=0.0
		     for m in vals:
			enerm,cntm,labm=vals[m]
			peak1=explst[j].peakData.peaklist[m]
			distrstats=self.get_distrstats((peak0,peak1))
			psum,Dkl,akl,cent=distrstats
			print 'distrstats: %1d %3d %1d %1s %3d %3s %6.3f %7.4f %7.4f %7.4f %7.4f'%\
			(i,k,j,ax0,m,labm,enerm,psum,sqrt(Dkl),akl,cent)
			vals[m]=((enerm+sqrt(Dkl)*0.5)*0.5,cntm,labm)
	 save_dba2(allneardct,'allneardct_mod.pck')
	 1/0

    def increment(self,allneardct,allneardct0,explst,updateentrop=True,multilink=False,mode=1,cnt=None):
	T_0=time.time()
	#multi=(1,0,1,0)
        selec=BestSelector()
	if updateentrop:
	 self.extdct={}
	 choicelist=[];varlst=[];self.usedchoices=[]
	 ##for i in range(self.numexp):
	 ## for j in range(i,self.numexp):
	 ##   if (i,j) in allneardct:
	 for i,j,ax0 in allneardct:
	   ##if mode==1 or ax0=='u':
		nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[(i,j,ax0)]
		for k in nearest.keys():#fwd TODO:rev
		 if (i,k) in self.linked:likj=self.linked[(i,k)][j]
		 else:likj={}
		 ##print 'likj',likj
		 if len(likj)<1 or multilink or self.multi[j]:
		  vals=nearest[k]
		  if len(vals)>0:
		    if mode==1:its=[(vals[m][0],m) for m in vals]#ener,m
		    else:its=self.get_linkvalues(vals,k,i,j,ax0,allneardct,allneardct0,explst,mode)
		    #it might be a good idea to use only if (i,k) is patched...
		    if len(its)>0:
		     ##its.sort()
		     minit=min(its)
		     minener=minit[0];minm=minit[1]
		     print its
		     peak0=explst[i].peakData.peaklist[k]
		     bestpsum=0.0
		     if False:##for m in vals:
			enerm,cntm,labm=vals[m]
			peak1=explst[j].peakData.peaklist[m]
			distrstats=self.get_distrstats((peak0,peak1))
			psum,Dkl,akl,cent=distrstats
			print 'distrstats: %1d %3d %1d %1s %3d %3s %6.3f %7.4f %7.4f %7.4f %7.4f'%\
			(i,k,j,ax0,m,labm,enerm,psum,Dkl,akl,cent)
			if psum>bestpsum:
			  bestpsum=psum
			  ##minm=m
		     ##print minit,minener,minm
		     entrop=self.getentrop(its)##,scale=2.0)
		     mincnt=vals[minm][1]
		     ##if mincnt<2:entrop=max(1.5*entrop,0.5+entrop)
		     if mincnt<2:
			entrop=max(2.0*entrop,1.2+entrop)
			minener*=2.0
		     elif ax0=='c':
			entrop=max(1.5*entrop,0.5+entrop)
			minener*=1.5
		     elif j in [1,3]:
			entrop/=1.5
			minener/=1.5
		     minlab=vals[minm][2]
		     hastrue=False
		     for tup in vals.values():
			if tup[2]<>'na':
			  hastrue=True
			  break
		     ##score=entrop+minener+log(minener+0.1)-log(0.1)
		     score=entrop+minener/1.0
		     if cnt==0:##mode==2:
			  print 'Entrop: %1d %3d %1d %1s %3d %2d %3s %6.3f %7.4f %7.4f'%\
			  (i,k,j,ax0,minm,len(vals),minlab,minener,entrop,score),mincnt,hastrue
			  ##(i,k,j,ax0,minm,len(vals),minlab,minener,entrop,entrop+minener/2.0),mincnt
			  ##(i,k,j,ax0,minm,len(vals),minlab,minener,entrop,entrop*1.2+minener/3.0)
		     if minener<5.0:
		      ##choicelist.append((entrop,len(varlst)))
		      ##choicelist.append((entrop+minener/2.0,len(varlst)))
		      choicelist.append((score,len(varlst)))
		      varlst.append((k,(i,j,ax0),'fwd',its))
	 choicelist.sort()
	else:
	  choicelist=self.choicelist
	  varlst=self.varlst
	action,flag,em=0,None,None
        pselec=ProbabilitySelector()
	if len(choicelist)>0:
	  maxi,bestprob,bestn,minent=selec.selectpartner(choicelist,minfac=30.0)
	  mink,minpair,direc,its=varlst[bestn]
	  mini,minj,minax0=minpair
	  print 'minimum entropy: %1d %1d %s %3d %6.3f %6.3f %2d'%\
	        (minpair[0],minpair[1],minax0,mink,minent,bestprob,len(its))
	  #update its (assuming nearest has been updated)
	  nearest=allneardct[minpair][0]
	  vals=nearest[mink]
	  print vals
	  ##its=[(vals[m][0],m) for m in vals]#ener,m
	  its=self.get_linkvalues(vals,mink,mini,minj,minax0,allneardct,allneardct0,explst,mode=mode)
	  its.sort()
	  ##if not mink in self.usedchoices: self.usedchoices.append(mini)
	  print its
	  #try not to pop maxi from the choicelist, but pop minm from its
	  minlab=None
	  if len(its)==0:
	    print 'empty list of selections',maxi,minpair,mink
	    choicelist.pop(maxi)
	  elif its[0][0]>5.0:
	    print 'high energy',maxi,minpair,mink,its[0][0]
	    choicelist.pop(maxi)
	  else:
	    n,probm,minm,em,pnorm=pselec.selectpartner2(its)##,scale=2.0)
	    minener,mincnt,minlab=vals[minm]
	    if minener<2.0:
	      pkeys=((mini,mink),(minj,minm))
	      action,flag,curener=self.connect(pkeys,minax0,minlab,explst,em,allneardct,allneardct0,mode=mode)
	      print 'selected (best? incr %d) partner:'%mode,
	      print '%1d %3d %1d %3d %s %2d %3s %2d %7.4f %6.3f %6.3f %6.3f %6.3f %s %s'%\
	        (mini,mink,minj,minm,minax0,len(vals),minlab,n,probm,em,curener,minener,pnorm,flag,action)
	    else:print 'skipped partner: %1d %3d %1d %3d %s %2d %3s %2d %7.4f %6.3f %6.3f'%\
		(mini,mink,minj,minm,minax0,len(vals),minlab,n,probm,em,minener)
	    if self.pop_partner(explst[minj],len(its)):choicelist.pop(maxi)
	    #above: not allways pop - could more than one true partner
	    ##nearest[mink].pop(minm)
	    ##if mini==minj:#intra-experiment
	    ##  if minm in nearest:#not allready popped
	    ##    nearest[minm].pop(mink)
	  self.choicelist=choicelist
	  self.varlst=varlst
	if em==None and not action:em=None
	print 'numpatches:',self.numpatches,len(self.choicelist),em
	print 'time incrstep:',time.time()-T_0
	##if mode==2:1/0
	return len(choicelist),action,flag,em,minlab

    def get_prob_doubled(self,ref):
	if ref in self.nonassigned:#remaining peaks
	  return 1.0,'R'
	if ref in self.assignedpeaks:
	  return 0.5,'A'
	if ref in self.noisepeaks:
	  return 0.8,'N'
	if ref in self.neverused:
	  return 0.7,'Q'
	else:
	  return 0.2,'U'#unique

    def setpeakflags(self,explst):
	for k in range(len(explst)):
	  for m,peak in enumerate(explst[k].peakData.peaklist):
	    ref=(k,m)
	    peak.flag='L'#linked
	    if ref in self.nonassigned:
		peak.flag='R'
	    elif ref in self.noisepeaks:
	  	peak.flag='N'
	    elif ref in self.neverused:
	  	peak.flag='Q'

    def increment_by_missing_atom_assignments(self,shdct,explst,pasdct,tpasdct,updateentrop=True,usenonassigned=False):
        print 'increment_by_missing_atom_assignments'
        selec=BestSelector()
	btdct=self.bytypedct
	totmiss=0;matches=0
	allatys=self.assigned_types
	forbidden=[]
	if updateentrop:
	  ks=allatys.keys();ks.sort()
	  ##print 'blacklist:',self.blacklist
	  print 'updating entropy (ma)',len(ks),ks
          pselec=ProbabilitySelector()
	  choicelist=[];varlst=[];self.usedchoices=[]
	  for i in range(len(self.seq)-1):
	   if not i in forbidden:
	    if i in allatys:#TODO: else: what...
	      spin=allatys[i]
	      spin.show()
	      ##espin=spin.get_espinsystem()
	      ##eval_true,nump,numtrue=spin.eval_true_peaks(explst)
    	      missing=spin.get_missing_atom_assignments(shdct,(self.seq[i+1],self.seq[i]))
	      #allow confirmation? (not missing?)
	      totmiss+=len(missing)
	      print 'result getmiss %2d %s %2d'%\
		  (i,self.seq[i+1],len(missing)),missing
	      if i in btdct:
		  print 'btdct[i].keys()',btdct[i].keys()
	      for ordi,atn,weakflag in missing:
	        its=[]
		atnord=ordi,atn
		##if not (i,atnord) in self.blacklist:
		if atn in ['C','CA','N']:xdb=0
		else: xdb='BGDEZH'.index(atn[1])-ordi+1
		pmiss0={0:0.001, 1:0.01, 2:0.1, 3:0.5, 4:0.7, 5:0.90, 6:0.90, 7:0.90}[xdb]
		if ordi==-1:pmiss=pmiss0
		else: pmiss=min(pmiss0,0.1)
	        if i in btdct:
		  if True:##weakflag<>'w':
		   if atnord in btdct[i]:
		    totcnt=btdct[i][atnord][0]
		    totcnt=max(totcnt,20)*1.0
		    refdct=btdct[i][atnord][1]
		    print 'found match %2d %2d %4s %2d %2d'%(i,ordi,atn,totcnt,len(refdct)),refdct
		    matches+=1
		    for ref in refdct:
		      count,axis=refdct[ref]
		      if ref in self.refdct2 and i in self.refdct2[ref]:
			atndct=self.refdct2[ref][i]
		        if not atnord in atndct:atndct[axis]={atnord:None}
		      else:
			atndct={axis:{atnord:None}}
		      ssyxener=spin.add_peak(ref,explst,mode=2,execute=False,atndct=atndct)
		      if ssyxener<1.0:
			pdoub,flag=self.get_prob_doubled(ref)
			##its.append(((ref,flag),pdoub*refdct[ref]))
			##its.append(((ref,axis,flag),pdoub*count))
			its.append(((ref,axis,flag,atndct),pdoub*count))
	        if i in pasdct:## and len(its)<=1:#0:
		    numpos=[0,0]
		    totcnt=10.0
		    if atnord in pasdct[i]:
		      ##print 'check pasrefs',pasdct[i][atnord]
		      ##for ref in self.neverused+self.noisepeaks:
		      if usenonassigned:
		        searchrefs=self.neverused+self.noisepeaks+self.nonassigned.keys()+self.assignedpeaks#allpeaks
		      else:
		        searchrefs=self.neverused+self.noisepeaks
		      for ref in searchrefs:
			if ref in pasdct[i][atnord]:
		           ener,axis=pasdct[i][atnord][ref]
			   if ref in self.refdct2 and i in self.refdct2[ref]:
				atndct=self.refdct2[ref][i]
				if not atnord in atndct:atndct[axis]={atnord:None}
			   else:
			       atndct={axis:{atnord:None}}
			   ssyxener=spin.add_peak(ref,explst,mode=2,execute=False,atndct=atndct)
			   numpos[0]+=1
			   pdoub,flag=self.get_prob_doubled(ref)
			   if ssyxener<1.0:
			     ##print 'ref never used',ref,i,atnord,ener,ssyxener
			     px=exp(-(ener+2*ssyxener))*pdoub
			     score=0.7*totcnt*px
			     print 'maybe use:',i,atnord,ref,ssyxener,ener,pdoub,score
			     its.append(((ref,axis,'Q',atndct),score))
			     numpos[1]+=1
		  	     ##print numpos,
	        if i in tpasdct:
		  if atnord in tpasdct[i]:
		     print 'true values:',tpasdct[i][atnord]
	        its.append(((None,None,'-',None),pmiss*10.0))##totcnt))#NOISE
	        its.sort(lambda x,y: cmp(y[-1],x[-1]))
	        ##print 'its:',i,atnord,len(its),its
	        if len(its)>1 or its[0][0][0]<>None:
		  ##if len(its)>1 or its[0][0][0]<>None:
		    print 'summarizing possibilities:',i,atnord,len(its),its
		    nums=array([it[-1] for it in its])
		    nums/=sum(nums)
		    entrop=getentrop4(nums)
		    if weakflag=='w':entrop*=2.0
		    print 'entrop (ma): %2d %1d %4s %2d  %7.4f'%(i,ordi,atn,len(nums),entrop)
		    choicelist.append((entrop,len(varlst)))
		    varlst.append(((i,atnord),its))
	        else:
		  ##else:
		    self.blacklist.append((i,atnord))
		    print 'still no matching assignments for:',i,ordi,atn
	  choicelist.sort()
	  print 'stat:',totmiss,matches
	else:
	  choicelist=self.choicelist
	  varlst=self.varlst
	action='none';minent=999.99
	if len(choicelist)>0:
          pselec=ProbabilitySelector()
	  maxi,bestprob,bestn,minent=selec.selectpartner(choicelist)
	  minvars,its=varlst[bestn]
	  aty,atnord=minvars
	  print its
	  n,cprobt,prob,best=pselec.pselectpartner(its)
	  print n,cprobt,prob,best
	  minref,axis,flag,atndct=best
	  choicelist.pop(maxi)
	  action='noise'
	  if minref<>None:
	    chkn_vars=(aty,len(self.seq)-1,self.assigned_types)
	    ssy=self.assigned_types[aty]
	    ##atndct={axis:{atnord:None}}
	    ##atndct=self.refdct2[ref][i]
	    ##atndct[axis]={atnord:None}
	    ssyxener=ssy.add_peak(minref,explst,mode=2,execute=False,atndct=atndct)
	    mink,minm=minref
            peak=explst[mink].peakData.peaklist[minm]
	    istrue,numas=ssy.has_true_assign(peak,aty)
	    action='add_skip'
	    if ssyxener<0.99:
	      ssyxener=ssy.add_peak(minref,explst,mode=2,atndct=atndct,checknei=chkn_vars)
	      action='add'
	      self.blacklist.append(minvars)
	    print 'assigning peak',minref,flag,aty,atnord,n,ssyxener,action,istrue
	  ##else:self.blacklist.append(minvars)
	  self.choicelist=choicelist
	  self.varlst=varlst
	return action,minent,len(choicelist)

    def increment_by_nonlinked(self,explst,shdct,maxener=24.0,updateentrop=True):
	action='none';minscore=999
        selec=BestSelector()
	allatys=self.assigned_types
	T_0=time.time()
	if updateentrop:
	  choicelist=[];varlst=[];self.usedchoices=[]
	  for ref in self.nonlinkedlst:
	    k,m=ref
	    expk=explst[k]
	    data=[(None,(None,''),expk.dimension*2.0)]#2.0 is 0.5*(2.0**2)
	    peak=expk.peakData.peaklist[m]
	    peakasname='none'##getAsFormat(peak.names)
	    ##bestener=999.9;bestarg=None
	    bestener=data[0][-1];bestarg=(None,[])
	    for i in range(len(self.seq)-1):##allatys:
	     if i in allatys:
	      ssy=allatys[i]
    	      aas=(self.seq[i+1],self.seq[i])
	      ##print i,aas,peakasname,ref,peak.shifts
	      ##ssy.show()
	      ener,assignment=ssy.get_assign(ref,explst,shdct,aas)
	      #best atom assignment based on assigned atoms;also included non-assigned from shdct?
	      ##print peakasname,ref,i,ener,assignment
	      if len(assignment)==expk.dimension:
		if ener<bestener:
		  bestener=ener
		  bestarg=(i,assignment)
		if ener<maxener:
		  data.append((i,assignment,ener))
	    if len(data)>1:
	      data.sort(lambda x,y: cmp(x[-1],y[-1]))
	      eners=array([it[-1] for it in data])
	      print len(data),data,eners,bestarg
	      entrop=getentrop3(eners)
	      score=entrop+bestener/2
	      mini,minatn=bestarg
	      if mini==None:
		istrue=2
		for it in data:
		 aty=it[0]
		 if aty<>None:
		  thistrue,numas=allatys[aty].has_true_assign(peak,aty)
		  if thistrue:
		    istrue=3
		    break
	      else:istrue,numas=allatys[mini].has_true_assign(peak,mini)
	      print 'entrop: %1d %3d  %2d  %1d  %7.4f %7.4f %7.4f'%(k,m,len(eners),istrue,score,entrop,bestener),
	      print peakasname,bestarg
	      choicelist.append((score,len(varlst)))
	      varlst.append((ref,data))
	  choicelist.sort()
	      ##print entrop
	  print 'Time nonlink used:',time.time()-T_0,len(choicelist)
	else:
	  choicelist=self.choicelist
	  varlst=self.varlst
	if len(choicelist)>0:
	  maxi,bestprob,bestn,minscore=selec.selectpartner(choicelist)
	  minref,data=varlst[bestn]
	  mink,minm=minref
	  eners=array([it[-1] for it in data])
	  if minscore<99.9:
	    choicelist.pop(maxi)
            pselec=ProbabilitySelector()
	    probs=exp(-array(eners));probs/=sum(probs)
	    print data
	    print list(probs)
	    selj,cprob,probj=pselec.pselectpartner2(probs)
	    mini,assj,enerj=data[selj]
	    if mini==None:
	      print 'assigned as noise peak',minref; action='noise'
	      ##self.noisepeaks.append(minref)#needed?
	    else:
	      ##chkn_vars=(mini,len(self.seq)-1,self.assigned_types)
	      peak=explst[mink].peakData.peaklist[minm]
	      peakasname='none'##getAsFormat(peak.names)
	      istrue,numas=allatys[mini].has_true_assign(peak,mini)
	      print 'selected (best?) partner:',
	      print '%6.3f %1d %3d %2d %2d %1d %7.4f'%(minscore,mink,minm,mini,selj,istrue,probj),peakasname,assj
	      ssy=allatys[mini]
	      ##ssy.show()
	      atndct=dict([(i,{assj[i]:None}) for i in range(len(assj))])
	      ssy.add_peak(minref,explst,mode=2,atndct=atndct)##,checknei=chkn_vars)
	      #or check ssyxener before adding?
	      ##ssy.update_maintain()
	      ##ssy.show()
	      action='add'
	      ##self.assignedpeaks.append(minref)#needed?
	  self.choicelist=choicelist
	  self.varlst=varlst
	return action,minscore,len(choicelist)

    def increment_by_single_peak(self,shdct,explst,updateentrop=True):
        selec=BestSelector()
	if updateentrop:
	  choicelist=[];varlst=[];self.usedchoices=[]
	  for ref in self.nonassigned:
	  #TODO: also the never assigned...
	    k,m=ref
	    data=self.refdct[ref]
	    nums=data.values()
	    entrop=self.nonassigned[ref]
	    if k in ALLMULT>3:entrop*=1.5
	    print 'entrop: %1d %3d  %2d  %7.4f'%(k,m,len(nums),entrop)
	    choicelist.append((entrop,len(varlst)))
	    varlst.append((ref,data))
	  choicelist.sort()
	else:
	  choicelist=self.choicelist
	  varlst=self.varlst
	action='none';minent=999.99
	if len(choicelist)>0:
	  maxi,bestprob,bestn,minent=selec.selectpartner(choicelist)
	  minref,data=varlst[bestn]
	  nums=data.values()
	  cntf=sum(nums)
	  sumnoise=1.0-cntf
	  if sumnoise>0.001:
	    ##data[-1]=min(0.1,sumnoise)
	    ##data[-1]=min(0.05,sumnoise)
	    if len(nums)>1:
	      data[-1]=min(0.02,sumnoise)
	    else:
	      data[-1]=min(0.002,sumnoise)
	  mink,minm=minref
          peak=explst[mink].peakData.peaklist[minm]
	  peaknam='none'##getAsFormat(peak.names)
	  print 'minimum entropy: %1d %3d %6.3f %6.3f %2d %16s'%\
	        (mink,minm,minent,bestprob,len(data),peaknam),data
	  if minent<99.9:##1.5:
            pselec=ProbabilitySelector()
	    its=data.items();its.sort(lambda x,y: cmp(y[-1],x[-1]))
	    print its
	    n,cprobt,probt,bestt=pselec.pselectpartner(its)
	    print n,cprobt,probt,bestt
	    istrue=-1
	    choicelist.pop(maxi)
	    if bestt<0:
		print 'assigned as noise peak',minref; action='noise'
		self.nonassigned.pop(minref)
		self.noisepeaks.append(minref)
	    else:
		self.nonassigned.pop(minref)
		assityp=bestt
		atndct=self.refdct2[minref][assityp]
		print 'assigned typed peak',assityp,minref,atndct
		chkn_vars=(assityp,len(self.seq)-1,self.assigned_types)
	        if assityp in self.assigned_types:
		  ##pnum=self.assigned_types[assityp]
		  ssy=self.assigned_types[assityp]
	    	  ##patch=self.patches[pnum]
		  ##ssy=patch.spin
		  pener=peak.assignenerlst[assityp]
		  istrue,numas=ssy.has_true_assign(peak,assityp)
		  thres=0.99
		  if ssy.complete:
		    print 'type allready exists for peak (complete)',assityp,minref; action='comp'
		    ##ssyxener=0.0
		    thres=0.5
		  if True:##else:
		   ssyxener=ssy.add_peak(minref,explst,mode=2,execute=False,atndct=atndct)
		   if ssyxener<thres:##0.99:
		    ##patch.add(minref,lab=atndct)
		    ssyxener=ssy.add_peak(minref,explst,mode=2,atndct=atndct,checknei=chkn_vars)
		    ##print pnum,patch,ssy
	  	    comp=ssy.get_complete(shdct,(self.seq[assityp+1],self.seq[assityp]))
	  	    ssy.complete=comp
		    print 'type allready exists for peak',assityp,minref,ssyxener,comp,istrue
		    action='add'
		    self.assignedpeaks.append(minref)
		   else:
		    print 'type allready exists for peak (skipped)',assityp,minref,ssyxener,istrue
		    action='add_skip'
		    self.noisepeaks.append(minref)
		  print 'check %8s: %15s %1d %2d %1d %7.4f %7.4f'%(action,peaknam,istrue,assityp,numas,pener,ssyxener)
	        else:
		  ##pnum=len(self.patches)
		  print 'creating new type for peak',assityp,minref; action='new'
		  ##patch=PatchDict()#empty init
		  ##patch.label=assityp
		  ##patch.assigned_type=assityp
		  ##patch.add(minref,lab=atndct)
	  	  ##self.patches.append(patch)
	  	  ##self.numpatches+=1
	  	  ssy=SpinSystem(aty=assityp)##patch,explst,mode=2)
		  ssy.add_peak(minref,explst,mode=2,atndct=atndct,checknei=chkn_vars)
	  	  ##self.spindct[pnum]=ssy
	  	  ##self.keylst.append((assityp,pnum))
	  	  ##self.assigned_types[assityp]=pnum
	  	  self.assigned_types[assityp]=ssy
		  pener=peak.assignenerlst[assityp]
		  istrue,numas=ssy.has_true_assign(peak,assityp)
		  print 'check %8s: %15s %1d %2d %1d %7.4f'%(action,peaknam,istrue,assityp,numas,pener)
	    print 'selected (best?) partner:',
	    print '%1d %3d %2d %2d %7.4f %6.3f %1d'%(mink,minm,n,bestt,probt,-log(1.0-probt),istrue),action
	  self.choicelist=choicelist
	  self.varlst=varlst
	return action,minent,len(choicelist)

    def fill_from_true(self,explst,shdct):
	self.assigned_types={}
	allatys=self.assigned_types
	self.nonassigned=[]
	self.noisepeaks=[]
	self.neverused=[]
	for k in range(len(explst)):
	  expk=explst[k]
	  for m,peak0 in enumerate(expk.peakData.peaklist):
	    ref=(k,m)
	    if k>=9:peak=peak0.oldPeaks[0]
	    else:peak=peak0
	    if peak.allAssigns==None:
	      self.noisepeaks.append(ref)
	    else:
	      peakasname='none'##getAsFormat(peak.names)
	      for nams in peak.allAssigns:
		atndct={}
		for i in range(len(nams)):
		  npasi=nams[i][0]
	          if nams[i][3]=='N':
		    break
		aty=npasi-1
		prevord=None
		for i in range(len(nams)):
		  ordi=expk.order[i]
		  if ordi==None:ordi=prevord
		  prevord=ordi
		  ordp=nams[i][0]-npasi
		  if True:##ordp==ordi:
		    atni=expk.atnames[i]
		    ##atnord=(ordi,nams[i][3])
		    atnord=(ordp,nams[i][3])
		    atndct[i]={atnord:None}
		  else:
		    print 'rejecting true peak',peakasname,ref,nams,aty,ordp,ordi
		    break
		if len(atndct)==expk.dimension:
		  if not aty in allatys:allatys[aty]=SpinSystem(aty=aty)
		  spin=allatys[aty]
		  print 'adding true peak',peakasname,ref,nams,aty,atndct
		  if k==4:
		   if abs(nams[0][0]-nams[1][0])==0:
		    oatndct={0:atndct[1], 1:atndct[0]}
		    ssyxener =spin.add_peak( ref,explst,mode=2,atndct= atndct,execute=False,overwriteord=True)
		    ossyxener=spin.add_peak( ref,explst,mode=2,atndct=oatndct,execute=False,overwriteord=True)
		    print 'comparing eners',ssyxener,ossyxener
		    if min(ssyxener,ossyxener)>1.0:
			print 'no valid combination',ssyxener,ossyxener,atndct,oatndct
		    else:
		     if ssyxener<=ossyxener:
		      ssyxener=spin.add_peak(ref,explst,mode=2,atndct= atndct,execute=True,overwriteord=True)
		     else:
		      print 'swapping axes',ssyxener,ossyxener,peakasname,ref
		      ssyxener=spin.add_peak(ref,explst,mode=2,atndct=oatndct,execute=True,overwriteord=True)
		  else:
		    ssyxener=spin.add_peak(ref,explst,mode=2,execute=True,atndct=atndct,overwriteord=True)
	for t in allatys.keys():##range(len(self.seq)-1):
	  spin=allatys[t]
	  spin.neighbors={}
	  if t>0:
	    try:spin.neighbors[-1]=allatys[t-1]
	    except KeyError:pass
	  if t<len(self.seq)-2:
	    try:spin.neighbors[1] =allatys[t+1]
	    except KeyError:pass
	  comp=spin.get_complete(shdct,(self.seq[t+1],self.seq[t]))
	  spin.complete=comp
	  spin.transfer_neighbor_assignments(t,len(self.seq)-1,allatys)

    def update_spinsystems(self,reusesdct,newssydct,chosen):
	print 'updating spin systems'
	for i in range(len(self.seq)-1):
	  if i in newssydct:
	    print 'using modified spin system',i
	    self.assigned_types[i]=newssydct[i]
	  else:
	    ri=reusesdct[i]
	    print 'using reused spin system',i,ri
	    try:self.assigned_types[i]=chosen[ri].assigned_types[i].deep_copy()
	    except KeyError:
		print 'WARNING: no key for reused spin system',i,ri

    def pre_eval_assignments(self,explst,shdct,scheme,moldba=None,verb=True,nsbias=0.25,savespins=False):
	totscore=0.0
	totcomp=0;totfalse=0;tottrue=0;numtot=0.0
	nummiss=0;numbad=0
	totbad=0;totbadsc=0
	totmiss=0;totmisssc=0
	totnum=0;totnumsc=0
	totsumdevs2=0.0;totsumdevs2sc=0.0
	T_0=time.time()
	self.fullpeakdct={}
	truedct={}
	for k in range(len(explst)):
	  numtot+=len(explst[k].peakData.peaklist)
	tripsum=0.0
	if not verb:cmpeners=self.toteners[:]
	self.toteners=ones(len(self.seq)-1)*19.9
	ord1={0:-1,-1:0}
	dnei={0:1,-1:-1}
	for i in range(len(self.seq)-1):
	  if not i in self.assigned_types:
	    print 'warning spin system is missing',i,
	    for delt in [-1,1]:
	      if i+delt in self.assigned_types:
		nspin=self.assigned_types[i+delt]
		if -delt in nspin.neighbors:
		  ospin=nspin.neighbors[-delt]
		  print 'found:',(delt,ospin.keys())
		  ospin.show()
	    print
	if len(self.seq)-1 in self.assigned_types:
	  ctermspin=self.assigned_types[len(self.seq)-1]
	  ctermspin.elink=0.00#OK?
	  ctermspin.etyps={-1:0.00,0:0.00}
	for i in range(len(self.seq)-1):
	  if i in self.assigned_types:
	    ##pnum=self.assigned_types[i]
	    spin=self.assigned_types[i]
	    spin.assigned_type=i
	    spin.set_stats()
	    if 1 in spin.neighbors:
		spin.neighbors[1].set_stats()
	    spin.show()
	    ##tripener=spin.get_tripener(scheme.tripenerdct,scheme.rcdct,scheme.seq,i+1)
	    ##tripsum+=tripener
	    ##print 'tripener is:',tripener
	    ##print spin
	    ##patch=self.patches[pnum]
	    ##spin=patch.spin
	    spin.get_flatpeakdct(explst,self.fullpeakdct)
	    espin=spin.get_espinsystem()
	    eval_true,nump,numtrue=spin.eval_true_peaks(explst)
	    numfalse=nump-numtrue
	    totfalse+=numfalse
	    tottrue +=numtrue
	    ##numtot+=nump
	    if numfalse>0:numbad+=1
	    if spin.complete:totcomp+=1
	    aac=self.seq[i+1]
	    aap=self.seq[i]
	    etbb,etsc=spin.get_etyp(aac,aap,shdct,verb=True)
	    etyp=etbb+etsc
	    spin.elink=9.99
	    if -1 in spin.neighbors:
	      spinp=spin.neighbors[-1]
	      ##print 'spinp:',spinp
	      elink=spin.get_elink(spinp,verb=verb)##True)##,redo=True)
	      spin.elink=elink
	    elif i==0:
		elink=0.0
	        spin.elink=0.0
	    ##else:elink=9.999
	    else:elink=0.999#plausible
	    ##etot=etyp+elink+10*espin
	    etot=etyp+elink+1.00*espin
	    totscore+=etot
	    ns=len(spin.flatpeakdct);spin.numspins=ns
	    ##self.toteners[i]=etot-0.1*ns
	    if ns==0:print 'NOTE: no peaks asigned to spinsystem (except weak)',i,aac,aap
	    print 'result preeval %2d %s %s %1d %2d %7.4f  %6.3f %6.3f %6.3f  %7.4f'%\
		  (i,aac,aap,spin.complete,ns,eval_true,espin,etyp,elink,etot-nsbias*ns)
	    truedct[i]=(ns,eval_true)
	    ##if not verb:print 'comparing eners',i,self.toteners[i],cmpeners[i]
	    if moldba<>None:
	      reskey=str(i+2)
	      if reskey in moldba:
		preskey=str(i+1)
		print 'truevalues:',moldba[reskey]
		tsh=(moldba[reskey],None)##moldba[preskey])
		cmpresul=spin.compare_true(tsh,(aac,aap))
		miss,bad,sumdevs2,misssc,badsc,sumdevs2sc,num,numsc=cmpresul
		print 'truestat:',len(miss),len(misssc),len(bad),len(badsc),bad,badsc,sumdevs2,sumdevs2sc,miss,misssc
		totbad+=len(bad);totbadsc+=len(badsc)
		totmiss+=len(miss);totmisssc+=len(misssc)
		totnum+=num;totnumsc+=numsc
		totsumdevs2+=sumdevs2;totsumdevs2sc+=sumdevs2sc
	  else:
	    print 'result preeval %2d %s %s %2d %1d %7.4f'%\
		  (i,self.seq[i+1],self.seq[i],0,-1,-1)
	    nummiss+=1
	    totscore+=1.0#IMPORTANT?!
	    ##print 'NOTE spinsystem is missing',i
	    print 'eval:      !!!!!!!    -1',i,'NOTE spinsystem is missing'
	  print 'time pree:',time.time()-T_0;T_0=time.time()
	tot=len(self.seq)-1.0
	if verb:self.setpeakflags(explst)
	self.nonlinked=self.shownonlinked(explst,show=True)
	##self.combscore=(totscore+1.0*self.nonlinked-totcomp)/tot;self.energy=self.combscore
	self.combscore=(totscore+0.5*self.nonlinked-totcomp)/tot;self.energy=self.combscore
	print 'finaleval: %7.4f %7.4f %7.4f %2d %2d %3d %3d %7.4f  %6.3f'%\
		(totcomp/tot,totfalse/numtot,tottrue/numtot,numbad,nummiss,totfalse,self.nonlinked,self.combscore,tripsum/tot),
	if moldba<>None:
	  print	totbad,totbadsc,totmiss,totmisssc,sqrt(totsumdevs2/totnum),sqrt(totsumdevs2sc/totnumsc),totnum,totnumsc,len(self.multiusedlst)
	else: print
	if verb:print len(self.nonassigned),len(self.neverused),len(self.noisepeaks),numtot-tottrue,self.nonlinked,tripsum/tot
	##print 'combscore (final)',self.combscore,tot,totscore,3.0*self.nonlinked,totcomp
	#finally calculate toteners
	for i in range(len(self.seq)-1):
	  if i in self.assigned_types:
	    spin=self.assigned_types[i]
	    #self.toteners[i]=etot-0.1*ns
	    ##self.toteners[i] = spin.etyps[0]-spin.numspins*0.1+sum(spin.espins.values())*10.0
	    self.toteners[i] = spin.etyps[0]+sum(spin.espins.values())*1.0
	    self.toteners[i]+=(spin.elink/2.0)
	    self.toteners[i]+=(spin.etyps[-1]/2.0)
	    if i+1 in self.assigned_types:
		##print 'reevaluating totener for spin system',i
		nspin=self.assigned_types[i+1]
		##print dir(nspin)
		##nspin.show()
		self.toteners[i]+=(nspin.elink/2.0)
	        self.toteners[i]+=(nspin.etyps[0]/2.0)
	    ##elif i<len(self.seq)-1: self.toteners[i]+=2.0#optimize constant
	    else:
	        self.toteners[i]+=(spin.elink/2.0)
	        self.toteners[i]+=(spin.etyps[-1]/2.0)
	newtotscore=sum(self.toteners)
	for i in range(len(self.seq)-1):
	  if i in self.assigned_types:
	    spin=self.assigned_types[i]
	    self.toteners[i]-=(spin.numspins*nsbias)#must not contribute to newtotscore
	    if not verb:print 'comparing eners',i,self.toteners[i],cmpeners[i]
	    if spin.numspins==0:
		newtotscore+=1.0#OK? was 5.0
	        self.toteners[i]+=1.0
	    else:
	      aac=self.seq[i+1]
	      aap=self.seq[i]
	      ns,eval_true=truedct[i]
	      nummult=0
	      for ref in spin.flatpeakdct:
		if ref in self.multiusedlst:nummult+=1
	      spin.nummult=nummult
	      self.toteners[i]+=(spin.nummult*nsbias)#must not contribute to newtotscore
	      print 'result Preeval %2d %s %s %1d %2d %7.4f  %6.3f %2d'%\
		  (i,aac,aap,spin.complete,ns,eval_true,self.toteners[i],nummult)
	    if savespins:
	      spin.neighbors.clear()
	      save_dba2(spin,'allspins/spin%d.pck'%i)
	self.combscore=(newtotscore+0.5*self.nonlinked-totcomp)/tot;self.energy=self.combscore
	print 'combscore (final)',self.combscore,tot,newtotscore,0.5*self.nonlinked,totcomp

    def put_genestr(self):
	allkeys=[]
	for i in range(len(self.seq)-1):
	  if i in self.assigned_types:
	    spin=self.assigned_types[i]
	    lst=[]
	    for ref in spin.flatpeakdct:
		peak,p,atndct=spin.flatpeakdct[ref]
		atnits=atndct.items();atnits.sort()
		lst.append((ref,tuple(atnits)))
	    lst.sort()
	    allkeys.append(tuple(lst))
	  else:
	    allkeys.append(())
	self.genestr=tuple(allkeys)

    def build_from_genestr(self,explst,merge=False):
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	tup=self.genestr
	allatys=self.assigned_types
	self.fullpeakdct={}
	for i in range(len(tup)):
	  if i in allatys:ssy=allatys[i]
	  else:
	    ssy=SpinSystem(aty=i)
	    allatys[i]=ssy
	  pairs=tup[i]
	  ##print i,pairs
	  for ref,atnits in pairs:
	    atndct=dict([(ax,{atnord:None}) for ax,atnord in atnits])
	    ##print ref,atndct
	    ##spindct[pnum]=ssy
	    ##keylst.append((k,pnum))
	    ssy.add_peak(ref,explst,mode=2,execute=True,atndct=atndct)##,overwriteord=True)
	  ssy.update_maintain()
	self.set_neighbor_spinsystems()
	self.transfer_all_neighbor_assignments(merge=merge)
	for i in range(len(tup)):
	  ssy=allatys[i]
	  ssy.assigned_type=i
	  ssy.get_flatpeakdct(explst,self.fullpeakdct)
	  ssy.update_maintain()
	  comp=ssy.get_complete(shdct,(self.seq[i+1],self.seq[i]))
	  ssy.complete=comp
	  ##ssy.show()
	    
    def eval_diff(self,other):
	gs0=self.genestr
	gs1=other.genestr
	sumdi=0
	for i in range(len(self.seq)-1):
	  s0=set(gs0[i])
	  s1=set(gs1[i])
	  di=len((s0|s1)-(s0&s1))
	  sumdi+=di
	return sumdi

    def recombine(self,num,members,newssa,shdct,explst,thr0=0.5,step=0.1,nsbias=0.25):
	current=self;others=members[:num]+members[num+1:]
	thr=0.0
	newssydct={}
	reusesdct={}
	prev=None
	newtot=0.0
	newssa.fullpeakdct={}	
	newssa.toteners=[]
	numcomp=0
	pselec=ProbabilitySelector()
	temp=0.1##1.0
	for i in range(len(self.toteners)):
	  curener =current.toteners[i]
	  otheners= [(others[j].toteners[i],j) for j in range(len(others))];otheners.sort()
	  try:curns=current.assigned_types[i].numspins
	  except AttributeError:
	    print 'warning: no attribute numspins for current',i;curns=-1
          except KeyError:
            print 'warning: no key numspins for current',i;curns=-1
	  probs=exp(-array([tup[0] for tup in otheners]));probs=list(probs/sum(probs))
	  jind,cprob,probj=pselec.pselectpartner2(probs)
	  jmate=otheners[jind][1]
	  mate =others[jmate]
	  try:matns=mate.assigned_types[i].numspins
	  except AttributeError:
	    print 'warning: no attribute numspins for mate',i;matns=-1
          except KeyError:
            print 'warning: no key numspins for mat',i;matns=-1
	  matener=otheners[jind][0]
	  ediff=curener-matener
	  print 'receners:%2d %6.3f %6.3f %6.3f %2d %2d'%(i,curener,matener,ediff,curns,matns),
	  ptest=rand()
	  forbidinher=False
	  if i in current.assigned_types:
	    spin=current.assigned_types[i]
	  else:
	    print 'warning: no spin assigned',i,curener,ediff#modify ediff?
	    spin=SpinSystem(aty=i)
	    spin.elink=19.99
	    spin.espins={-1:9.99,0:9.99}
	    spin.etyps= {-1:9.99,0:9.99}
	    spin.flatpeakdct={}
	    forbidinher=True
	  if abs(ediff)>0.000001 and ediff>thr or exp((ediff-thr)/temp)>ptest:#using Boltzman temperature
	    num=mate.popnum
	    oldnum=current.popnum
	    current=members[num]
	    older=members[oldnum]
	    others =members[:num]+members[num+1:]
	    print 'switched',num,oldnum,thr
	    thr=thr0
	    if i>0:
	      ptest=rand()
	      if (ptest<0.95 or forbidinher) or not i in older.assigned_types:
	        ##spin=spin.deep_copy(include_weak={-1:False,0:True})
	        if i in current.assigned_types:spin=current.assigned_types[i].deep_copy(include_weak={-1:False,0:True})
		#CHECK: why not include_weak allways False. Har set nogle, som arver shift uden peak!
	        newprev=prev.deep_copy(include_weak={0:False,-1:True})
	      else:
	        if i in current.assigned_types:spin=current.assigned_types[i].deep_copy(include_weak={-1:False,0:True})
	        newprev=prev.deep_copy(include_weak={0:True, -1:True})
		if i in older.assigned_types:oldspin=older.assigned_types[i]
		ptest=rand()
		print 'combining spin systems',oldspin==spin,ptest
		if True:##ptest<0.5:
		  oldspin.inheretnew(spin,explst)#spin inherets peaks only present in oldpsin
		else:
		  oldspin.inheretsplit(spin,explst,-1)
	      spin.update_neighbor(newprev,i)##,len(self.seq)-1,allatys)
	      print spin.espins,spin.etyps,spin.elink
	      #new elink
	      ##elink=spin.get_elink(newprev,expectX=True);spin.elink=elink
	      elink=spin.get_elink(newprev,expectX=False);spin.elink=elink
	      #modified etyps[-1] for this and etyps[0] for prev (same with espins)
	      espin=spin.get_espinsystem()
	      pespin=newprev.get_espinsystem()
	      etbb0,etsc0=spin.get_etyp(   self.seq[i+1],self.seq[i],  shdct)##aajc,aajp,dct)
	      etyp0=etbb0+etsc0
	      etbb1,etsc1=newprev.get_etyp(self.seq[i],  self.seq[i-1],shdct)
	      etyp1=etbb1+etsc1
	      print elink,etyp0,etyp1,pespin,prev.elink,
	      fpd=newprev.flatpeakdct
	      ns=len(fpd)
	      comp0=spin.get_complete(   shdct,(self.seq[i+1],self.seq[i]));spin.complete=comp0
	      comp1=newprev.get_complete(shdct,(self.seq[i],  self.seq[i-1]));newprev.complete=comp1
	      ##addener=prev.elink+etbb1+etsc1+pespin*10.0##sum(newprev.espins.values())*10.0
	      addener=prev.elink/2+spin.elink/2+newprev.etyps[0]+newprev.etyps[-1]/2+\
		      spin.etyps[0]/2+pespin*1.0
	      if ns==0:addener+=1.0
	      print 'addener',i,addener,ns
	      print sum(spin.etyps.values()),sum(newprev.etyps.values())
	      newtot+=addener
	      numcomp+=comp1
	      newssydct[i-1]=newprev
	      newssydct[i]=spin
	      nms=newprev.nummult
	      newssa.toteners.append(addener-nsbias*(ns-nms))
	    else:
	      reusesdct[i]=num
	  else:
	    print
	    reusesdct[i]=num
	    if i==0:thr=thr0
	    else:
	      thr-=step
	      fpd=prev.flatpeakdct
	      ns=len(fpd)
	      if i-1 in newssydct:#there was a switch for prev residue
		##addener=prev.elink+sum(prev.etyps.values())+sum(prev.espins.values())*10.0
		addener=prev.elink/2+spin.elink/2+prev.etyps[0]+prev.etyps[-1]/2+spin.etyps[0]/2+sum(prev.espins.values())*1.0
	        if ns==0:addener+=1.0
		print 'addener',i,addener,(prev.elink,sum(prev.etyps.values()),sum(prev.espins.values())*1.0)
		newtot+=addener
	        ##reusesdct.pop(i-1)
	        numcomp+=prev.complete
		nms=prev.nummult
	        ##newssa.toteners.append(addener-nsbias*ns)
	        newssa.toteners.append(addener-nsbias*(ns-nms))
	      else:
		newtot+=(prevtot+nsbias*(prevns-prevnms))
	        numcomp+=prevcomp
	        newssa.toteners.append(prevtot)
	  if i>0:
	    ##newssa.fullpeakdct.update(fpd)
	    prev.assigned_type=i
	    prev.update_fulldct(newssa.fullpeakdct)
	  prev=spin
	  prevtot=current.toteners[i]
	  prevcomp=prev.complete
	  prevns=len(prev.flatpeakdct)
	  prevnms=prev.nummult
	fpd=prev.flatpeakdct
	ns=len(fpd)
	nms=prev.nummult
	addener=prev.elink+sum(prev.etyps.values())+sum(prev.espins.values())*1.0
	if ns==0:addener+=1.0
	numcomp+=prevcomp
	newtot+=addener
	newssa.toteners.append(addener-nsbias*(ns-nms))
	#the constant by ns is to bias selection toward large ssys
	#nms corrects for not including the same peak multiple times
	##newssa.fullpeakdct.update(fpd)
	prev.assigned_type=i
	prev.update_fulldct(newssa.fullpeakdct)
	newssa.nonlinked=newssa.shownonlinked(explst)
	##newssa.combscore=(newtot+1.0*newssa.nonlinked-numcomp)/len(self.toteners);newssa.energy=newssa.combscore
	newssa.combscore=(newtot+0.5*newssa.nonlinked-numcomp)/len(self.toteners);newssa.energy=newssa.combscore
	print 'combscore (recom)',newssa.combscore,len(newssa.toteners),newtot,0.5*newssa.nonlinked,numcomp
	return newssa.combscore,reusesdct,newssydct

    def grow_by_nonlinked(self,scheme):
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	cnt=0
	while True:
	  action,minent,numchoi=self.increment_by_nonlinked(scheme.explst,shdct,updateentrop=cnt==0)
	  if numchoi<5:break
	  if minent>2.0:break
	  cnt+=1
	ks=self.assigned_types.keys();ks.sort()
	for k in ks:
	  ssy=self.assigned_types[k]
	  ##print 'showing assigned spin system:',k
	  ssy.update_maintain()
	  ##ssy.show()

    def grow_by_single_peak(self,scheme):
	cnt=0;miss=None
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	while True:
	  action,minent,numchoi=self.increment_by_single_peak(shdct,scheme.explst,updateentrop=cnt==0)
	  if len(self.nonassigned)<5:break
	  if minent>3.0:break
	  miss=set(range(len(self.seq)-1))-set(self.assigned_types.keys())
	  print 'action (sp) is %9s %2d %7.4f %3d'%(action,len(miss),minent,numchoi)
	  ##if action=='none':break
	  cnt+=1
	print 'still to be assigned:',miss
	ks=self.assigned_types.keys();ks.sort()
	for k in ks:
	  ssy=self.assigned_types[k]
	  ##print 'showing assigned spin system:',k
	  ssy.update_maintain()
	  ##ssy.show()

    def grow_by_missing_atom_assignments(self,scheme,usenonassigned):
	cnt=0;miss=[]
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	pasdct=scheme.protein_assignments
	tpasdct=scheme.true_protein_assignments
	numchoi=100
	self.blacklist=[]
	while True:
	  action,minent,numchoi=self.increment_by_missing_atom_assignments(shdct,scheme.explst,pasdct,tpasdct,updateentrop=(cnt%150==0),usenonassigned=usenonassigned)
	  #NOTE: updation with cnt>0 will reintroduce noise possibilities unless blacklisted...
	  if minent>3.0:
		print 'terminating grow_by_missing_atom_assignment due to large minent:',minent
		break#CHECK break kriterie (ogsa for andre incerment/grow metoder)
	  print 'action (ma) is %9s %2d %7.4f %3d'%(action,len(miss),minent,numchoi)
	  cnt+=1
	  if numchoi<3:break

    def grow_extend(self,scheme): 
	pass

    def growmore(self,scheme,mode=1,maxnumchoices=100):
	cnt=0
	while True:
	   numchoices,action,flag,ener=self.incrementmore_patches(scheme.allneardct2,scheme.allneardct0,scheme.explst,updateentrop=cnt==0)
	   print 'growmore status patches:',numchoices,ener,cnt
	   if numchoices==0 or ener>3.0 or cnt>20:break
	   cnt+=1
	cnt=0
	while True:
	   numchoices,action,flag,ener=self.incrementmore_patch2peak(scheme.allneardct2,scheme.explst,updateentrop=cnt==0)
	   print 'growmore status pat2pe:',numchoices,ener,cnt
	   if numchoices==2 or ener>3.0 or cnt>150:break
	   cnt+=1
	print numchoices,ener
	return
	

    def grow(self,scheme,mode=1,maxnumchoices=100):
	cnt=0
	updent=True
	prevnum=None
	totnumact=0;numact=0;flags=[]
	prevcnt=0
	enerlst=[]
	tailener=None
	numbadlabs=0
	while True:
	   numchoices,action,flag,ener,minlab=self.increment(
		scheme.allneardct,scheme.allneardct0,scheme.explst,updateentrop=updent,mode=mode,cnt=cnt)
	   numact+=action;totnumact+=action;flags.append(flag)
	   if minlab=='na' and action:numbadlabs+=1
	   if numchoices<maxnumchoices or cnt>500:##1200:
		print 'exiting count'
		break
	   if prevnum==None:prevnum=numchoices
	   cnt+=1
	   ##if ener<>None:enerlst.append(ener)
	   if ener<>None and action:enerlst.append(ener)
	   updent=False
	   diffcnt=cnt-prevcnt
	   if len(enerlst)>=20:
	     if len(enerlst)==20:
		print 'calculating refstd',cnt,numchoices,numact,enerlst
		refstd=std(enerlst)
	     tailener=average(enerlst[-10:])/refstd
	     tailener_un=average(enerlst[-10:])
	     if ener<>None and action:
	        print 'tailener',tailener,tailener*refstd,refstd##,enerlst[-10:]
	     if tailener>90.0 or tailener_un>10.6:
		print 'exiting tailener',tailener,tailener*refstd,refstd
		break
	   nonlinked=self.shownonlinked(scheme.explst,show=False,usefull=False)
	   if nonlinked<2:
		print 'exiting nonlinked'
		break
	   if prevnum<>None and (1.0*numchoices/prevnum)<=0.95 and (1.0*diffcnt/numchoices)>0.04:
	     print 'ready for updating entropy',cnt,numchoices,numact,diffcnt,tailener,nonlinked
	     if (numact+1.0)/diffcnt<0.2:
		print 'exiting nonactive',(numact+1.0)/diffcnt
		break
	     print flags
	     updent=True
	     prevnum=numchoices
	     numact=0;flags=[]
	     prevcnt=cnt
	print 'growresult:',totnumact,numbadlabs,numchoices,nonlinked,cnt,tailener,tailener*refstd,refstd

    def recalculate_energy(self,scheme,explst):
	totscore,tottrue,sumtruefrac,totnumpeaks=self.ra0.recalculate_energy(scheme.seq,scheme.typedct,self,explst)
	self.fullpeakdct=self.ra0.fullpeakdct
	return totscore,tottrue,sumtruefrac,totnumpeaks

    def linkmore(self,allneardct,explst):
	T_0=time.time()
	for i,j,ax0 in allneardct:
	##for i in range(self.numexp):
	##  for j in range(i,self.numexp):
	##    if (i,j) in allneardct:
		nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[(i,j,ax0)]
		##print 'nearkeys',(i,j),nearest.keys()
		for k in nearest.keys():
		  if (i,k) in self.linked:
		    likj=self.linked[(i,k)][j]
		    ##print 'nearbefore',(i,j),k,nearest[k]
		    ##print 'compare',(i,j),k,likj,nearest[k]
		    vals=nearest[k]
		    for m in vals.keys():
			if m in likj:
			  nearest[k].pop(m)
			  ##print 'popping key:',(i,j,ax0),k,m
		    ##print 'numnearest',len(nearest[k])

    def iter_patches(self):
	for pnum,pt in enumerate(self.patches):
	  if isinstance(pt,PatchDict):
	    yield pnum,pt

    def showallpatches(self,explst,createssy=True):
	upeaks=[]
	ptdct={}
	totnumbad=0;allranks=[]
	totespin=0.0
	for pnum,pt in enumerate(self.patches):
	 if isinstance(pt,PatchDict):
	  pt.setlabel()
	  ptlab=pt.label
	  if not ptlab in ptdct:ptdct[ptlab]=[]
	  ptdct[ptlab].append(pnum)
	  upeaks+=pt
	lkeys=ptdct.keys();lkeys.sort()
	spindct={}
	keylst=[]
	prelinks={'l':{},'r':{}}
	self.convdct={}
	totall=0
	for lab in lkeys:
	  ptlst=ptdct[lab]
	  print '************** showing label %3s %2d'%(lab,len(ptlst)),ptlst
	  for pnum in ptlst:
	    pt=self.patches[pnum]
	    for direc in pt.hlinked:
		hlpnum=pt.hlinked[direc]
		if pnum in prelinks[direc] and prelinks[direc][pnum]<>hlpnum:
		  print 'WARNING inconsistent hlinking:',prelinks[direc][pnum],hlpnum
		prelinks[direc][pnum]=hlpnum
		odir={'l':'r','r':'l'}[direc]
		if hlpnum in prelinks[odir] and prelinks[odir][hlpnum]<>pnum:
		  print 'WARNING inconsistent hlinking:',prelinks[odir][hlpnum],pnum
		prelinks[odir][hlpnum]=pnum
	    ssy=pt.show(explst,pnum=pnum,createssy=createssy)
	    ssy.set_rank()
	    print 'rank is:',ssy.label,ssy.rank
	    espin=ssy.get_espinsystem();totespin+=espin
	    print 'espin was (updated later):',ssy.label,espin,espin/ssy.count,ssy.numbad,ssy.count,ssy.numbad*1.0/ssy.count,ssy.rank
	    ##ssy.get_flatpeakdct(explst,usenonspec=True)
	    ##ssy.get_peak_aligns(explst)
	    allranks.append(ssy.rank)
	    totnumbad+=ssy.numbad
	    totall+=ssy.count
	    spindct[len(keylst)]=ssy
	    keylst.append((lab,pnum))
	    self.convdct[pnum]=len(keylst)-1
	self.prelinks=prelinks
	##print 'total linked peaks:',len(set(upeaks))
	print 'total nonlinked peaks: %2d %3d %3d %6.3f %6.3f'%\
	 (len(self.nonlinkedlst),totnumbad,totall,totnumbad*1.0/totall,totespin)
	print 'averanks: %6.3f %2d'%(average(allranks),len(allranks))
	print 'total hlinked patches:',len(prelinks['l'])
	if createssy:
	  self.spindct=spindct
	  self.keylst=keylst
	score=len(self.nonlinkedlst)+1.00*totespin
	return spindct,keylst,score

    def update_all_spinsystems(self):
	for k in self.spindct:
	  ssy=self.spindct[k]
	  ssy.update_maintain()

    def merge_spinsystems(self,explst):
	cnt=0
	while True:
	   numchoices,action,flag,prob=self.increment_mergessys(explst,updateentrop=cnt==0)
	   print 'merge status ssys:',numchoices,prob,cnt
	   if numchoices==0 or (prob<0.1 and (cnt>5 or numchoices<5)) or cnt>99:break
	   cnt+=1
	totnumpeaks=sum([len(expk.peakData.peaklist) for expk in explst])
	return self.perform_mergins(totnumpeaks,explst)

    def oldishlinked(self,ssy0,ssy1,i,j):
	pt1=ssy1.patch
	if 'l' in pt1.hlinked:
	  pnum=pt1.hlinked['l']
	  k=self.convdct[pnum]
	  return j==k
	return False

    def ishlinked(self,ssy0,ssy1,i,j,explst,verb=False):
	pt1=ssy1.patch
	if verb:
	  print 'deriving ishlinked',i,j,
	  print pt1.hlinked,
	if 'l' in pt1.hlinked:
	  pnum=pt1.hlinked['l']
	  try:k=self.convdct[pnum]
	  except KeyError:return False
	  if verb: print pnum,k
	  if i==k:
	    print 'found hlinked pair',i,j,pnum,verb
	    ssy1.show()
	    ssy0.show()
	    pt1.show(explst,False,showssy=False)
	    ssy0.patch.show(explst,False,showssy=False)
	  return i==k
	elif verb:print 'nn','nn'
	return False

    def couldhlinked(self,ssy0,ssy1,i,j,explst,nallneardct,istrue,ishlinked):
	pt0=ssy0.patch
	pt1=ssy1.patch
	nearest=nallneardct[(1,2,'u')][0]
	if 1 in pt0 and 2 in pt1 and len(pt0[1])>0 and len(pt1[2])>0:
	 for k in pt0[1]:
	  if k in nearest:
	    vals=nearest[k]
	    for m in pt1[2]:
	      if m in vals:
		print 'couldbe hlinked',i,j,k,m,vals[m],istrue,ishlinked
		return True,vals[m][0]
		##sumener+=vals[m][0]
	 if istrue:
	    print 'false negative!',i,j
	    ##ssy1.show()
	    ##ssy0.show()
	    ##pt1.show(explst,False,showssy=False)
	    ##pt0.show(explst,False,showssy=False)
	return False,999

    def get_elinks(self,explst,nallneardct):
	keylst=self.keylst
	N=len(keylst)
	##lmat=ones((N,N))*8.0
	lmat=ones((N+1,N+1))*8.0
	self.prelinkedpairs=[]
	for i in range(N):
	  for j in range(N):
	    if i<>j:
		ssy0=self.spindct[i]
		ssy1=self.spindct[j]
		elink=ssy1.get_elink(ssy0,verb=False,expectX=True,probminspec=0.10,probminx=0.4)##,explst)
		ishlinked=self.ishlinked(ssy0,ssy1,i,j,explst,True)#TJEK!
		if ishlinked and elink<2.0:self.prelinkedpairs.append((i,j))
		chl,enerhl=self.couldhlinked(ssy0,ssy1,i,j,explst,nallneardct,True,ishlinked)
		##if ishlinked: elink-=1.0
		##if chl:elink-=3.0
		if chl:elink-=(3.0-2.0*enerhl)
		lmat[i,j]=elink
		#TODO:only if its the best elink??...
		##print 'final elink for %2d %2d %7.4f %1d'%(i,j,elink,istrue),keylst[i],keylst[j],ishlinked
	  lmat[i,N]=6.0#bad spin system
	for j in range(N+1):
	  lmat[N,j]=6.0#bad spin system
	summin=sum(amin(lmat,axis=1))
	summinr=sum(amin(transpose(lmat),axis=1))
	print 'summinlink:',summin,summinr
	##return lmat
        A=normSym(exp(-lmat))
	##return -log(A)
	##imshow(rot90(lmat),interpolation='nearest',cmap=cm.jet,vmax=8.0)
	##imshow(rot90(-log(1-A)),interpolation='nearest',cmap=cm.jet)##,vmax=10.0)
	##pylab.colorbar()
	##show()
	outdct={};ranks=[]
	for i in range(N):
	  outdct[i]={}
	  for j in range(N):
	    if i<>j:
	        elinkprob=A[i,j]
		lp=-log(elinkprob);rlp=-log(1-elinkprob)
		outdct[i][j]=lp
		if False:##istrue:
	          print 'normalized elink for %2d %2d %7.4f %1d %7.4f %7.4f'%\
		  (i,j,elinkprob,True,-log(elinkprob),-log(1-elinkprob)),
	          print keylst[i],keylst[j]
		##else:A[i,j]=0.0000001
	  vals=outdct[i].items()
	  vals.sort(lambda x,y: cmp(x[-1],y[-1]))
	return -log(transpose(A[:-1,:-1])),summin+summinr

    def get_etyps(self,dct,seq,explst):
	keylst=self.keylst
	N=len(keylst)
	M=len(seq)-1
	##tmat=ones((N,M))*8.0
	tmat=ones((N,M+1))*8.0
	forbidden=[]
	for i in range(N):
	  for j in range(M):
	   if j in forbidden:etyp=19.99
	   else:
          ##for j in range(1,len(self.pdb[ch])):
	     ssyi=self.spindct[i]
	     aajc=seq[j+1]
	     aajp=seq[j]
	     ##print 'calculating etyp',i,j,keylst[i],aajc,aajp,ssyi.label
	     ##etbb,etsc=ssyi.get_etyp(aajc,aajp,dct,verb=False)
	     etbb,etsc=ssyi.get_etyp(aajc,aajp,dct,verb=False,expectfull=False,\
		 probminspec=0.10,probminx=0.2,probminx2=0.2,probbadcount=0.3)
	     esimple=ssyi.get_etyp_simple(j,explst)
	     ##print esimple
	     etyp=etbb+etsc
	     ##tmat[i,j]=etyp
	   tmat[i,j+1]=etyp
	     ##print 'final etyp for %2d %2d %s %s %7.4f %1d %7.4f %7.4f %7.4f'%(i,j,aajc,aajp,etyp,istrue,etbb,etsc,esimple),keylst[i]
	  ##tmat[i,M]=6.0#bad spin system
	  tmat[i,0]=6.0#bad spin system
	##save_dba2(tmat,'tmat.pck')
	summin=sum(amin(tmat,axis=1))
	summinr=sum(amin(transpose(tmat),axis=1))
        T=array(-tmat)
        A=normSym(exp(-tmat))
	for i in range(N):
	  for j in forbidden:etyp=A[i,j+1]=0.0000001
	Q=-A*log(A)
	entrop=sum(sum(Q))/M
	print 'summintype:',summin,summinr,entrop
	##return -log(A)
	##imshow(rot90(lmat),interpolation='nearest',cmap=cm.jet,vmax=8.0)
	##imshow(rot90(-log(1-A)),interpolation='nearest',cmap=cm.jet)##,vmax=10.0)
	##subplot(121)
	##imshow(rot90(A),interpolation='nearest',cmap=cm.jet,vmin=0.0,vmax=1.0)##,vmax=10.0)
	##pylab.colorbar()
	##subplot(122)
	##imshow(rot90(T),interpolation='nearest',cmap=cm.jet,vmin=-6.0)
	##show()
	outdct={};ranks=[]
	for i in range(N):
	  outdct[i]={}
	  for j in range(M):
	     aajc=seq[j+1]
	     aajp=seq[j]
	     etypprob=A[i,j]
	     lp=-log(etypprob);rlp=-log(1-etypprob)
	     outdct[i][j]=lp
	  vals=outdct[i].items()
	  vals.sort(lambda x,y: cmp(x[-1],y[-1]))
	  bestj=vals[0][0]
	##return tmat
	return -log(A),summin+summinr
	##return -log(A[:,:-1])#everything but the last column)
	##return outdct

    def shownonlinked(self,explst,show=True,usefull=True):
	cnt=0
	##if show:testdct=self.fullpeakdct
	##else:testdct=self.linked
	self.nonlinkedlst=[]
	self.multiusedlst=[]
	if usefull:testdct=self.fullpeakdct
	else:testdct=self.linked
	for i,expi in enumerate(explst):
	  pklst=expi.peakData.peaklist
	  for k in range(len(pklst)):
	    ##if not (i,k) in self.linked:
	    ##if not (i,k) in self.fullpeakdct:
	    if not (i,k) in testdct:
	     if show:
	      peak=pklst[k]
	      peakasname='none'##getAsFormat(peak.names)
	      shs=peak.shifts
	      print 'not linked: %15s'%peakasname,
	      print ('%7.3f '*len(shs))%tuple(shs),
	      print '%6s %3d %3d'%(expi.name,i,k)##,peak.flag
	      ##print peak.hErrProb##,peak.probnoise,peak.score
	     if explst[-1].lweight and i in ALLMULT:cnt+=0.5
	     else:cnt+=1
	     self.nonlinkedlst.append((i,k))
	    elif usefull and len(testdct[(i,k)])>1:
	      peak=pklst[k]
	      shs=peak.shifts
	      peakasname='none'##getAsFormat(peak.names)
	      print 'multi-used: %15s'%peakasname,
	      print ('%7.3f '*len(shs))%tuple(shs),
	      print '%6s %3d %3d'%(expi.name,i,k),
	      print [dat[0] for dat in testdct[(i,k)]]
	      self.multiusedlst.append((i,k))
	print cnt,'nonlinked peaks'
	return cnt

    def showstate(self,flag):
	print flag,'<<< %7.4f'%self.energy

    def set_near_from_cons(self,consdct,refdct,refdct2,explst,maxcnt=86.0):
	self.allneardct=read_dba(self.path+'allneardct.pck')
	allneardct=self.allneardct
	dct={}
	for (i,j) in allneardct:
	  nearest,nearestrev,uniq,uniqrev,labels,plabels=allneardct[(i,j)]
	  poplst=[]
	  for k in nearest:
	    vals=nearest[k]
	    if not (i,k) in refdct:
	      print 'pair not in refdct (0)',(i,k)
	      ##poplst.append(k)
	    else:
	     for m in vals.keys():
	      hits=0
	      if not (j,m) in refdct:
	        print 'pair not in refdct (1)',(j,m)
		##vals.pop(m)
	      else:
	       #peak can be either "unique" => ispatched or ambigous => loop refdct
	       pnum0,pn0=self.ispatched((i,k))
	       pnum1,pn1=self.ispatched((j,m))
	       print 'testing allneardct',i,k,j,m,pnum0,pnum1
	       if pnum0<>None and pnum1<>None:
 		 #both in same patch or in different
		 print 'SNFC: removing from allneardct',i,k,j,m,pnum0,pnum1
		 vals.pop(m)
	       else:
		ener,cntval,lab0=vals[m]
		hits+=1
		if pn0<>None:
		    aty0=pn0.assigned_type
		    data=refdct[(j,m)]
		    if aty0 in data:
		      cnt0=data[aty0]
		      print 'SNFC: found plausible common typing (0)',i,k,j,m,pnum0,pnum1,aty0,cnt0,ener,lab0
		      addener=-log(cnt0/maxcnt)
		      ##vals[m]=((ener+addener,aty0),lab0)
		      vals[m]=({aty0:ener+addener},cntval,lab0)
		      #TODO: also store atom specific assignments via refdct2?
		    else:
		      print 'SNFC: aty0 not in data',i,k,j,m,pnum0,pnum1,aty0,ener,lab0
		      vals.pop(m)
		elif pn1<>None:
		    aty1=pn1.assigned_type
		    data=refdct[(i,k)]
		    if aty1 in data:
		      cnt1=data[aty1]
		      print 'SNFC: found plausible common typing (1)',i,k,j,m,pnum0,pnum1,aty1,cnt1,ener,lab0
		      addener=-log(cnt1/maxcnt)
		      ##vals[m]=((ener+addener,aty1),lab0)
		      vals[m]=({aty1:ener+addener},cntval,lab0)
		    else:
		      print 'SNFC: aty1 not in data',i,k,j,m,pnum0,pnum1,aty1,ener,lab0
		      vals.pop(m)
		else:
		  print 'SNFC: no patches for either peak',i,k,j,m
		  #both are ambigous
		  data0=refdct[(j,m)]
		  data1=refdct[(j,m)]
		  psum=0.0
		  maxprod=-1;maxelem=None
		  enerdct={}
		  for aty0 in data0:
		    cnt0=data0[aty0]
		    if aty0 in data1:
		      cnt1=data1[aty0]
		      prod01=cnt0*cnt1
		      addener=-log(prod01/maxcnt/maxcnt)
		      enerdct[aty0]=addener
		      psum+=(prod01/maxcnt/maxcnt)
		      if prod01>maxprod:
			maxprod=prod01
			maxelem=aty0
		  if psum<0.000000001:
		    print 'no common typing',i,k,j,m,psum
		    vals[m]=(49.99,cntval,lab0)
		  else:
		    addener=-log(psum)
		    print 'found common typing',i,k,j,m,addener,maxprod,lab0,maxelem
		    ##vals[m]=(ener+addener,lab0)
		    vals[m]=(enerdct,cntval,lab0)
	    if hits==0:poplst.append(k)
	  for k in poplst:nearest.pop(k)
	
    def set_clique_links(self,patch):
	for k0,lab in patch.iter_items():
	  for k1,lab1 in patch.iter_items():
	    if k0<>k1:
	      if not k0 in self.linked:self.linked[k0]=dict([(q,{}) for q in range(self.numexp)])
	      self.linked[k0][k1[0]][k1[1]]=lab

    def set_neighbor_spinsystems(self):
	ks=self.assigned_types.keys();ks.sort()
	for k in ks:
	  ssy=self.assigned_types[k]
	  ssy.neighbors={}
	  if k-1 in self.assigned_types:ssy.neighbors[-1]=self.assigned_types[k-1]
	  if k+1 in self.assigned_types:ssy.neighbors[1] =self.assigned_types[k+1]

    def transfer_all_neighbor_assignments(self,merge=False):
	ks=self.assigned_types.keys();ks.sort()
	for k in ks:
	  ssy=self.assigned_types[k]
	  ssy.transfer_neighbor_assignments(k,len(self.seq)-1,self.assigned_types,merge=merge)

    def set_state_from_cons(self,consdct,refdct,refdct2,explst):
	self.assigned_types={}
	ks=consdct.keys();ks.sort()
	spindct={}
	keylst=[]
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	print 'consdct.keys:',len(ks),ks
	for pnum,k in enumerate(ks):
	  print 'consvalues:',k,len(consdct[k]),consdct[k]
	  patch=PatchDict(numexp=len(explst))#empty init
	  patch.label=k
	  patch.assigned_type=k#OK?
	  for ref in consdct[k]:
	   if not k in refdct2[ref]:
	    print 'warning: key is missing (might popped):',k,ref,pnum
	   else:
	    atns=refdct2[ref][k]
	    ##patch.add(ref,lab=k)
	    patch.add(ref,lab=atns)
	    ##print 'refdct2',len(atns),ref,atns
	    self.has_patch[ref]=pnum
	  self.set_clique_links(patch)
	  self.patches.append(patch)
	  self.numpatches+=1
	  ssy=SpinSystem(patch,explst,mode=2)
	  comp=ssy.get_complete(shdct,(self.seq[k+1],self.seq[k]))
	  ssy.complete=comp
	  spindct[pnum]=ssy
	  keylst.append((k,pnum))
	  ##self.assigned_types[k]=pnum
	  self.assigned_types[k]=ssy
	self.spindct=spindct
	self.keylst=keylst
	self.set_neighbor_spinsystems()
	self.transfer_all_neighbor_assignments()
	##self.set_near_from_cons(consdct,refdct,refdct2,explst)


class Consensus(dict):

    def __init__(self,buf,seqlen,skeys,spindct,num=32):
	print 'deriving consensus from preveous generation using:',num
	dict.__init__(self)
	self.skeys=skeys
	self.spindct=spindct
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	self.num=num
	self.hastypdcts=[{} for _ in range(seqlen)]
	self.typdct={}
	self.linked={'l':{},'r':{}}
	deltas={'l':-1,'r':1}
	self.members=[]
        for n in range(num):
	  self.members.append(buf[n][0])
	  for i,code in enumerate(buf[n][0]):
	    if code=='|':j='|'+str(i)
	    elif code=='-':j='-'
	    else: j=prnstr.index(code)
	    if isinstance(j,int) or j=='-':
	      if not j in self.hastypdcts[i]:self.hastypdcts[i][j]=0
	      self.hastypdcts[i][j]+=1
	    if isinstance(j,int):
	      #----------------------------------
	      if not j in self.typdct:self.typdct[j]={}
	      if not i in self.typdct[j]:self.typdct[j][i]=0
	      self.typdct[j][i]+=1
	      #----------------------------------
	      for direc in 'lr':
		  oi=i+deltas[direc]
		  if 0<=oi<len(buf[n][0]):
		    ocode=buf[n][0][oi]
		    if not ocode in '|-':
		      oj=prnstr.index(ocode)
		      if not j in self.linked[direc]:self.linked[direc][j]={}
		      if not oj in self.linked[direc][j]:self.linked[direc][j][oj]=0
		      self.linked[direc][j][oj]+=1
		##      if direc=='r' and self.linked[direc][j][oj]>10:
		##	print 'link?:',j,oj,code+ocode,self.linked[direc][j][oj]
    	self.analyze()

    def analyze(self,verb=1):
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	if False:##for ic,cod in enumerate(prnstr):
	  ##if not ic in self.typdct:print 'warning: spin system not assigned',ic,cod,0,[]
	  if not ic in self.typdct:
	    print ic,cod,self.skeys[ic],0,[],
	  else:
	    print ic,cod,self.skeys[ic],sum(self.typdct[ic].values()),self.typdct[ic].keys(),
	  spin=self.spindct[self.skeys[ic]]
	  print spin.varclist,spin.hetdct['C13'].keys()
	st='';ce=''
	self.consp={}
	for i,dct in enumerate(self.hastypdcts):
	  itsi=dct.items()
	  if len(itsi)==0:
	    st+='|'
	    ce+='|'
	  else:
	    itsi.sort(lambda x,y: cmp(y[-1],x[-1]))#reverse
	    j=itsi[0][0]
	    if j=='-':code='-'
	    else:code=prnstr[j]
	    st+=code
	    if len(itsi)==1:
	      ce+='x'
	      if j<>'-':
	        self[i]=(j,0.0,itsi,'x')#conserved
	    else:
	      ps=array([it[1] for it in itsi])*1.0/self.num
	      es=-log(ps)
	      entrop=sum(ps*es)
	      x=int(exp(entrop)-1)
	      if x>9:ce+='*'
	      else:ce+=str(x)
	      self[i]=(j,entrop,itsi,ce[-1])
	for j in self.typdct:
	  dctj=self.typdct[j]
	  vals=[(dctj[k]*1.0/self.num,k) for k in dctj]
	  vals.sort()
	  vals.reverse()
	  self.consp[j]=vals
	if verb:
	  print st
	  print ce
	  for j in self.consp:
		best=self.consp[j][0]
		##print 'bestconsprob: %2d %6.3f %2d'%(j,best[0],best[1])

    def showassignments(self,spindct,seq,skeys):
	outfile=open('protein_psnmrstar.str','w')
	cnt=0
	for i in self:
	 j0,entropi,itsi,cex=self[i]
	 assigned=False
	 for j,count in itsi:
	  if isinstance(j,int):
	    assigned=True
	    prob=count*1.0/self.num
	    key=skeys[j]
	    spin=spindct[key]
	    lin='%1s %2d %2d %3s %6.3f '%(seq[i],i+1,j,key,entropi)
	    resn=aa13dict[seq[i]]
	    ##print dir(spin)
	    lin+='%6.3f %6.3f %6.3f'%spin.rootcoords
	    devs={'H':0.03,'N':0.1,'C':0.2}
	    rootnames=['HA','N','H']
	    for n,atname in enumerate(rootnames):
		elem=atname[0]
		val=spin.rootcoords[n]
		if atname=='N':val-=spin.aliased
		outfile.write('%4d %2d %3s %4s %1s %6.2f %4.2f %7.4f %1s\n'\
		            %(cnt,i+1,resn,atname,elem,val,devs[elem],prob,cex))
		cnt+=1
	    hdct=spin.hetdct
	    if not 'C13' in hdct:lin+=('   0.00'*3)
	    else:
	      for atpair in [('CA','0'),('CB','0'),('C','-1')]:
		atname=atpair[0];off=string.atoi(atpair[1])
		if atpair in hdct['C13']:
		    specres=aa13dict[seq[i+off]]
		    val=hdct['C13'][atpair]; lin+=' %6.2f'%val
		    outfile.write('%4d %2d %3s %4s C %6.2f 0.2  %7.4f %1s\n'%(cnt,i+1+off,specres,atname,val,prob,cex))
		    cnt+=1
		elif (atpair[0],'na') in hdct['C13']:
		    val=hdct['C13'][(atpair[0],'na')]; lin+=' %6.2f'%val
		    outfile.write('%4d %2d %3s %4s C %6.2f 0.2  %7.4f %1s\n'%(cnt,i+1    ,resn,   atname,val,prob,cex))
		    cnt+=1
		else:lin+=('   0.00')
	      for atpair in [('CA','-1'),('CB','-1')]:
		if atpair in hdct['C13']:lin+=' %6.2f'%hdct['C13'][atpair]
		elif (atpair[0],'na') in hdct['C13']:lin+=' %6.2f'%hdct['C13'][(atpair[0],'na')]
		else:lin+=('   0.00')
	    print lin
	  if not assigned:
	   if i+1 in self:
	    j0,entropi,itsi,cex=self[i+1]
	    for j,count in itsi:
	     if isinstance(j,int):
	      prob=count*1.0/self.num
	      resn=aa13dict[seq[i]]
	      spin=spindct[skeys[j]]
	      hdct=spin.hetdct
	      if 'C13' in hdct:
  	        for atpair in [('CA','-1'),('CB','-1')]:
		  atname=atpair[0]
		  val=None
  		  if atpair in hdct['C13']:
		    val=hdct['C13'][atpair]
  		  elif (atpair[0],'na') in hdct['C13']:
		    val=hdct['C13'][(atpair[0],'na')]
		  if val<>None:
		    outfile.write('%4d %2d %3s %4s C %6.2f 0.2  %7.4f %1s\n'%(cnt,i+1,resn,atname,val,prob,cex))
		    cnt+=1


class Population(list):

    def __init__(self,lst=[]):
	list.__init__(self,lst)

    def choosesubset(self,num):
	if num>=len(self):return self
        selec=BestSelector(len(self)/4.0)
	ra0=self[0]
	if isinstance(ra0,SpinSystemAssignment):
	  if len(self)==num:return self
	pop=Population()
	choicelist=zip(range(len(self)),range(len(self)))
	for i in range(num):
	  ##j=randchoice(choicelist)
	  maxi,bestprob,j,jcopy=selec.selectpartner(choicelist)
	  choicelist.pop(maxi)
	  if isinstance(ra0,SpinSystemAssignment):
	    member=self[maxi]#NOTE: not a deeeep copy!
	  else:
	    member=ResonanceAssignment(ra0.numgenes,ra0.numvalues,ra0.seq)
	    member.genestr=self[j].genestr
	    member.energy =self[j].energy#syntaxially needed only
	  pop.append(member)
	return pop

    def merge_with_new(self,pops):
	genes=[member.genestr for member in self]
	for pop in pops:
	  for mem in pop:
	    if not mem.genestr in genes:
		genes.append(mem.genestr)
		self.append(mem)
		print 'adding new member:',mem.energy,mem.genestr
	print 'unique members:',len(self)

    def setenerstats(self):
	self.enerstats={}
	ra0=self[0]
	true='|0123456789abcdefg|hijklmnopqrstuvwx||yzABCDEFGHIJKLMNOPQRSTUVWXYZ+?*@$!#%&<'
	for i in range(len(ra0.seq)):
	  eis=[]
	  for ra in self:
	    try:
	      eis.append(ra.edct[i])
	    except KeyError:pass
	  if len(eis)>0:
	    avei=average(eis)
	    stdi=std(eis)
	    print 'enerstat: %2d %s %6.3f %6.3f'%(i,true[i],avei,stdi)
	    self.enerstats[i]=(avei,stdi)


class RessasMinimumEntropy:

    def __init__(self,pckdata1,pckdata2,seq,cons=''):
	prnstr=string.printable[:62]+'+?*@$!#%&<>'+'^~;:()[]{}/_-.,"`'
	self.spindct,self.linkdct,self.skeys,self.rev,self.typedct,self.revtyp=pckdata1
	self.seq=seq
	self.penalize_bad([])
	self.setnearest()
	##self.tripenerdct=read_dba('hist3d1.pck')
	##self.rcdct=getrandomcoils()
	self.consensus=None
	self.prelinkedpairs=[]
	if False:
	  ra0=ResonanceAssignment(len(self.seq),len(self.spindct),self.seq)
	  ra0.genestr='|0123456789abcdefg|hijklmnopqrstuvwx||yzABCDEFGHIJKLMNOPQRSTUVWXYZ+?*@$!#%&<'
	  ra0.buildfromstr()
	  ra0.recalculate_score(self.linkdct,self.typedct,self.skeys)
	  ##ra0.gettripener(self.tripenerdct,self.rcdct,self.spindct,self.skeys,self.seq)
	  ##ra0.showassignments(self.spindct,self.seq,self.skeys,self.typedct,self.linkdct)
	  ##ra0.stripAllBad(self.linkdct,self.typedct)
	  ##ra0.recalculate_score(self.linkdct,self.typedct,self.skeys)
	  ##ra1=ra0.reproduce()
	  ##ra1.buildfromstr()
	  ##ra1.recalculate_score(self.linkdct,self.typedct,self.skeys)
	if cons<>'':
	  buf=initfil2(cons)
	  self.consensus=Consensus(buf,len(seq),self.skeys,self.spindct,num=len(buf))
	  self.addconsnearest()
	  return
	  for gst in self.consensus.members:
	    rac=ResonanceAssignment(len(self.seq),len(self.spindct),self.seq)
	    rac.genestr=gst
	    rac.buildfromstr()
	    rac.recalculate_score(self.linkdct,self.typedct,self.skeys)
	    ##rac.gettripener(self.tripenerdct,self.rcdct,self.spindct,self.skeys,self.seq)
	  self.consensus.showassignments(self.spindct,self.seq,self.skeys)
	  1/0
	##entrops,mats=pckdata2
	##entropf,entropr,typentropf,typentropr=entrops
	##matf,matr,typmatf,typmatr=mats
	##print min(self.typedct.keys())
	##print max(self.typedct.keys())
	##print min(self.revtyp.keys())
	##print max(self.revtyp.keys())

    def addconsnearest(self,thr=7.0):
	cons=self.consensus
	for i in self.linknearest.keys():
	  for j in self.linknearest[i].keys():
	    if j in cons.linked['l'][i]:
		tot=self.linknearest[i][j]-log((1.0+cons.linked['l'][i][j])/cons.num)
		if tot>thr:
		  print 'popping value (link)',i,j,tot
		  self.linknearest[i].pop(j)
		  self.linknearestrev[j].pop(i)
		else:self.linknearest[i][j]=tot
	for i in self.typenearest.keys():
	  for j in self.typenearest[i].keys():
	    if j in cons.typdct[i]:
		tot=self.typenearest[i][j]-log((1.0+cons.typdct[i][j])/cons.num)
		if tot>thr:
		  print 'popping value (type)',i,j,tot
		  self.typenearest[i].pop(j)
		  self.typenearestrev[j].pop(i)
		else:self.typenearest[i][j]=tot
		##else:print 'modifying type:',i,j,self.typenearest[i][j],tot

    def setnearest(self,lmaxval=6.0,tmaxval=6.0):
	ldct={}
	rdct={}
	tdct={}
	udct={}
	##for i in self.linkdct:
	print 'setting nearest'
	for i in range(len(self.linkdct)):
	  if not i in ldct:ldct[i]={}
	  for j in range(len(self.linkdct[i])):
	    if not j in rdct:rdct[j]={}
	    if self.linkdct[i][j]<lmaxval:
	      ldct[i][j]=self.linkdct[i][j]
	      rdct[j][i]=self.linkdct[i][j]
	##for i in ldct:print i,len(ldct[i])
	for i in range(len(self.typedct)):
	  if not i in tdct:tdct[i]={}
	  for j in range(len(self.typedct[i])):
	    if not j in udct:udct[j]={}
	    if self.typedct[i][j]<tmaxval:
	      tdct[i][j]=self.typedct[i][j]
	      udct[j][i]=self.typedct[i][j]
	for i in tdct:
	  print 'neartypes %2d %2d'%(i,len(tdct[i])), #some might be empty!
	  if len(tdct[i])>0:
	    its=tdct[i].items()[:];its.sort(lambda x,y: cmp(x[-1],y[-1]))
	    minit=its[0]
	    entrop=getentrop2(its)
	    minener=minit[1];minj=minit[0]
	    print '%2d %6.3f %7.4f'%(minj,minener,entrop)
	    print its
	  else:print 'nan none'
	self.linknearest=ldct
	self.typenearest=tdct
	self.linknearestrev=rdct
	self.typenearestrev=udct

    def penalize_bad(self,bad):
	for i in bad:
	  print 'penalizing bad',i
	  for k in self.typedct[i]:self.typedct[i][k]=19.999
	  for k in self.linkdct[i]:
		self.linkdct[i][k]=19.999
		self.linkdct[k][i]=19.999
	self.badlst=bad

    def transfer_nearest2ra(self,ra):
	  ra.linknearest   =dict([(k,dict(self.linknearest[k].items()))    for k in self.linknearest])
	  ra.typenearest   =dict([(k,dict(self.typenearest[k].items()))    for k in self.typenearest])
	  ra.linknearestrev=dict([(k,dict(self.linknearestrev[k].items())) for k in self.linknearestrev])
	  ra.typenearestrev=dict([(k,dict(self.typenearestrev[k].items())) for k in self.typenearestrev])

    def initialize(self,num):
	self.population=Population()
	for i in range(num):
	  ##self.setnearest()
	  ra=ResonanceAssignment(len(self.seq),len(self.spindct),self.seq)
	  if self.consensus<>None:
	    ra.cons=self.consensus
	    ra.fillFromConsensus(0.8)
	    ra.buildfromstr()
	    ##ra.cons=None
          self.transfer_nearest2ra(ra)
	  prelits =[('l',p[1],p[0]) for p in self.prelinkedpairs]
	  ##prelits+=[('r',p[1],p[0]) for p in self.prelinkedpairs]
	  print 'prelits are',len(prelits),prelits
	  ra.energy=0.0
	  ra.apply_prelits(self.linkdct,self.typedct,self.skeys,prelits)
	  ra.showstate('prehl')
	  ra.grow(self)##,mode='tourn')
	  self.population.append(ra)

    def recombine_replace(self,numcomb,junk=None):
	print 'recombining:',numcomb
	cnt=0
	scale=0.05
	while cnt<numcomb:
	  T_0=time.time()
	  i=randint(0,len(self.population)-1)
	  j=randint(0,len(self.population)-1)
	  if i<>j:
	    pari=self.population[i]
	    parj=self.population[j]
	    cc=pari.recombine(parj)
            self.transfer_nearest2ra(cc)
	    cc.recalculate_score(self.linkdct,self.typedct,self.skeys,xnear=True)
	    print 'recomb Time used:',time.time()-T_0
	    cc.grow(self,initcnt=60)##42)##60)
	    ei=pari.energy;ej=parj.energy;ec=cc.energy
	    if ei>ej:
	      emaxpar=ei;maxind=i
	    else:
	      emaxpar=ej;maxind=j
	    ptest=rand()
	    ebolz=(ec-emaxpar)/scale
	    if ebolz<ptest and abs(ebolz)>0.00001:
	    ##if ec<emaxpar:
	      print 'replacing parrent',ec,maxind,emaxpar
	      self.population[maxind]=cc
	    cnt+=1
	    print 'comb TIme used:',time.time()-T_0

    def evaluate(self,flag='evalu',bestnum=64,savefile=None,sortatr='energy'):
	pop=self.population
	pop.sort(key=operator.attrgetter(sortatr))
	for elem in pop:
	   elem.showstate(flag)
	for i in range(bestnum):
	 if len(pop)>i:
	   pop[i].showstate('bestmember'+str(i))
	   if savefile<>None:savefile.write(pop[i].genestr+'\n')

    def run(self,num=256,numcomb=None,split=1):
      super=[]
      for n in range(split):
	self.initialize(num)##/split)
	self.evaluate('initi')
	if numcomb<>None:##numcomb=(num-1+(num-1)**2)/2
	  self.recombine_replace(numcomb)##/split)
	  self.evaluate('compe')
	  super.append(self.population[0])#best individual
      if numcomb<>None:super.sort(key=operator.attrgetter('energy'))

    def getpopulation(self,name):
	buf=initfil2(name)
	pop=Population()
	super=[]
	for i in range(len(buf)):
	  ra=ResonanceAssignment(len(self.seq),len(self.spindct),self.seq)
	  ra.genestr=buf[i][0]
	  ra.energy=0.0##string.atof(buf[i][1])
	  ra.buildfromstr()
          self.transfer_nearest2ra(ra)
	  ra.recalculate_score(self.linkdct,self.typedct,self.skeys)
	  pop.append(ra)
	return pop

    def run_mutate(self,name=None,numrounds=20,numrem=5,scale=0.05):
	if name==None:pop=self.population
	else:
	  pop=self.getpopulation(name)
          pop.setenerstats()
	difflst=[]
	for i in range(len(pop)):
	  T_0=time.time()
	  ra=pop[i]
	  prev=ra.energy
	  for n in range(numrounds):
	    ra=pop[i]
	    ra1=ra.get_brother(self)
	    ra1.remove_grow(self,numrem=numrem)
	    ptest=rand()
	    ebolz=(ra1.energy-ra.energy)/scale
	    if ebolz<ptest and abs(ebolz)>0.00001:
		print 'lower energy (replacing)',i,n,ebolz,ra1.energy,ra.energy
		ra=ra1;pop[i]=ra1
		ra.recalculate_score(self.linkdct,self.typedct,self.skeys)
	  print 'remove time used:',time.time()-T_0
	  diff=prev-pop[i].energy
	  difflst.append(diff)
	  print 'mutresult:',i,pop[i].energy,diff
	print 'avemutresult:',average(difflst)
	self.evaluate('mutat')

    def getpopspread(self):
	alldists=[]
	m0=self.population[0]
	for mi in self.population[1:]:
	  dist=m0.eval_diff(mi)
	  alldists.append(dist)
	print 'diststats',average(alldists),std(alldists),m0.energy
	return std(alldists)

    def runrecomb(self,split,numruns,numcomb,name=None,savename=None):
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	super=Population();genestrs=[]
	if name==None:pop=self.population
	else:
	  pop=self.getpopulation(name)
	for j in range(numruns):
	  self.population=pop.choosesubset(split)
	  self.recombine_replace(numcomb,shdct)
	  self.evaluate('compe')
	  self.getpopspread()
	  gst=self.population[0].genestr
	  if not gst in genestrs:
	    genestrs.append(gst)
	    super.append(self.population[0])#best individual
	super.sort(key=operator.attrgetter('energy'))
	for i in range(len(super)):
	  super[i].showstate('supr'+str(i))
	self.population=super
	##self.recombine_replace(3,shdct,4)
	self.evaluate('super')
	##save_dba2(self,'scheme_super_'+ind+'.pck')
	##if savename<>None:save_dba2(self,savename)
	if savename<>None:save_dba2(genestrs,savename)
	return super

    def runConsensus(self,num=60,numcomb=500,split=15):
      super=[];genestrs=[]
      for n in range(split):
	self.population=Population()
	for i in range(num):
	  ra=ResonanceAssignment(len(self.seq),len(self.spindct),self.seq)
	  ra.cons=self.consensus
	  ra.fillFromConsensus(0.8)
	  ra.buildfromstr()
	  ra.grow(self)
	  self.population.append(ra)
	self.evaluate('conse')
	while len(self.population)>10:self.population.pop(-1)
	self.recombine_replace(numcomb)
	self.evaluate('compe')
	gst=self.population[0].genestr
	if not gst in genestrs:
	  genestrs.append(gst)
	  super.append(self.population[0])#best individual
      super.sort(key=operator.attrgetter('energy'))
      for i in range(len(super)):
	super[i].showstate('supr'+str(i))
      self.population=Population()
      for i in range(10):self.population.append(super[i])
      self.recombine_replace(numcomb)
      self.evaluate('FINAL')

    def showbestassignment(self):
	self.population[0].showassignments(self.spindct)

    def initialize_consensus(self,num=None):
	if num==None:num=len(self.population)
	pop=self.population[:num]
	buf=[[ra.genestr,ra.energy] for ra in pop]
	self.consensus=Consensus(buf,len(self.seq),self.skeys,self.spindct,num=len(buf))
	self.addconsnearest()
	while len(self.population)>0:self.population.pop(0)

    def run_strip(self,ssa):
	ra0=self.population[0]
	ra0.strip_peaks(self.seq,self.typedct,ssa)
	ssa.ra0=ra0


class SpinSystemAssembleMinimumEntropy(RessasMinimumEntropy):

    def __init__(self,pckdata,seq,path='./'):
	self.allneardct=pckdata
	self.seq=seq
	self.consensus=None
	##self.explst=read_dba(path+'newexplst_assigned2.pck')##[:4]
	##self.explst=read_dba('newexplst_assigned2.pck')##[:4]
	self.explst=read_dba(path+'newexplst.pck')##[:4]
	self.explst[-1].lweight=True
	self.assign_explst()
	self.path=path
        peak=self.explst[-1].peakData.peaklist[-2]

    def recombine_replace(self,numcomb,shdct,numparents=2):
	bestmember=None
	print 'recombining:',numcomb,numparents
	cnt=0
	wait=0
	bwait=0
	bestener=999
	while cnt<numcomb:
	  T_0=time.time()
	  chosen=Population()
	  choicelst=range(len(self.population))
	  eners=[];refnums=[]
	  while len(chosen)<numparents:
	    i=randchoice(choicelst)
	    choicelst.remove(i)
	    refnums.append(i)
	    ssai=self.population[i]
	    ssai.popnum=len(chosen)
	    chosen.append(ssai)
	    eners.append(ssai.energy)
	  ssa0=chosen[0]
	  newssa=SpinSystemAssignment(self.seq,self.explst)
	  childener,reusesdct,newssydct=ssa0.recombine(0,chosen,newssa,shdct,self.explst)
	  maxnum=argmax(eners)
	  maxpn=chosen[maxnum].popnum
	  maxind=refnums[maxnum]
	  maxener=self.population[maxind].energy
	  ##newssa.update_spinsystems(reusesdct,newssydct,chosen)
	  ##newssa.put_genestr()
	  ##newssa.pre_eval_assignments(self.explst,shdct,self,verb=False)
	  ##print 'resetting energy',childener,newssa.energy
	  ##childener=newssa.energy
	  ediff=-(childener-maxener);temp=0.02;ptest=rand()
	  if abs(ediff)>0.000001 and ediff>0.0 or exp(ediff/temp)>ptest:#using Boltzman temperature
	    #to something to preserve diversity?...
	    print 'replacing parrent',maxener,childener,maxind,maxnum,maxpn,maxener,max(eners)
	    self.population[maxind]=newssa
	    newssa.update_spinsystems(reusesdct,newssydct,chosen)
	    newssa.put_genestr()
	    ##newssa.pre_eval_assignments(self.explst,shdct,self,verb=False)
	    if childener<bestener:
	      bestener=childener
	      newssa.pre_eval_assignments(self.explst,shdct,self,verb=False,moldba=self.moldba)
	      print 'new best',childener,newssa.energy
	      bestmember=newssa
	      bwait=0
	    else:bwait+=1
	  else:
	    wait+=1
	    print 'keeping parrent',maxener,childener,maxind,maxnum,maxpn,maxener,max(eners)
	  cnt+=1
	  print 'comb TIme used:',time.time()-T_0
	  if wait>40:
	    print 'no replacement occured for #it =',wait,cnt
	    break
	  if bwait>70:
	    print 'no new best occured for #it =',bwait,cnt
	    break
	return bestmember
	  

    def analyze_toteners(self):
	print 'analyzing all totener'
	pop=self.population
	np=len(pop)
	nr=len(pop[0].toteners)
	for i in range(nr):
	  eners=[pop[j].toteners[i] for j in range(np)]
	  eners.sort()
	  ent=getentrop3(array(eners))
	  print 'analtot %2d %7.4f %6.3f %6.3f %6.3f'%(i,ent,eners[-1]-eners[0],eners[0],eners[-1])##,eners
	snl=set(pop[0].nonlinkedlst)
	pop[0].put_genestr()
	alldists=[]
	for j in range(1,np):
	  snl&=set(pop[j].nonlinkedlst)
	  pop[j].put_genestr()
	  dist0j=pop[j].eval_diff(pop[0])
	  alldists.append(dist0j)
	print 'allnonlinked:',len(snl),snl
	print 'diststats',average(alldists),std(alldists)

    def assign_explst(self):
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	c13dct={}
	specs=('CA','C')
	self.protein_assignments={}
	pasdct=self.protein_assignments
	self.true_protein_assignments={}
	tpasdct=self.true_protein_assignments
	for aa in aa31dict:
	  shi=shdct[aa]
	  xatns=[k for k in shi if k[0]=='C']## and (shi[k][0]<100 or shi[k][0]>160)]
	  #also including specs
	  c13dct[aa]=xatns
	  ##print 'xatns',aa,xatns
	for k in range(len(self.explst)):
	  expk=self.explst[k]
	  pklst=expk.peakData.peaklist
	  for m,peak in enumerate(pklst):
	    name='none'#getAsFormat(peak.names)
	    shs=peak.shifts
	    lst=[]
	    mat=[];asmat=[]
	    for j in range(len(self.seq)-1):
	      if not j in pasdct:pasdct[j]={}
	      aajc=self.seq[j+1]
	      aajp=self.seq[j]
	      edims=[];asnames=[]
	      if 'N' in expk.atnames and expk.order[expk.atnames.index('N')]==0 and aajc=='P':
		edims=[9.999 for _ in range(expk.dimension)]
		##print 'skipping PRO',j,expk.name
	      else:
	       for i in range(len(shs)):
		ordi=expk.order[i]
		atni=expk.atnames[i]
		if atni==None:atni='X'
		if ordi==None:ordi=expk.order[1]#TAKEBACK
		if ordi==None:ordi=expk.exporder[i]
		aai=aa13dict[self.seq[j+1+ordi]]
		shi=shdct[aai]
		if atni<>'X':
		 atnord=ordi,atni
		 if atni in shi:#OK?
		  vald,stdd=shi[atni]
		  edims.append(0.5*(((shs[i]-vald)/stdd)**2))
		  asnames.append(atni)
		  if not atnord in pasdct[j]:pasdct[j][atnord]={}
		  pasdct[j][atnord][(k,m)]=(edims[-1],i)
		  #TODO: also store atom name...
		else:
		  mindiff2,minat=min([(((shs[i]-shi[atn][0])**2),atn) for atn in c13dct[aai]])
		  #TODO include "volfac"?
		  edims.append(0.5*mindiff2/(shi[atn][1])**2)
		  asnames.append(minat)#could be "special" atom
		  for atn in c13dct[aai]:
		    atnord=ordi,atn
		    if not atnord in pasdct[j]:pasdct[j][atnord]={}
		    shdiff2=((shs[i]-shi[atn][0])/shi[atn][1])**2
		    if shdiff2<20.0:
			pasdct[j][atnord][(k,m)]=(0.5*shdiff2,i)
		  #TODO: actually sum of probs
		  #TODO: store best atoms (i.e. could be more than one)
	      ##print edims
	      tot=sum(edims)
	      lst.append(tot)
	      mat.append(edims)
	      asmat.append(asnames)
	    ##print dir(asd)
	    ##print len(asd.assigns)
	    minener=min(lst)
	    minj=argmin(lst)
	    ent,normps=getentrop3b(array(lst))
	    print '%1d %3d %16s %2d %6.3f %7.4f %2d'%(k,m,name,minj,minener,ent,len(lst))
	    peak.assignenerlst=lst
	    peak.assignenermat=mat
	    peak.assignamesmat=asmat
	    peak.entrop=ent
	    peak.normps=normps

    def initexplst(self):
	self.explst=[]
	for nam in self.expnames:
	   self.explst.append(initfil2(nam))

    def initialize(self,num):
	self.population=Population()
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	spindata=[]
	for i in range(num):##*4):
	  T_0=time.time()
	  self.allneardct =read_dba(self.path+'allneardct.pck')#TODO get a deeeeep copy
	  self.allneardct0=read_dba(self.path+'allneardct.pck')#original object which is not changed througout
	  self.nallneardct=read_dba(self.path+'nallneardct.pck')
	  ssa=SpinSystemAssignment(self.seq,self.explst)
	  ##ssa.modify_allneardct(self.allneardct,self.explst)
	  ssa.linkuniq(self.allneardct,self.explst, mode='v',elinkmax=1.0,allneardct0=self.allneardct0)
	  ssa.linkuniq(self.nallneardct,self.explst,mode='h')
	  ##ssa.showallpatches(self.explst)
	  ssa.linkmore(self.allneardct,self.explst)
	  ssa.grow(self)
	  print 'TIME grow:',time.time()-T_0;T_0=time.time()
	  self.allneardct2=read_dba(self.path+'allneardct.pck')#a fresh initialization to allow duplication
	  self.nallneardct2=read_dba(self.path+'nallneardct.pck')#a fresh initialization to allow duplication
	  #ssa.modify_allneardct(self.allneardct2,self.explst)
	  ##spindct,keylst=ssa.showallpatches(self.explst)
	  ssa.growmore(self)
	  print 'TIME gmore:',time.time()-T_0;T_0=time.time()
	  spindct,keylst,spinscore=ssa.showallpatches(self.explst)#also sets spindct,keylst as attributes for ssa
	  print 'TIME createssys:',time.time()-T_0;T_0=time.time()
	  ssa.update_all_spinsystems()
	  print 'TIME updatessys:',time.time()-T_0;T_0=time.time()
	  spinscore=ssa.merge_spinsystems(self.explst)
	  print 'TIME mergessys:',time.time()-T_0;T_0=time.time()
          ##ssa.strip_spinsystems(self.explst)
	  ##print 'TIME stripssys:',time.time()-T_0;T_0=time.time()
	  spindata.append((spinscore,ssa.spindct,ssa.keylst,ssa))
	##spindata.sort()
	for i in range(num):
	  T_00=time.time()
	  T_0=time.time()
	  spinscore,spindct,keylst,ssa=spindata[i]
          lmat,summinslink=ssa.get_elinks(self.explst,self.nallneardct2)
	  print 'TIME elink:',time.time()-T_0;T_0=time.time()
	  tmat,summinstyp=ssa.get_etyps(shdct,self.seq,self.explst)
	  print 'totsummins:',summinslink+summinstyp
	  print 'TIME etyp:',time.time()-T_0;T_0=time.time()
	  ##ssa.shownonlinked(self.explst)
	  revjunk=None
	  data1=spindct,lmat,keylst,revjunk,tmat,revjunk
	  scheme=RessasMinimumEntropy(data1,None,self.seq)
	  scheme.prelinkedpairs=ssa.prelinkedpairs
	  scheme.run(20)
       	  for _ in range(4):scheme.population.pop(-1)
       	  scheme.population.pop(-1)
	  print 'TIME resas:',time.time()-T_0;T_0=time.time()
	  if True:
       	   scheme.run_mutate()#possibly leave the "holes" open?...
	   print 'TIME mutate',time.time()-T_0;T_0=time.time()
	   ##scheme.initialize_consensus(20)
	   ##scheme.run(20)
       	   ##scheme.run_mutate()
	   ##scheme.runrecomb(8,1,700)
	   scheme.runrecomb(16,1,2000)
	   ##scheme.runrecomb(8,1,700)
       	   scheme.run_strip(ssa)
	   print 'TIME strip',time.time()-T_0;T_0=time.time()
	   totscore,totbadpeaks,sumtruefrac,totnumpeaks=ssa.recalculate_energy(scheme,self.explst)
	   ssa.totscore=totscore
	   ssa.nonlinked=ssa.shownonlinked(self.explst,usefull=False)
	   ##eners=(ssa.totscore/len(self.seq),ssa.nonlinked*0.5/len(self.seq),ssa.ra0.energy)
	   eners=(ssa.totscore/len(self.seq),ssa.nonlinked*0.25/len(self.seq),ssa.ra0.energy)
	   ##eners=(ssa.totscore/len(self.seq),ssa.nonlinked*2.0/len(self.seq),ssa.ra0.energy)
	   ssa.combscore=sum(array(eners[:2]))
	   ssa.energy=ssa.combscore
	   print 'final combscore: %7.4f'%ssa.combscore,
	   print '%7.4f %7.4f %7.3f'%tuple(eners),#tot,nonlinked,ra0.energy
	   print '%3d %6.3f %6.3f'%(totbadpeaks,sumtruefrac,totbadpeaks*1.0/totnumpeaks)
	   self.population.append(ssa)
	   print 'TIME total',time.time()-T_00

    def get_bytypedct(self,refdct,refdct2):
	dct={}
	for ref in refdct:
	  for aty in refdct[ref]:
	    if not aty in dct:dct[aty]={}
	    atndct=refdct2[ref][aty]
	    for axis in atndct:
	      for atnord in atndct[axis]:
		if not atnord in dct[aty]:dct[aty][atnord]=[0,{}]
		cnt=atndct[axis][atnord]
		dct[aty][atnord][1][ref]=(cnt,axis)
		dct[aty][atnord][0]+=cnt
	return dct

    def get_from_consensus_ssa(self,scomin=-0.2,maxusenum=64):
	num=0
	refdct={}
	refdct2={}
	T_0=time.time()
	typdata={}
	for ssa in self.population:
	  if ssa.combscore<scomin and num<maxusenum:
	    ##print 'adding ssa:',ssa.combscore
	    for key in ssa.spindct:
		spin=ssa.spindct[key]
		##print key,spin.__class__,spin
	    for spin,etot in ssa.ra0.iter_assigned_spinsystems(ssa):
	      print spin,etot
	      ##spin.show()
	      assityp=spin.patch.assigned_type
	      if not assityp in typdata:typdata[assityp]=[]
	      typdata[assityp].append(etot)
	ks=typdata.keys();ks.sort()
	typstats={}
	maxnum=0
	allaves=[]
	for assityp in ks:
	  etots=array(typdata[assityp])
	  emin,emax=min(etots),max(etots)
	  eave,estd,enum=average(etots),std(etots),len(etots)
	  print 'typstat: %2d %6.3f %6.3f %6.3f %7.4f %2d'%(assityp,emin,eave,emax,estd,enum)
	  if enum>maxnum:maxnum=enum
	  allaves.append(eave)
	  typstats[assityp]=eave,estd,enum
	aveave=average(allaves)
	stdave=std(allaves)
	for ssa in self.population:
	  ##print ssa.combscore
	  if ssa.combscore<scomin and num<maxusenum:
	    print 'adding ssa:',ssa.combscore
	    num+=1
	    for spin,etot in ssa.ra0.iter_assigned_spinsystems(ssa):
	     assityp=spin.patch.assigned_type
	     thisave,thisstd,thisnum=typstats[assityp]
	     thr=max(aveave-stdave,thisave)
	     if thisnum<maxnum*0.75 or etot<thr:
	     #this means that ssa is used in all cases except when large count of use where etot<thr is also required
	     #TODO: soft above
	      spin.update_maintain()#needed?
	      spin.get_flatpeakdct(self.explst)##,self.fullpeakdct
	      for ref in spin.flatpeakdct:
		peak,i,atndct=spin.flatpeakdct[ref]
		if not ref in refdct:
		  refdct[ref]={}
		  refdct2[ref]={}
		if not assityp in refdct[ref]:
		  refdct[ref][assityp]=0
		  refdct2[ref][assityp]={}
		for n in atndct:#n is the axis
		  atn=atndct[n]
		  #atn=(i,atname)#i is the order ( in [-1,0] )
		  if not n in refdct2[ref][assityp]:refdct2[ref][assityp][n]={}
		  if not atn in refdct2[ref][assityp][n]:refdct2[ref][assityp][n][atn]=0
		  refdct2[ref][assityp][n][atn]+=1
		refdct[ref][assityp]+=1#prob is this number/num
	print 'time stats:',time.time()-T_0;T_0=time.time()
	totmt=0;totot=0;fulltot=0;numassi=0;sumentrop=0.0;numunique=0
	consdct={}
	nonassigned={}
	neverused=[]
	floatnum=num*1.0
	for k in range(len(self.explst)):
	  expk=self.explst[k]
	  pklst=expk.peakData.peaklist
	  for m,peak in enumerate(pklst):
	      fulltot+=1
	      peakasname='none'##getAsFormat(peak.names)
	      print 'data: %15s'%peakasname,
	      shs=peak.shifts
	      print ('%7.3f '*len(shs))%tuple(shs),
	      print '%6s %3d %3d'%(expk.name,k,m),
	      if (k,m) in refdct:
		data=refdct[(k,m)]
		cnt=0;maxnum=0;maxelem=-1
		onceistrue=False
		for t in data:
		  cnt+=data[t]
		  thisistrue,n=spin.has_true_assign(peak,t)
		  onceistrue|=thisistrue
		  if data[t]>maxnum:
		    maxnum=data[t]
		    maxelem=t
		  data[t]/=floatnum
		##mostlyistrue,numas=spin.has_true_assign(peak,maxelem)
		nums=data.values()
		if cnt<num:nums.append((num-cnt)/floatnum)#noise count
		entrop=getentrop4(array(nums)*1.0)
		##unique=entrop<0.35 and cnt*1.0/num>0.7
		##unique=entrop<0.5 and cnt*1.0/num>0.6
		unique=entrop<0.2 and cnt*1.0/num>0.7
		##unique=entrop<0.001
		#TODO: more "soft" unique... stochastical criterium...
		##print (len(data),cnt*1.0/num,maxnum*1.0/num,entrop,maxelem,maxnum,mt,ot,unique)
		print '%2d %6.3f %6.3f %6.3f %2d %2d %1d'%\
		       (len(data),cnt*1.0/num,maxnum*1.0/num,entrop,maxelem,maxnum,unique),data
		numassi+=1
		numunique+=unique
		sumentrop+=entrop
		if cnt*1.0/num<0.5:entrop+=0.5
		if unique:
		  if not maxelem in consdct:consdct[maxelem]=[]
		  consdct[maxelem].append((k,m))
		else:
		  nonassigned[(k,m)]=entrop
	      else:
		##nonassigned.append((k,m))
		neverused.append((k,m))
		print '%2d %6.3f %6.3f %6.3f %2d %2d %1d'%(0,0.0,0.0,9.9,-1,0,9)
	print 'evalconsensus: %3d %3d %7.4f'%\
		(fulltot-numassi,numassi-numunique,sumentrop/numassi)
	print 'time uniq:',time.time()-T_0;T_0=time.time()
	bytypedct=self.get_bytypedct(refdct,refdct2)
	print 'time near:',time.time()-T_0;T_0=time.time()
	return consdct,refdct,refdct2,nonassigned,neverused,num,bytypedct
        #end-def get_from_consensus_ssa(self):

    def init_from_consvars(self,consvars):
	consdct,refdct,refdct2,nonassigned,neverused,num,bytypedct=consvars
	for ref in refdct2.keys():
	  for assityp in refdct2[ref].keys():
	    atndct=refdct2[ref][assityp]
	    dim=self.explst[ref[0]].dimension
	    ##print 'anallen:',ref,assityp,len(atndct),dim,atndct.keys(),atndct
	    if len(atndct)<dim:
		#one or more axis values are missing
		#because atas was not deleted "deep" from spin system
		#one axis => 'X' assignment
		print 'missing axis, popping assityp',ref,assityp
		refdct2[ref].pop(assityp)
		refdct[ref].pop(assityp)#OK?
		#whatif refdct[ref] or refdct2[ref] becomes empty
	ssac=SpinSystemAssignment(self.seq,self.explst)
	ssac.set_state_from_cons(consdct,refdct,refdct2,self.explst)#set_near... is skipped
	ssac.refdct=refdct
	ssac.refdct2=refdct2
	ssac.nonassigned={}
	ssac.nonassigned.update(nonassigned)
	ssac.neverused=neverused[:]
	ssac.assignedpeaks=[]
	ssac.noisepeaks=[]
	ssac.totnum=num
	ssac.bytypedct=bytypedct
	return ssac

    def run_consensus(self,consvars=None,ind=None,numruns=200,usenonassigned=False,grownonlinked=False):
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	T_0=time.time()
	##ssa1=SpinSystemAssignment(self.seq,self.explst)
	##ssa1.fill_from_true(self.explst,shdct)
        ##ssa1.pre_eval_assignments(self.explst,shdct,self);1/0
	if consvars==None:
	  consvars=self.get_from_consensus_ssa(scomin=999.0)#VERY important param!
	print 'TIME cons:',time.time()-T_0;T_0=time.time()
	if ind<>None:save_dba2(consvars,'consvars'+ind+'.pck')
	self.population=Population()
	if grownonlinked:self.explst[-1].lweight=False
	for i in range(numruns):
	  ssa0=self.init_from_consvars(consvars)
	  print 'TIME init:',time.time()-T_0;T_0=time.time()
	  ##self.allneardct=ssa0.allneardct
	  ##self.allneardct=read_dba('allneardct.pck')
	  ssa0.grow_by_single_peak(self)
	  print 'TIME grow (sp):',time.time()-T_0;T_0=time.time()
	  ssa0.grow_by_missing_atom_assignments(self,usenonassigned)
	  print 'TIME grow (ma):',time.time()-T_0;T_0=time.time()
	  if grownonlinked:
	    for ssy in ssa0.assigned_types.values():
	      ssy.update_maintain()
	      ssy.get_flatpeakdct(self.explst,ssa0.fullpeakdct)
	    ssa0.shownonlinked(self.explst,show=False)
	    ssa0.grow_by_nonlinked(self)
	    print 'TIME grow (nl):',time.time()-T_0;T_0=time.time()
          ssa0.pre_eval_assignments(self.explst,shdct,self,moldba=self.moldba)
	  print 'TIME eval:',time.time()-T_0;T_0=time.time()
	  ##ssa0.grow(self,maxnumchoices=30,mode=3)
	  ##ssa0.totscore=ssa0.recalculate_energy(self,self.explst)
	  ##ssa0.nonlinked=ssa0.shownonlinked(self.explst)
	  ##ssa0.showallpatches(self.explst,createssy=False)
	  ssa0.ra0=DummyRA()
	  self.population.append(ssa0)
	self.analyze_toteners()

def main(ind,numruns=128):
	seq=initfil('sequence.txt')[0][:-1]
	path='./'
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	pckdata=read_dba(path+'allneardct.pck')
	scheme=SpinSystemAssembleMinimumEntropy(pckdata,seq,path=path)
	##scheme.tripenerdct=read_dba('hist3d2.pck')
	##scheme.rcdct=getrandomcoils()
	scheme.explst[-1].lweight=False
	##ssa1=SpinSystemAssignment(seq,scheme.explst)
	##ssa1.fill_from_true(scheme.explst,shdct)
	scheme.run(numruns)
	return scheme
	##scheme.run_consensus()
	##save_dba2(scheme,'scheme_wdata128_'+ind+'.pck')

def combineall(ind='',merge=False):
	##path=''
	path=''##modDkl/'
	seq=initfil('sequence.txt')[0][:-1]
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	pckdata=read_dba(path+'allneardct.pck')
	scheme=SpinSystemAssembleMinimumEntropy(pckdata,seq,path=path)
	##scheme.tripenerdct=read_dba('hist3d2.pck')
	##scheme.rcdct=getrandomcoils()
	scheme.population=Population()
	scheme.explst[-1].lweight=False
	pops=[]
	allgenes=set([])
	##parser=Parser(initfil2('bmr7111.str'))
	##parser=Parser(initfil2('ubiq550.str'))
	##scheme.moldba=parser.findShiftData('A',verb=True)
	##scheme.moldba=getShiftDBAsparky(initfil2('ubiq260613.list'))
	scheme.moldba=None##getShiftDBAsparky(initfil2('GB1assignments.list'))
	##genestrs=read_dba('best_super40_all.pck')
	for i in range(8):
	   ##schi=read_dba('scheme_super_'+str(i)+'.pck')
	   try:
	     ##genestrs=read_dba('schemes/scheme_super40_'+str(i)+'.pck')
	     genestrs=read_dba('best_super'+str(i)+'.pck')
	     allgenes|=set(genestrs)
	   except IOError:print 'warning, file not found',i
	   if False:
	     gene=genestrs[4]
	     ssa=SpinSystemAssignment(seq,scheme.explst)
	     ssa.genestr=gene
             ssa.build_from_genestr(scheme.explst)
	     ssa.nonlinked=ssa.shownonlinked(scheme.explst,show=True)
	     ssa.nonassigned=[];ssa.noisepeaks=[];ssa.neverused=[]
             ##ssa.pre_eval_assignments(scheme.explst,shdct,scheme,moldba=scheme.moldba)
	     ssa.grow_by_nonlinked(scheme)
             ssa.pre_eval_assignments(scheme.explst,shdct,scheme,moldba=scheme.moldba)
	     1/0
	##allgenes|=set(genestrs)
	print 'number of unique genes:',len(allgenes)
	#now initialize from genes...
	if len(allgenes)==0:1/0
	for gene in allgenes:
	   ssa=SpinSystemAssignment(seq,scheme.explst)
	   ssa.genestr=gene
           ssa.build_from_genestr(scheme.explst)
	   ssa.nonlinked=ssa.shownonlinked(scheme.explst,show=True)
	   ssa.nonassigned=[];ssa.noisepeaks=[];ssa.neverused=[]
           ssa.pre_eval_assignments(scheme.explst,shdct,scheme,moldba=scheme.moldba)
	   ##ssa.grow_by_nonlinked(scheme)
           ##ssa.pre_eval_assignments(scheme.explst,shdct,scheme,moldba=scheme.moldba)
	   scheme.population.append(ssa)
	if merge:
	 os.system('mkdir allspins')
	 ssac=SpinSystemAssignment(seq,scheme.explst)
	 for i in range(len(scheme.population)):
	   ssai=scheme.population[i]
	   ssac.genestr=ssai.genestr
           ssac.build_from_genestr(scheme.explst,merge=True)
	 ssac.nonlinked=ssac.shownonlinked(scheme.explst,show=True)
	 ssac.nonassigned=[];ssac.noisepeaks=[];ssac.neverused=[]
         ssac.pre_eval_assignments(scheme.explst,shdct,scheme,moldba=scheme.moldba,savespins=True)##,cmpall=True)
	 ##raise SystemExit
	 return
	##scheme.population.merge_with_new(pops)
	scheme.evaluate('merged',bestnum=128)
	scheme.getpopspread()
	##scheme.runrecomb(20,10,1000)
	scheme.runrecomb(20,20,1000,savename='best_super'+ind+'.pck')

def testconsensus(ind,scheme=None):
	path=''
	seq=initfil('sequence.txt')[0][:-1]
	if scheme==None:
	  ##scheme=read_dba('scheme_wdata128_'+ind+'.pck')
	  pckdata=read_dba(path+'allneardct.pck')
	  scheme=SpinSystemAssembleMinimumEntropy(pckdata,seq,path=path)
	##scheme.tripenerdct=read_dba('hist3d2.pck')
	scheme.ind=ind
	##scheme.rcdct=getrandomcoils()
	##parser=Parser(initfil2('bmr7111.str'))
	##parser=Parser(initfil2('ubiq550.str'))
	##scheme.moldba=parser.findShiftData('A',verb=True)
	##scheme.moldba=getShiftDBAsparky(initfil2('ubiq260613.list'))
	##scheme.moldba=getShiftDBAsparky(initfil2('GB1assignments.list'))
	scheme.moldba=None
	scheme.run_consensus(numruns=400,ind=ind)
	##scheme.run_consensus(numruns=400,ind=ind,consvars=read_dba('consvars'+ind+'.pck'))
	##scheme.evaluate()#delete after
	scheme.run_consensus(numruns=400)
	scheme.run_consensus(numruns=400,grownonlinked=True,usenonassigned=False)##True)
	scheme.run_consensus(numruns=800,grownonlinked=True,usenonassigned=False)##True)
	scheme.evaluate()
	while len(scheme.population)>200:scheme.population.pop(-1)
	scheme.runrecomb(20,20,1000,savename='scheme_super_'+ind+'.pck')
	scheme.runrecomb(10,10,500,savename='scheme_super_'+ind+'.pck')
        shdct=createShiftDBA('csTable.txt',useelems='CN')
	best=scheme.population[0]
	best.nonlinked=best.shownonlinked(scheme.explst,show=True)
	best.nonassigned=[];best.noisepeaks=[];best.neverused=[]
        best.pre_eval_assignments(scheme.explst,shdct,scheme,moldba=scheme.moldba)

##dct=read_dba('allneardct.pck')
##for key in dct.keys():
##  i,j,ax0=key
##  if i>3 or j>3:del dct[key]
##save_dba2(dct,'allneardct_nodarr.pck')

def get_qualities():
  ##seq='MQYKLILNGKTLKGETTTEAVDAATAEKVFKQYANDNGVDGEWTYDDATKTFTVTE' #GB1
  seq=initfil('sequence.txt')[0][:-1]
  ##moldba=getShiftDBAsparky(initfil2('GB1assignments.list'))
  moldba={}##getShiftDBAsparky(initfil2('GB1assignments_wArom.list'))
  explst=read_dba('newexplst.pck')
  totbbfar=0;totbbbad=0;totscfar=0;totscbad=0
  cnt=1
  outfile=open('bmr.str','w')
  for i in range(len(seq)-1):
      ##spin=read_dba('spin42_%d.pck'%i)
      spin=read_dba('allspins/spin%d.pck'%i)
      spin.show()
      ##spin.evaltrues=spin.eval_true_peaks(explst)
      if str(i+2) in moldba: resshifts=moldba[str(i+2)]
      else:resshifts=None
      bbfar,bbbad,scfar,scbad,cnt=spin.get_quality(i+2,resshifts,seq[i+1],seq,cnt,outfile)
      totbbfar+=bbfar;totbbbad+=bbbad;totscfar+=scfar;totscbad+=scbad
  print 'final result:',totbbfar,totbbbad,totscfar,totscbad


if len(sys.argv)<2:ind=-1
else:ind=sys.argv[1]
if ind=='all':
  ind2=sys.argv[2]
  if ind2=='comb':
    combineall(merge=True) 
    get_qualities()
  else:
    combineall(ind2)
else:
  scheme=main(ind,numruns=400)
  testconsensus(ind,scheme=scheme)
  get_qualities()
  ##testconsensus(ind,scheme=None)
##else: testconsensus(ind,scheme=scheme)

